=== modified file 'CHANGES'
--- CHANGES	2008-03-27 20:08:06 +0000
+++ CHANGES	2008-11-19 20:58:59 +0000
@@ -1,3 +1,56 @@
+0.52 - Wed 12 November 2008
+
+- Add "netcat-alike" option (-B) to dbclient, allowing Dropbear to tunnel
+  standard input/output to a TCP port-forwarded remote host.
+
+- Add "proxy command" support to dbclient, to allow using a spawned process for
+  IO rather than a direct TCP connection. eg
+	  dbclient remotehost
+  is equivalent to
+	  dbclient -J 'nc remotehost 22' remotehost
+  (the hostname is still provided purely for looking up saved host keys)
+
+- Combine netcat-alike and proxy support to allow "multihop" connections, with
+  comma-separated host syntax.  Allows running
+
+	  dbclient user1@host1,user2@host2,user3@host3
+
+  to end up at host3 via the other two, using SSH TCP forwarding. It's a bit
+  like onion-routing. All connections are established from the local machine.
+  The comma-separated syntax can also be used for scp/rsync, eg
+
+	  rsync -a -e dbclient m@gateway,m2@host,martello:/home/matt/ ~/backup/
+
+  to bounce through a few hosts.
+
+- Add -I "idle timeout" option (contributed by Farrell Aultman)
+
+- Allow restrictions on authorized_keys logins such as restricting commands
+  to be run etc. This is a subset of those allowed by OpenSSH, doesn't
+  yet allow restricting source host.
+
+- Use vfork() for scp on uClinux
+
+- Default to PATH=/usr/bin:/bin for shells.
+
+- Report errors if -R forwarding fails
+
+- Add counter mode cipher support, which avoids some security problems with the
+  standard CBC mode.
+
+- Support zlib@openssh.com delayed compression for client/server. It can be
+  required for the Dropbear server with the '-Z' option. This is useful for
+  security as it avoids exposing the server to attacks on zlib by
+  unauthenticated remote users, though requires client side support.
+
+- options.h has been split into options.h (user-changable) and sysoptions.h
+  (less commonly changed)
+
+- Support "dbclient -s sftp" to specify a subsystem
+
+- Fix a bug in replies to channel requests that could be triggered by recent
+  versions of PuTTY
+
 0.51 - Thu 27 March 2008
 
 - Make a copy of password fields rather erroneously relying on getwpnam()

=== modified file 'LICENSE'
--- LICENSE	2008-03-27 20:08:06 +0000
+++ LICENSE	2008-11-19 20:58:59 +0000
@@ -8,7 +8,7 @@
 Portions of the client-mode work are (c) 2004 Mihnea Stoenescu, under the
 same license:
 
-Copyright (c) 2002-2006 Matt Johnston
+Copyright (c) 2002-2008 Matt Johnston
 Portions copyright (c) 2004 Mihnea Stoenescu
 All rights reserved.
 

=== modified file 'Makefile.in'
--- Makefile.in	2008-03-27 20:08:06 +0000
+++ Makefile.in	2008-11-19 20:58:59 +0000
@@ -23,7 +23,7 @@
 		atomicio.o compat.o  fake-rfc2553.o
 
 SVROBJS=svr-kex.o svr-algo.o svr-auth.o sshpty.o \
-		svr-authpasswd.o svr-authpubkey.o svr-session.o svr-service.o \
+		svr-authpasswd.o svr-authpubkey.o svr-authpubkeyoptions.o svr-session.o svr-service.o \
 		svr-chansession.o svr-runopts.o svr-agentfwd.o svr-main.o svr-x11fwd.o\
 		svr-tcpfwd.o svr-authpam.o
 

=== modified file '_MTN/inodeprints'
--- _MTN/inodeprints	2008-03-27 20:08:06 +0000
+++ _MTN/inodeprints	2008-11-19 20:58:59 +0000
@@ -1,2119 +1,2122 @@
 format_version "1"
 
- file "CHANGES"
-print [a0b205d94a4a39caa8da21e289f6b9530ea54132]
-
  file "INSTALL"
-print [b3279b0a7ebe865acc32460949c9bbbc21463798]
+print [266005e6ba19f0460a520856762c715cc81b1234]
 
  file "LICENSE"
-print [bc6aa2ffff53feb4f3890851de5af73a6b80af9a]
+print [19aa49ce1de5f658020439223bae9dd64124427f]
 
  file "MULTI"
-print [61f07529e06c193f9c1c8d1be5aca11cc93dba56]
+print [44670cf30a72a7f0a8cad88a6bbc8c7f8bcc4701]
 
  file "Makefile.in"
-print [42c2da0f8fddcc790103101c583da982bad95cd5]
+print [56874a669e99076b9bc6885280610b1f44214b4a]
 
  file "README"
-print [71c1aa40ef71ebebd36a5c0ea59f6ba0d07c9bd6]
+print [e9359c6531913ce1b903e1cc1e86e743d32c87d3]
 
  file "SMALL"
-print [1c6fbc429cb7a93faa0b9937862f1315ca44bdae]
+print [230d1c3dbf66b94c942f5576c4b34940f4d925c3]
 
  file "TODO"
-print [86a3885f9aa0f0cbfc0157e503f3199a0f49d6ef]
+print [4ef5e1fbf983df32cc00b1c151410f8abbb3e4f7]
 
  file "agentfwd.h"
-print [80fe7ae54025805124f89b3c933ac4fea6b1a3a5]
+print [31f614ce03a358512d9008b3222b3ce8b2db8470]
 
  file "algo.h"
-print [eea67046d4f9fed207aa976207174c12ba95141e]
+print [d6ca781ae899a78916260d0001dab24b95978269]
 
  file "atomicio.c"
-print [02036751c62fe6b2ceafd8d7c263234449fe87a0]
+print [e17ae64115d9d39f800c580277e3880891af31e6]
 
  file "atomicio.h"
-print [fbfb5b37d03007019dec01da3442a1d66c23bb73]
+print [05895ff95b76ce27c400d50ed816e8438e3c3bf4]
 
  file "auth.h"
-print [89a4bd8ce0390daa4a9f8080c8291dda553d1df8]
+print [1ef86bbf0a13dff6982d77a46553b3228ec7f6dc]
 
  file "bignum.c"
-print [57e6dfed0a7233d94645c9b202e3a1cc7be2c918]
+print [2710c76c16d0378a1a5a30ddc600ce0d3eb32936]
 
  file "bignum.h"
-print [f15858ca2d776928f69be21d75d4dd5bbe4e0685]
+print [8747624915748843dbaac986caa7578499a5f121]
 
  file "buffer.c"
-print [affd645c951149f5727e5e52d026222ce7362efa]
+print [3e7685af74bad6735726b5d675ebed402cd3ac66]
 
  file "buffer.h"
-print [4fda3067ccdf1832e3850aac4c63fa615d797e45]
+print [dfa13e84221163f91c28aead540fb2c25c96ef3f]
 
  file "channel.h"
-print [247242ace28d6253ce0101837f67b85a1a431726]
+print [d1a9305b00f163dcddb4cdc29c5137e6a4eb1cea]
 
  file "chansession.h"
-print [d2b4ba6beb130c0541a35a451a9a8043a5d57c60]
+print [b8766a14cd7c52c95ac5e502e1e7484bbd71696b]
 
  file "circbuffer.c"
-print [30e8caa261e294be10b8fbc0a8878745e040b756]
+print [d41d0dfc8e42c62d719d5a12a70dad585aca39e0]
 
  file "circbuffer.h"
-print [33a69a7911ad881d2c23b8be25f7c07cd4f5e92b]
+print [9fc048ac604686966a64abef174b6dc7dab68c97]
 
  file "cli-algo.c"
-print [16b9b7d0a6dceae018785011654ea96347b5d988]
+print [9ff0305934f2e1c8c015cabf92cdcbedda50fec4]
 
  file "cli-auth.c"
-print [dfa1450dc6107ff06b1480aae06cb46a168c7b61]
+print [57723379741dba50a96b2a01eb66f89d1ee74b05]
 
  file "cli-authinteract.c"
-print [273e2d1c76f94b9864f5b490eb1321370afeedb2]
+print [4027ca9039d590a1464cc2b7ed74c2cdadef0611]
 
  file "cli-authpasswd.c"
-print [04625d0c834703125a38bbaf390620d514b95ed4]
+print [b39c38c5d7f7d9bdd83da2fbb7d5f910fa36c0ce]
 
  file "cli-authpubkey.c"
-print [4ebc53fc662080e95717b4de416be5ca64f435f6]
+print [0936ea7d2beefb9dd72e8a107157e85ccbe2a955]
 
  file "cli-channel.c"
-print [01084e3e6ee9e3cebc332acea4542baed8df79cc]
+print [ada523f5aa1fa918884eed0a5718fa819bdd5932]
 
  file "cli-chansession.c"
-print [6e53b934fc2e7ae48b6289226b71f415b201980a]
+print [b5ba9a6b6353d4ff5dbbdde62923abd5a756525a]
 
  file "cli-kex.c"
-print [e508ba34c6780930c1a6307c7b1fc78425e95eb5]
+print [4b84129a719e0a0d5897aeba94d71b8c97902781]
 
  file "cli-main.c"
-print [3a337096d42a25128e2ab37eff702a5fd219891e]
+print [b8ada37ae4b586fed35ac9a68a50494cb1b4e0c8]
 
  file "cli-runopts.c"
-print [02791583223676fd9c216d86ccd9386647ebf963]
+print [82c5403fac3922bc19aee993bf87a449ad0f4808]
 
  file "cli-service.c"
-print [4406def66899593ac03f4b87943cc257ede24415]
+print [8c200ff390436eb3a7781017532205e62b8657ac]
 
  file "cli-session.c"
-print [1e4a3f472e1b5f6d08c2539588fc1d4a585b853f]
+print [2c7281d5d6b26f27574e66992acd998ebe0e0e87]
 
  file "cli-tcpfwd.c"
-print [2cb72e5837c80a54c2856620da70eebf1be6dfad]
+print [60a04c58a1bb19bec17b3e6d5d356b187dfa1bb1]
 
  file "common-algo.c"
-print [771375dd5933bc832284a399425329dee27dc2a3]
+print [6840a1d9d489d567a84453cef99d2ec84ff4c815]
 
  file "common-channel.c"
-print [fd796a3332d294730a974af67d40791d2d7ca36f]
+print [b29bd2e359947d6a709d41b5a9be2b3aa04cfc49]
 
  file "common-chansession.c"
-print [ebc26595b850a4a0023dfdb0e79a5033b5d16651]
+print [7e43e48767cf003bbc2ecb8d6091a1f757535e57]
 
  file "common-kex.c"
-print [d59e84165d9b8eb92bb2837870816e117c20756f]
+print [6f1742351e016f51110e60bfc3e60d1d9b3f3e1d]
 
  file "common-runopts.c"
-print [630e767935303db496ff88199efadddf6ff30393]
+print [52190a9619d7da8ca6f492d7381314604a12269f]
 
  file "common-session.c"
-print [e4553b0a5184856260de3cd9a04cbd58417a22d8]
+print [a351a80aab55cc2d352dd3943a2a84e736c2c8ce]
 
  file "compat.c"
-print [da3a10fe080d51a05df518f2219383957ab57685]
+print [1baedef48ec7adbef2b8d968b02ad5ba5df6edbe]
 
  file "compat.h"
-print [9985ee38a1924b72e0288f09c4e86b3aae4e3fae]
+print [bc9bde006284391dee42b42bbc650b7c4ad23da3]
 
  file "config.guess"
-print [c517de1f0b5fac9fcbd47156139c2564b0583cad]
+print [a08714ba77ce43e4e84170e199b12938bd556056]
 
  file "config.sub"
-print [5bcac062d78e163aa75bf921c0446c01f8a24919]
+print [582bed48e75d76da7ca17b85c7795b533423d1e2]
 
  file "configure.in"
-print [d1ea1ba6a1a74553858ac1f36001deb1498ded70]
+print [eaacf85e37ed2a8c2bf262973ff2c499967efcf8]
 
  file "dbclient.1"
-print [6645d5a6043bc6f7bc9cf5e9ce881c77828ef82c]
+print [a05bffdd978c5f4e1baf01586080a5b8b47922cf]
 
  file "dbmulti.c"
-print [90d245d41aa6d0a992435c0ad1802ecae49d44bc]
+print [1317b9e22ca84fc37b9d1018490b5d5fbcb17492]
 
  file "dbutil.c"
-print [ff47a0f870aab595a6018cdbdc4441f82042d36f]
+print [bf1003e425bdcd1fb42cb711330587cb30b45820]
 
  file "dbutil.h"
-print [09103f1ec86080db7e42eec343ef9bc2274db18f]
+print [7f74b8a99b450aa227b6a366314466560043cd1a]
 
  file "debian/README.Debian"
-print [d296d41176b2be35e41cbe0efd8bf4ad7fab659c]
+print [7900ff63df75e78ec1eff4075519fcf0cd10ef7b]
 
  file "debian/README.Debian.diet"
-print [482b7448c34e86ed3d2f6d55735e27f4fe10af3d]
+print [556d0c8e7ad7f7509484133a4199659a8b6e6f98]
 
  file "debian/README.runit"
-print [e5e1acab19033290e3d0003e4ba29d25e10df9c7]
-
- file "debian/changelog"
-print [f085187b5bb658751e81aa6e48be02166ceefc3a]
+print [eaaf4d824d21363f34b09db99e6688eb42f70bff]
 
  file "debian/control"
-print [5d1654587ffd86a234f97709eea653d2aa493886]
+print [812c86b0ee0a22e5737aac95028cc9e46fc675aa]
 
  file "debian/copyright.in"
-print [414040440d6f4cb5fbfacb4dad91dc49641c1212]
+print [5f7439257d6d7d521b833d9e92c0a71e3154f1c7]
 
  file "debian/dropbear.README.Debian"
-print [4e0bc1e2ae18e1a51e66eab53ef0cba133f25f26]
+print [6880396a81b84eff4a718442be75f20afe73a697]
 
  file "debian/dropbear.conffiles"
-print [f8913617abf96bd057456045d62403d7d6216502]
+print [ef31d73ba62f28739463a33d2dd9811a7580fac5]
 
  file "debian/dropbear.default"
-print [d480a0274f638d7eaa9ceb2e85e7ea125d9a1d5e]
+print [02bb7feffc6dd35846bd45219ba1b2c6a827a468]
 
  file "debian/dropbear.docs"
-print [f7992edd52bb05ee7986ebf7c75c01450fde62f1]
+print [c9c62afb53ea7ab4b2d8f184cb5fe1011e267f0b]
 
  file "debian/dropbear.init"
-print [e6722fa2e61d51cc58ee9febd2f308f2058c4418]
+print [a32fa1ef365ab7cd2140f8230a1f46b38698ad9d]
 
  file "debian/dropbear.postinst"
-print [2e71aae3a9944cbad4e8091c1d8ed24377722961]
+print [07fa03251657a031304de7ebd11a23a47744cf4f]
 
  file "debian/dropbear.postrm"
-print [0b5c631aac7c03af1cef719477539ad12acd5a31]
+print [b2789868df718e6dd853b57bdc968b912c1c2806]
 
  file "debian/dropbear.prerm"
-print [cb7c39f5c99918e90b05bbaec183816b7a58f728]
+print [466a06eb085b53c67db8b2be707719ab197640b9]
 
  file "debian/implicit"
-print [0dc82a05a1e50e6c28c410eece425a0240aa3add]
+print [43bd21e5941a84705a2b6ea122b90753017b96cd]
 
  file "debian/rules"
-print [f8e7d1e705eb9db7c0a59d2ec055fa1b853d633a]
+print [f5577e23b7bf162c8e916722a2ef37a0fcb33a2a]
 
  file "debian/service/log"
-print [1fe2cb9cd8a1fbb9332c425f51e2ac97646c3d56]
+print [f80346e19da96ad2bbb91e0b20ab6129da645d50]
 
  file "debian/service/run"
-print [840327843487b683d8515c0d105e474a4bb03886]
+print [14bd30f14213f6af14c21ff58761e1668593c6f7]
 
  file "debug.h"
-print [bbf7e9fb6000e327595589eb7b4a75cfc0c05ced]
+print [6409c0f5a15ff399e882e82592a39d8cadd941c5]
 
  file "dropbear.8"
-print [9c6037e95e5b9dce4a3576d4a2edd65d9569f088]
+print [c7c4faebd41cc4598b00cd0ec4f17162f2ebf7da]
 
  file "dropbearconvert.c"
-print [20c2c77a67171c5003951c222743091ac2c7f5a8]
+print [b38fc184f60bb65042dda56a8524197c3c9f5b15]
 
  file "dropbearkey.8"
-print [7b0b6c764af2d05f0aab4259afa5d6a0dce2dcef]
+print [13fa2ed2bce77f366f1f60ae9518a63bc1559e42]
 
  file "dropbearkey.c"
-print [a51aca4d82f1d831d76f2ec55f904423336ae341]
+print [d5382ab8481174237f81ff59b18f7de707661da4]
 
  file "dss.c"
-print [5352933e9e467c326b79d1f2fbe4979cef585865]
+print [f89a6dd09c19974447fb93827770d354aacb9918]
 
  file "dss.h"
-print [bd0fce7cf935ed89e9a15c1154b92586fc7cb28b]
+print [42d7a8e4e848a028bc0cdb77c02c6c38cbc496a7]
 
  file "fake-rfc2553.c"
-print [5b4cbdb09722e2e526da807bfd73dc72fda4cd17]
+print [ae9f01e11ea5bc9a52ff6635f235a5b421bfaccb]
 
  file "fake-rfc2553.h"
-print [4bcb3e2a26b29978bac448eda912a1cf990a56e5]
+print [c735a480dc15808320ab7bc135677ede0a26b619]
 
  file "filelist.txt"
-print [99e2c13ebf9cb50e93e67228227fa021a17f0131]
+print [9ab388ac168d7788a715431f779f7d9250a9f83e]
 
  file "gendss.c"
-print [aa277734629c705409bdfd0a3e154f80563f6745]
+print [35149d82f1dffb02ffb2122dbbc73da26dd1b9ea]
 
  file "gendss.h"
-print [6ded702f5a0c5a6a901d880e465bcd515e728649]
+print [3d7e5db2df9f5e725e5d448ee21d67ae90e01740]
 
  file "genrsa.c"
-print [831258ddfa747d267494a9175d2a7bac5558b0d5]
+print [81da271d1218fcdda2a9b0d6785c8ee83644a32f]
 
  file "genrsa.h"
-print [ea28cb576f9ce51e47426e6bedbc0ecc5bc7c9e3]
+print [df4efefcfe881aa1709e3a9e76b1c97ef9ede618]
 
  file "includes.h"
-print [d0f09b780ce30ae67d88a42ee497759ddc6cd397]
+print [4bd5a13a0b13e1365cd7415841fee095ff23f8f5]
 
  file "install-sh"
-print [81530abecd3eb284a2eff29e199d55c803fa3ea2]
+print [2aeb7d4754939741013eace6f3b0033d752d9b8e]
 
  file "kex.h"
-print [3c3323e70ea14b75565a1f8c95b03cb0c4ff8d66]
+print [8e0cf6c2df40ff4a8ec6b472fe079a64628f56f9]
 
  file "keyimport.c"
-print [bcbf0c0d25cbbbfbbf39957fc85730a5de7471b4]
+print [115783988c2033e9999deb29228bad0cc9e8e575]
 
  file "keyimport.h"
-print [81a348e95e9119ae4dae4ae9527b185bdeb98573]
+print [87ad14877c79253e8060a19d825ec47e4ccbf7a4]
 
  file "libtomcrypt/Doxyfile"
-print [a60a7c8bb7a07013d863d4bac0e688064cff5a9c]
+print [7c8546abae2689fe78796b4979d889914164de09]
 
  file "libtomcrypt/LICENSE"
-print [65a268c5e61c78aee56450267d91146aae167eff]
+print [4715e34dda81e06b3e5a4acf4d4f3532cf428eac]
 
  file "libtomcrypt/Makefile.in"
-print [61e5b75582e1ed3dd81d046e6d7bf4888e1b014f]
+print [4e00098776cd17f67d832ab6189d408a8c868a70]
 
  file "libtomcrypt/README"
-print [b70831b037a23ddd9d157ba6d288d79228912b31]
+print [bb27adce431a57615541529ea73029446bf0e539]
 
  file "libtomcrypt/TODO"
-print [fe5760e159262eb0b35719fd4608fb45b59dbf5f]
+print [7ad7eea207007609186cc4f5f665956b4ebe9d9b]
 
  file "libtomcrypt/build.sh"
-print [b19016be204541a01e99da67f050ff298912a1d0]
+print [6b3ed270ceed79430180c17391934375bd8611cb]
 
  file "libtomcrypt/changes"
-print [4563ba1d56d05e24c544391fe5bd19affd5406a7]
+print [c090d6c5ebbfc07c4052697796e6ec883ba77af1]
 
  file "libtomcrypt/crypt.lof"
-print [72c833e5625dea615dc003a212d2dc7db04ac3bc]
+print [53c0d90dafae46861c76033464ed0fec08cd5de5]
 
  file "libtomcrypt/crypt.tex"
-print [9d140d9fb7789fedd81f812501896f4ecd65b866]
+print [7999e24a2c494fc438cdaee597da92c6f7d345fa]
 
  file "libtomcrypt/demos/encrypt.c"
-print [097c3809c7382286c70dbcf9fcd9fe7b14f1a442]
+print [e21347ec242572025d7ad98de9b7dc8fdbdbccf5]
 
  file "libtomcrypt/demos/hashsum.c"
-print [65c59bf77c3b2bc65a64e1d41f131855374a0b9b]
+print [169e76989a6deaad7eccd038c0afad0f7f25c25d]
 
  file "libtomcrypt/demos/multi.c"
-print [9c116c6390ebe9dc5e5afd3da03af782c5ae9b04]
+print [9e8bffb65da046347ee0950b8b1b64341ec9e105]
 
  file "libtomcrypt/demos/small.c"
-print [cab6b415507be7b5da04e8f12f655b53b9a2a55b]
+print [88589e0d3014b735a6f5fcbfc2eb2d0392da9818]
 
  file "libtomcrypt/demos/test.c"
-print [c5aaa2997f4dd56dc30107c235ae160f827c6c3a]
+print [44e6844aabf2e00e69e862df7d300c4b699cd70c]
 
  file "libtomcrypt/demos/timing.c"
-print [617e30315e434e4bcb344bee0dd9e56fa6150671]
+print [0275a5ff29677d801a87ca8e1d7b12e6486f2da1]
 
  file "libtomcrypt/demos/tv_gen.c"
-print [7e56990fbddf17b234dade358041938130f24bc0]
+print [29ec32cffd995f045b85fcea39ca126c589088bd]
 
  file "libtomcrypt/doc/footer.html"
-print [df1106a676c2437862b84c482aa859566a4d9da5]
+print [0990196453f3e44d12268a2a22c0efdf89250d8d]
 
  file "libtomcrypt/doc/header.html"
-print [41d1aef51ecf8d40649f376884ea88d1bfc2c05a]
+print [9124fa921a7af4515803e50f5a54c68c43bbd411]
 
  file "libtomcrypt/filter.pl"
-print [7c045063e2b523dca086acd8c7bb0a4ca8e1596a]
+print [c2b8df2b8fdf6f5fdf8ed4ecbdd80e14f41a6758]
 
  file "libtomcrypt/fixupind.pl"
-print [0d5055e6a1b6b0cd26b9ad75c0a29ffce84f2892]
+print [16de5983fa522f7f533fa627f9bc7048ca54e36b]
 
  file "libtomcrypt/genlist.sh"
-print [8f28de45a4818781724a99d83fa8a2c1077e93ab]
+print [8c4e466997a3bb365f38a969203cf0cc095edaf4]
 
  file "libtomcrypt/makefile.icc"
-print [a90e87f7e2ce95abe9d3ea3418058f0f00b1f003]
+print [75e04db92575079e27fd6bb6b6b8fcd2950f8be0]
 
  file "libtomcrypt/makefile.msvc"
-print [79aa27c3599b9a81d4acdbdc56efb445d5949d0d]
+print [7dc75dc03f099ffc138028e3d8464d2ee3b722fb]
 
  file "libtomcrypt/makefile.shared"
-print [8dba797e732b76875612dccf401484fc0e0ebe4f]
+print [f0ba163e705b42768fd8b332b9f74acf96be7d73]
 
  file "libtomcrypt/makefile.unix"
-print [be448bf1ddfc981d1c732a95d5d5e7856a6bb351]
+print [2ebc64e37fe324841a9256b3f85be2a968e7944b]
 
  file "libtomcrypt/mess.sh"
-print [2107911e9c4d75594471508fa4ef548d80f5ff88]
+print [4c0beaee6af13d15294fff041d863a21a8826004]
 
  file "libtomcrypt/notes/base64_tv.txt"
-print [0962985287dce29da48f52625dc910b0b45d0a78]
+print [6f8f5fd125c728aac4b1669c731e2b774e1f8efa]
 
  file "libtomcrypt/notes/ccm_tv.txt"
-print [f7ea00529bb8d596e869067b3c9d71cd846dbcfa]
+print [aa5036d01f2409d4dec498a7aef7c3172fc2d712]
 
  file "libtomcrypt/notes/cipher_tv.txt"
-print [be1624c7a567381338c7439a0f9f64b3d36b5abe]
+print [bf1803ced53374a8c7ce01fedb40e5380e1e1ef0]
 
  file "libtomcrypt/notes/eax_tv.txt"
-print [e16f32977572cd4a832346d14c936d2a518aac08]
+print [9989f9e2bac907e1b9d794a2e9635eb5b706dda0]
 
  file "libtomcrypt/notes/ecc_tv.txt"
-print [24fa3c7c64cafb030dbc9b91980d7de843aa18c5]
+print [948f893998042c29feaecc7a9fb556c11317eb86]
 
  file "libtomcrypt/notes/etc/saferp_optimizer.c"
-print [cf6a67c3b743e34dce75023f3db4961e3d224fa4]
+print [8542e8e7f2845e42c6b67233ab3ac4a500e618d6]
 
  file "libtomcrypt/notes/etc/whirlgen.c"
-print [db35ec6a13adfe7633bfd5ac8fff7b56289c2576]
+print [9666e59c4e5e5e8c15fb97e1b2930f991f22d877]
 
  file "libtomcrypt/notes/etc/whirltest.c"
-print [19a3e3fce2a5ff112a7fc943e23ae3287249467e]
+print [e54603a60c8cf345b42e92a2df79297f765ac067]
 
  file "libtomcrypt/notes/gcm_tv.txt"
-print [c858ada5a6ad7f31138a806e13372c07663afa3e]
+print [680aaedcc76e08ff917b842ef4804bfc83974f6a]
 
  file "libtomcrypt/notes/hash_tv.txt"
-print [2642c5b4c4ee5f8183d917d3e3f4a17243e1fd1e]
+print [ced9a1e5571728f6682104416a3a8551d56c77a8]
 
  file "libtomcrypt/notes/hmac_tv.txt"
-print [231807f3ff43fe48d995fa9576edd28d6f6e92ac]
+print [9242f1f91770e2866a886470446ba30b142a60ba]
 
  file "libtomcrypt/notes/lrw_tv.txt"
-print [7ceb097385291e830922ed6fe0be3945a225fb46]
+print [57384aa734ec86962befd33dafb66e9893f162a5]
 
  file "libtomcrypt/notes/ocb_tv.txt"
-print [91271a29e8719eee3c70c903ec91f75807389984]
+print [3c13ea44ca26828933f8dd120390be47b1e82adb]
 
  file "libtomcrypt/notes/omac_tv.txt"
-print [78feabdb4f8bcabdbed9210acbf850a95e85cb32]
+print [da5ba9d2e5f72a276fb3c9883a2731fdc1044a60]
 
  file "libtomcrypt/notes/pmac_tv.txt"
-print [bfe24b68a508f17485b4ba298d8ab24ef74a028b]
+print [9327ebdba663e0c3aa02856b93a0ec70971e4e61]
 
  file "libtomcrypt/notes/tech0001.txt"
-print [72c83bb35edd0ae6742c9f4759428e674d606a69]
+print [e092f393c3f926cd9a016303c439b510e1c9f40e]
 
  file "libtomcrypt/notes/tech0002.txt"
-print [9ea787c8b6e028e8c6a8c777a372e366eb705b43]
+print [01a108eb41fdd077bff51b331adc490aaaab1d14]
 
  file "libtomcrypt/notes/tech0003.txt"
-print [304e71b9c8616daa98ea46bc0165ca227ee328c3]
+print [9c6fa95484c8455588fa9fcb9a5bed91d76d560f]
 
  file "libtomcrypt/notes/tech0004.txt"
-print [39657d093d7ea7d0071b63916e60256832217bd3]
+print [6ee6d55feec92ed20826e8798367e12e9abf9a57]
 
  file "libtomcrypt/notes/tech0005.txt"
-print [ffa43e0f579abdb6f91fff356d71616a0be24e44]
+print [957717a3280f40cb94b899c1378ea78da41fef95]
 
  file "libtomcrypt/notes/tech0006.txt"
-print [83b32a6ebcedd7857f81523196eb30959d427984]
+print [7b30bb69c9d05823656bb0b267dc897dcc5795ff]
 
  file "libtomcrypt/notes/tech0007.txt"
-print [cdf8072a07dc1e499cdea6998ca9a6b39a6af6bb]
+print [63367706ff0a3e1296fd08b48cb3a749418f6ada]
 
  file "libtomcrypt/parsenames.pl"
-print [2b84de437dd75b686d50d1bb930afe0bed23c639]
+print [efab85abd2dca80c6a9585b7327096af5d53cc32]
 
  file "libtomcrypt/run.sh"
-print [922473c6c6ee5a8bee3d6737761bdfe4bbb6f4ff]
+print [9c692232124eccbbdfc91747ac796807fdd4e11d]
 
  file "libtomcrypt/src/ciphers/aes/aes.c"
-print [750a072cf5c092d0951f132af5f85b52400a711a]
+print [3902738d62e26631f1d58c6f94600d69f502be71]
 
  file "libtomcrypt/src/ciphers/aes/aes_tab.c"
-print [be549d540abb02834ab8aea29e55188adeb436bf]
+print [0a8f674e5ab9448c236909e8c6eaf4ebfdb250c4]
 
  file "libtomcrypt/src/ciphers/anubis.c"
-print [b5edfb99ada88345fe255d858a2df80512776cf2]
+print [a5bd51267e188b1b30561d58a27b8a5e6284097e]
 
  file "libtomcrypt/src/ciphers/blowfish.c"
-print [3de7f8c630ae2dbdf8f613e65f890a6cb8226758]
+print [1624616f65f555dd2b0c60c17cda343738f607b4]
 
  file "libtomcrypt/src/ciphers/cast5.c"
-print [1ae459db840c46233c725edad738e9d539c733b6]
+print [ce0cbb8f1b6081563dc1353b1e979338ef7ec6de]
 
  file "libtomcrypt/src/ciphers/des.c"
-print [94f023eb3e0805f9865575a7565876bfedb36a6f]
+print [44ddbc0bdab9f81fa184a3f0c24c5cd79fcf05f7]
 
  file "libtomcrypt/src/ciphers/kasumi.c"
-print [2e1ecd199f1e6bdd8a36849950df28672e61eef1]
+print [f671b103ac4ab9b332fdf9c9ee31beac0afc78c5]
 
  file "libtomcrypt/src/ciphers/khazad.c"
-print [05f347102d9f582173b8ce135712f80d643bb850]
+print [5c70dc1d2303bf8190fff52773b1a1387c4db3cc]
 
  file "libtomcrypt/src/ciphers/kseed.c"
-print [99f9d0bba066164665f57232e419aef7d91de0bb]
+print [7e6b2e8f77455360bcdc8665959819f6e5bfd2ce]
 
  file "libtomcrypt/src/ciphers/noekeon.c"
-print [51c655a25465e94dcd91312f3f6a9d771b010bbc]
+print [5661582a08f805a75b8421b58bfd8442073748b5]
 
  file "libtomcrypt/src/ciphers/rc2.c"
-print [c6bda4bf9cabd2eb34da17808f68ac9dd1e6868c]
+print [ba5c07789fc7c827dcfb8b449f79ec4661a5e4e8]
 
  file "libtomcrypt/src/ciphers/rc5.c"
-print [945c41d07339672485813ca539372777dc89bf91]
+print [74f31379f70af0eef4a88768df77a379f95d8e8b]
 
  file "libtomcrypt/src/ciphers/rc6.c"
-print [cf65f9cce6ed78ab10b948b6c0b87d86d92587ce]
+print [7b3c1f99b991c1790cc3a6a5ab233587f458949b]
 
  file "libtomcrypt/src/ciphers/safer/safer.c"
-print [56cce4b0a677d15d0ddce88728db9a6177090c93]
+print [8b401ad6baa558d0d3268e6d8ecc12762cd15d99]
 
  file "libtomcrypt/src/ciphers/safer/safer_tab.c"
-print [e5c46c43165bc527ed4ec15c896a115eac2bb3b1]
+print [657f5c25f8502b2752abf783082afc0e77abd7aa]
 
  file "libtomcrypt/src/ciphers/safer/saferp.c"
-print [273b0630428765b969751bfffe71108d15512585]
+print [ed7814561cd881494f7459dd21fa2da963370b49]
 
  file "libtomcrypt/src/ciphers/skipjack.c"
-print [d50c97a90ac820f20d08a20dd819ee17ca462e42]
+print [dbd9d456d57fa9759f43b182702a0ff45232950f]
 
  file "libtomcrypt/src/ciphers/twofish/twofish.c"
-print [0cd19002fcab91401ca003152f8273a31bc5c6dc]
+print [72d8a1c0f15504310ecf1a595dd0517cb17870e5]
 
  file "libtomcrypt/src/ciphers/twofish/twofish_tab.c"
-print [8aeb6859d765d09d23c74ad2fb527f382b02b689]
+print [ca37333a48a381f8df9482939adb126d8e66fe9f]
 
  file "libtomcrypt/src/ciphers/xtea.c"
-print [44bef27f757ba84b4f9ccefb7f2ad30cc5e6ad9f]
+print [a6706e0b0d204cc6edcb1559bf247d9cee3b2c73]
 
  file "libtomcrypt/src/encauth/ccm/ccm_memory.c"
-print [c830eed5975fe52c404292caf1719213ea4fa3d5]
+print [33d710334a836c7367f03a4247763e0a0ed0968c]
 
  file "libtomcrypt/src/encauth/ccm/ccm_test.c"
-print [a71cf7e7c5f2e5c821291f89e7d7c0f43ef786a3]
+print [6c3db31e0a495e53d8f26f678dbe8b867a7d7ab3]
 
  file "libtomcrypt/src/encauth/eax/eax_addheader.c"
-print [7679c0213fc52e5c2b7b4d3db011ea538df19b90]
+print [308113d1244ae04f6535d3f394784e60b7ea6f74]
 
  file "libtomcrypt/src/encauth/eax/eax_decrypt.c"
-print [8f7369a6b67bf414a19fc4494e3bfaa8659da23d]
+print [7cd1085eec4ce90b43da2eef2bb3d9c2170e07a2]
 
  file "libtomcrypt/src/encauth/eax/eax_decrypt_verify_memory.c"
-print [385d72b336776fae47b50ee0877382f9a82473b7]
+print [5125e66c3ae8aeb480bcd8edd8ef53da9353341d]
 
  file "libtomcrypt/src/encauth/eax/eax_done.c"
-print [901cf052de5ee6dea7068f53ba4f00883a0403cd]
+print [dc91620d1fc9cd7e163f04f79fa4e6a5bd4a699b]
 
  file "libtomcrypt/src/encauth/eax/eax_encrypt.c"
-print [07e969d55f238cc5d9106414a2506881ffedb371]
+print [1a0a6ef6977e1096b905a8215250b862f5546e84]
 
  file "libtomcrypt/src/encauth/eax/eax_encrypt_authenticate_memory.c"
-print [9df87abe2f652fe3b800948cc343f644b01e314a]
+print [e3eaadf7c81485389654c83b6bec5c1bda66675c]
 
  file "libtomcrypt/src/encauth/eax/eax_init.c"
-print [a1638e5c4502792a7eb02ca8ff67c3786cae1474]
+print [3830a958d9d086ef2690cd6b06febe57f7c1c2e0]
 
  file "libtomcrypt/src/encauth/eax/eax_test.c"
-print [2f2ef7f93ef32053cf6cdc492b9cf4a9ed8f84a0]
+print [6d9acbf50abe6cd9830b16d1034459cf53151451]
 
  file "libtomcrypt/src/encauth/gcm/gcm_add_aad.c"
-print [f4df2e49053bd4ad4a183c5d1d9aa8d028103dee]
+print [87f11c65bcdc929d07dadaf83d44c562d22107cc]
 
  file "libtomcrypt/src/encauth/gcm/gcm_add_iv.c"
-print [306571709b85d143fe6b15c8f2ae54c1ac3f8558]
+print [34eb29786216a7e6424f25278009bc41355fa0cc]
 
  file "libtomcrypt/src/encauth/gcm/gcm_done.c"
-print [3593da56ba9944f20fb85f0760b25b602f8cc839]
+print [0126627f99fe3313fc7f01438da88a0a954b9efc]
 
  file "libtomcrypt/src/encauth/gcm/gcm_gf_mult.c"
-print [827133793e3bd0cda5005f440942c222969d9353]
+print [56d5ab2d9ea6ccdd0e9bbe01a9d069493d69694b]
 
  file "libtomcrypt/src/encauth/gcm/gcm_init.c"
-print [ea8f38dee9e5ac2971cec5a8b5933547fcda36f6]
+print [ce68c44102e96288f25595a59b1f2ce555596cc4]
 
  file "libtomcrypt/src/encauth/gcm/gcm_memory.c"
-print [eb1d52b0063b3410c95eeb22cbb09e50c1ee9033]
+print [973d4ace3ba75e020e086c6aa1aaa7b2f2d5a4de]
 
  file "libtomcrypt/src/encauth/gcm/gcm_mult_h.c"
-print [7b9984ee165a210bf0f32fffb26741381bad8acd]
+print [071ae5af6da9d62ab5dd0afbf1e881072f44d8dd]
 
  file "libtomcrypt/src/encauth/gcm/gcm_process.c"
-print [1aab5fd1decdcdc4cb57e3ca7ce38655d3fb928d]
+print [67d96c025e16cbee38d11b4c3de80213b1393b7a]
 
  file "libtomcrypt/src/encauth/gcm/gcm_reset.c"
-print [7e76d3e9272c46f1abe77eb37a28208339ddf987]
+print [7794f4837004cf25fbf35622a64bfc367cb1739a]
 
  file "libtomcrypt/src/encauth/gcm/gcm_test.c"
-print [c77453fbe331d70212e56f4839895a1a7a9cc72e]
+print [7c5358205953e8afe9f5802c31b70e6f9b2286cd]
 
  file "libtomcrypt/src/encauth/ocb/ocb_decrypt.c"
-print [786d597848bd2d00684933dc6e222cd62ace7989]
+print [fca0ac4b63d2ddae7cc29a26ca7d980d088754a8]
 
  file "libtomcrypt/src/encauth/ocb/ocb_decrypt_verify_memory.c"
-print [55941c939134ff7cde8dd9a4b32126c69b4e1224]
+print [1c4ec848b16b21b6830427d10b9b6f8c8e384e83]
 
  file "libtomcrypt/src/encauth/ocb/ocb_done_decrypt.c"
-print [4d1668d56bb9e7949e4f47a33e9004b523111cea]
+print [992b216612e6401fd48486972b82de40c3a9c0ca]
 
  file "libtomcrypt/src/encauth/ocb/ocb_done_encrypt.c"
-print [ff72b8f6ea4f7351a39b2b2edc0b09aa0d45971b]
+print [668cfa5c64cfa4a985caf05e96c00bd3d75663bb]
 
  file "libtomcrypt/src/encauth/ocb/ocb_encrypt.c"
-print [aad78f144885e658cb1bbdbae7f4a75abfd794a3]
+print [6f28a39a1135b0832c65bbf3abe794d1d66f9731]
 
  file "libtomcrypt/src/encauth/ocb/ocb_encrypt_authenticate_memory.c"
-print [8e729a21b965279ffa05a1c8489f480977e1a684]
+print [e2b3a11a5bdc0cf64e71f37c11dfaf44a94628b2]
 
  file "libtomcrypt/src/encauth/ocb/ocb_init.c"
-print [b394a5cb0aa9e6c37bea0a8e2d89c4da3820a923]
+print [2bca590cec6670357c800da3f7ec68c74037fb55]
 
  file "libtomcrypt/src/encauth/ocb/ocb_ntz.c"
-print [3c26eb4b5ef04e00f37e0113cd3f7f1fdd9276e7]
+print [a0e379ceb9a7a263bba4c6465061197210b0eda2]
 
  file "libtomcrypt/src/encauth/ocb/ocb_shift_xor.c"
-print [e295cd8019790d0aff4e0738b49f471d5b1676cc]
+print [0d29faf03338f583f0278527f1b6dea28272f426]
 
  file "libtomcrypt/src/encauth/ocb/ocb_test.c"
-print [51ed94fd8442d129ace81711ea7a4c1d5f0b2f72]
+print [a71d15ab2edfa82eb8041235571e87caa7da4f0f]
 
  file "libtomcrypt/src/encauth/ocb/s_ocb_done.c"
-print [5d39ac5a79fe95690087f30875814dfb301060e5]
+print [7e8090f4d3d32ab029af999810460356c9ba8796]
 
  file "libtomcrypt/src/hashes/chc/chc.c"
-print [b14f641c1340f951568fbcb91af60d50bd7ba3d5]
+print [29ef2c4d007eb723559d6dafb6ed2ed2eb0aabcd]
 
  file "libtomcrypt/src/hashes/helper/hash_file.c"
-print [62a64a6572ae2c1a53082b9dbfd5a5ee05b35638]
+print [727cad14f7078dfc567a5cc1d7ff2d9526cad4a4]
 
  file "libtomcrypt/src/hashes/helper/hash_filehandle.c"
-print [2162b5e16d18a73afe0a00d3507dba0509795b78]
+print [74d5259b37c202c65a2d0812a5b91f3a2e0ee3fe]
 
  file "libtomcrypt/src/hashes/helper/hash_memory.c"
-print [a293590f966a5c6c60a5d32a13a230962817b787]
+print [d8aafd0b0ddc491c2de926f349c44e71656ac874]
 
  file "libtomcrypt/src/hashes/helper/hash_memory_multi.c"
-print [d7f4f5e7b4ef47dd682c026dc85abf8569c3465a]
+print [acbed4083e9b94689eafd3a51cb6a1f73ecb9269]
 
  file "libtomcrypt/src/hashes/md2.c"
-print [db7ab35301493a5ac32dd1f152d88f3bc5b551aa]
+print [56323a9f51218a6390c68cb538b1d02bb8b38aab]
 
  file "libtomcrypt/src/hashes/md4.c"
-print [dbc77b432f343eac4f490c6b491ea93d229a6257]
+print [14c8c1b86798b1ed5f2602f70da2d954f9a75843]
 
  file "libtomcrypt/src/hashes/md5.c"
-print [7f3c576901b82540837de1f97748e7a8beb4f483]
+print [26ef810081a30716c30bd7c5172b16a1b9eb03d1]
 
  file "libtomcrypt/src/hashes/rmd128.c"
-print [ef7ea38339f3f0ae5e1b6737003559c8303767f1]
+print [51e129fd452b1ca808bad8fda83e0d7f4fd0130d]
 
  file "libtomcrypt/src/hashes/rmd160.c"
-print [0a9b87a6bea3ea03e64b661ea70f3ec9ef86e830]
+print [bdf0fac21200bf38510ca352806420ab962e4769]
 
  file "libtomcrypt/src/hashes/rmd256.c"
-print [6230f2bdd6bc24cc6f7e023033f0ca9b7f86b024]
+print [0374be564fa54ec0c64c106d934e211370dc9205]
 
  file "libtomcrypt/src/hashes/rmd320.c"
-print [00e55bfe49d2710c02a46b060002b3c7fdab2681]
+print [bd33811bae3848475dafea7303d512e0792c61ef]
 
  file "libtomcrypt/src/hashes/sha1.c"
-print [ddeacaff35249125c8e4e5dd37fa8555ab9fff29]
+print [288e473e803c653ccca6090f1c7a305e9d74e55b]
 
  file "libtomcrypt/src/hashes/sha2/sha224.c"
-print [7dfdb448da6dc6ce4372f52b294da538dc2295c3]
+print [182660c27422a8b1ecee33a729e11e029a0058aa]
 
  file "libtomcrypt/src/hashes/sha2/sha256.c"
-print [825b895efcd107409adef8378b119af27fd146c5]
+print [a6bc5791b1b0b8d5c7f7713868f76fdf0e584f51]
 
  file "libtomcrypt/src/hashes/sha2/sha384.c"
-print [86828da4ebf672a3aaf247e7c43e766ab7642159]
+print [67f42bc93cf870f4631e57208bd196b633acc1bd]
 
  file "libtomcrypt/src/hashes/sha2/sha512.c"
-print [1ebe2b05b9e65eccb1da13b3b8f274740d8b6cc5]
+print [04478f37e1c58619680a93651910b2eb85bf2f7b]
 
  file "libtomcrypt/src/hashes/tiger.c"
-print [6b67f71f3c92b0973cbf7062769dbc2881c6f995]
+print [9192e60e705776b9c0de8b8f30351295d27a3d4c]
 
  file "libtomcrypt/src/hashes/whirl/whirl.c"
-print [959a1305da4b0d9180916d8bccb362c5af4c4ce9]
+print [9835eead4c04b9249ae441fab15f2f91a943f745]
 
  file "libtomcrypt/src/hashes/whirl/whirltab.c"
-print [7fba9604fcc0b86832a5639be129fe28a9133107]
+print [d16c8060c436373a0183caf26de65b4dccdc93a7]
 
  file "libtomcrypt/src/headers/tomcrypt.h"
-print [7c05b5890928d8d8d0963e997eb5a6842e03ee68]
+print [e37c75f812095f78a95fb3e49e4c335adb2bb0be]
 
  file "libtomcrypt/src/headers/tomcrypt_argchk.h"
-print [15f5ee029de98836d374dbdbc0a32c258aefdcbc]
+print [f7847af6195df2e4f7e03c2981b7ba5c42d348ed]
 
  file "libtomcrypt/src/headers/tomcrypt_cfg.h"
-print [9613e186753160e90d60736eae0089a0ec39f0b6]
+print [e3e70d4c221a4c59755593dbf2fa81ed1f1d3d5d]
 
  file "libtomcrypt/src/headers/tomcrypt_cipher.h"
-print [d2a4f019225f57ad63ca3eb2f54c5f54bfc9095c]
+print [0b3a7544be779820ce034a4ad10175e30da4c742]
 
  file "libtomcrypt/src/headers/tomcrypt_custom.h"
-print [f0f43a9e99cfc40199162ce632f540422bc8e2c6]
+print [41b43afb6acc860038e9523649fb799afffd2670]
 
  file "libtomcrypt/src/headers/tomcrypt_hash.h"
-print [21df7f76e1e2daecd91c5d7385fefc9309517157]
+print [90bb97e2d7246e846736dfdefbcddfe8499b4b24]
 
  file "libtomcrypt/src/headers/tomcrypt_mac.h"
-print [7127a89e8f97f1c231444af548981b841852418d]
+print [de8aef41018e04cf674f1e9f5d57637cbdc37354]
 
  file "libtomcrypt/src/headers/tomcrypt_macros.h"
-print [ccd2c9e3f2c88c2fdd3af62690ee72bea750c109]
+print [22df16769f949c6bc29c6a6515ded739db7a4a1f]
 
  file "libtomcrypt/src/headers/tomcrypt_math.h"
-print [4d848f7f89dbd1fe41c5f30d984a0a1d0d6fc063]
+print [f19dd7d9f22287d8b4e0c23ea0064729957455fd]
 
  file "libtomcrypt/src/headers/tomcrypt_misc.h"
-print [3a17510109232fffe61f27be61afd3a26e7882ea]
+print [90db329a30be71d407331e9a09ebed5aaf3ad9bc]
 
  file "libtomcrypt/src/headers/tomcrypt_pk.h"
-print [5d48effcac489d9e4b73451562bbf487b66e6aea]
+print [b985338d746982819ec4a49d1ded9b7086ca6533]
 
  file "libtomcrypt/src/headers/tomcrypt_pkcs.h"
-print [aa7b36e4cb589c849857985917647d0ce4326ea5]
+print [6d760d84a7508d3939b4c12347c6b654e9ee6018]
 
  file "libtomcrypt/src/headers/tomcrypt_prng.h"
-print [62c3c7013afbb1b69f6a31a340cbd2f1fc505bf4]
+print [95ab989b1048c84d80fe9ab9782e4658d5101cfa]
 
  file "libtomcrypt/src/mac/f9/f9_done.c"
-print [56ca6faf62f24ab9095feeea643cbaa958876dee]
+print [a51d510d58081a7f3fa9a4ff3ebf617566970703]
 
  file "libtomcrypt/src/mac/f9/f9_file.c"
-print [33234613595740af1c315dc4311c2f1b028b048b]
+print [bcbd58eaef343406bd0c23b2bdd3a4e612d8546b]
 
  file "libtomcrypt/src/mac/f9/f9_init.c"
-print [403a72db3341bb1d4879cb2f2b50e1e6090e376f]
+print [760f99e6f814357073fbad5a337ebbc8ad371718]
 
  file "libtomcrypt/src/mac/f9/f9_memory.c"
-print [6ef8dfc86f361dc0f37255cc0118bc86140ed6dd]
+print [5258ef852074106c0a01e1690982600b1abee849]
 
  file "libtomcrypt/src/mac/f9/f9_memory_multi.c"
-print [8f3cc885cc351e42619a5287556a654d9852a43d]
+print [ec96b4871486e6b77be99afbbd5f84f2eb6bcd1b]
 
  file "libtomcrypt/src/mac/f9/f9_process.c"
-print [e163f544f0648df79004a5ac9d0e4ef43476e9d1]
+print [22106fb628ead802ff9b1b4c300a051c598747c5]
 
  file "libtomcrypt/src/mac/f9/f9_test.c"
-print [31b5d23f193761f70d1d63f92a464f087e84bb41]
+print [c520074ad9c1465fa95af35951d0633e0e91969f]
 
  file "libtomcrypt/src/mac/hmac/hmac_done.c"
-print [3982c0000922f2d20630d687ef48269e0a71b794]
+print [642285282fccb08ee000224f064845efa388ec6b]
 
  file "libtomcrypt/src/mac/hmac/hmac_file.c"
-print [95d9498f4827fe1beceb9e72ec80ac78481b5072]
+print [366502b6bd2e8b74bbf9c245eecfea667e12cf7b]
 
  file "libtomcrypt/src/mac/hmac/hmac_init.c"
-print [ae31684cf06acd5f38b9d71239f09291f8434887]
+print [6e6472b34391f439032e710aebb6991360a6910c]
 
  file "libtomcrypt/src/mac/hmac/hmac_memory.c"
-print [c1a9ec3e14cb55aa7669e92888453e83e7f9c921]
+print [190436cf7b71ac412a5be4a4877aaff02a5f3703]
 
  file "libtomcrypt/src/mac/hmac/hmac_memory_multi.c"
-print [46b55bd6926f58ed8746e4c82b830e9af5690361]
+print [37724ccf55a2cc48cbddeb3a7a7fba9936cc385e]
 
  file "libtomcrypt/src/mac/hmac/hmac_process.c"
-print [c4f6ad3badeb3fee06dceced36af830db24f8968]
+print [8c8284c9d218a9fbfe13c88d9e3ea460e76502ad]
 
  file "libtomcrypt/src/mac/hmac/hmac_test.c"
-print [fd58b5bfc798c72338e523da7cfef64aafd35817]
+print [325aceb31a421c92dd9fd39e55de73244c450dcf]
 
  file "libtomcrypt/src/mac/omac/omac_done.c"
-print [02ef2f5746b7662f056b30fb92818df8fb3e6080]
+print [ea4199f7f3d01ce1e54e1b5e18aa25a6ed42653b]
 
  file "libtomcrypt/src/mac/omac/omac_file.c"
-print [8fa215798b46726001aa4b9c729ae69dec8c03fc]
+print [9af6ca47db51ceff4ae338ae88ce7bcf009fc30e]
 
  file "libtomcrypt/src/mac/omac/omac_init.c"
-print [ca9ebf7e560b30604cf9b14b97c8e73b56737a44]
+print [7161f05586ba74774895ca5dd8005ba6edfae651]
 
  file "libtomcrypt/src/mac/omac/omac_memory.c"
-print [4e601717e7cde7e926d4cbcb7ba40237f23364ac]
+print [d4983a66da6272841c40c04fb7c17c179b246d1e]
 
  file "libtomcrypt/src/mac/omac/omac_memory_multi.c"
-print [d9971e9dc35b2d9139036c03c7a1a646ce264dcd]
+print [c3a3be5d1e44a1c91cb5dcbefdc743d5d319aaa6]
 
  file "libtomcrypt/src/mac/omac/omac_process.c"
-print [d7b68bab1c45f432395f45a2fb264601e195d64a]
+print [16e04bf167f22b73a912197a158d2ab35eaf2cbc]
 
  file "libtomcrypt/src/mac/omac/omac_test.c"
-print [a0ad5840f4cbe25c8f64050ad04c85a97eda1a0a]
+print [2af3fa0eefc637bf12250a7cc8030fdd11306f26]
 
  file "libtomcrypt/src/mac/pelican/pelican.c"
-print [1c760598941bdc194e21d173c008a1d32d32325e]
+print [cd9761419de0cddd09c172c8d0e8642513281ac5]
 
  file "libtomcrypt/src/mac/pelican/pelican_memory.c"
-print [5aaeb70bef68bea3ea8f6ce04d8a323d8011e41a]
+print [eb86e831ba3220b856c408435f695f315f04bfac]
 
  file "libtomcrypt/src/mac/pelican/pelican_test.c"
-print [54901bd537ecdca1dd3133637380afe71efe842d]
+print [117e09fac8b26ebaa13bbd6351b3e86ff443c2aa]
 
  file "libtomcrypt/src/mac/pmac/pmac_done.c"
-print [029046f6d81d1d4b2f4043a7280e2363ec8b7ebe]
+print [ad3a1a9c639b5bdc99e52e92a45a702f8127413d]
 
  file "libtomcrypt/src/mac/pmac/pmac_file.c"
-print [e9f690bb059748bc2cc3c4bb3d4ce1a6760778b6]
+print [d0cb5a362b8d8e6c0a8cec2f51e4540ce24c1c42]
 
  file "libtomcrypt/src/mac/pmac/pmac_init.c"
-print [c903850fe7e703a0bfa0c8479e947e4f17fe2c67]
+print [318870040634317708c38e95d1955874f67ff0f3]
 
  file "libtomcrypt/src/mac/pmac/pmac_memory.c"
-print [70198accc970cad62339468f3e16576e8ac7775f]
+print [9c0044f14d469c7e9e3fb23fece0609daf7452ee]
 
  file "libtomcrypt/src/mac/pmac/pmac_memory_multi.c"
-print [f655b8a01ac1844da11fcdeab780f4260c6971c2]
+print [5c3c8af52576236ac6017bd0e35aef546728ec24]
 
  file "libtomcrypt/src/mac/pmac/pmac_ntz.c"
-print [2bf3a77f89416bafb7b5db87cf0cfe6b4ab14f81]
+print [95611ed40a7dd0f1de54320ee676f1dba0e8e61f]
 
  file "libtomcrypt/src/mac/pmac/pmac_process.c"
-print [bf896da63cb2df5dc6d3c97324cf881979cf37a8]
+print [ee87cafe665dae0c136e19c25045d2ff4cae8fae]
 
  file "libtomcrypt/src/mac/pmac/pmac_shift_xor.c"
-print [6c9f363022ce63876c47b8454b5d3c4b94a184b2]
+print [c3405aba9901c72eb6ec7242e4f392cc95ca1aee]
 
  file "libtomcrypt/src/mac/pmac/pmac_test.c"
-print [f822ac9abf63a8dd6c16c94cd00f5071850054a2]
+print [e223486cfdc02b687c41da8242a02a0b9921d3b8]
 
  file "libtomcrypt/src/mac/xcbc/xcbc_done.c"
-print [22d05d2bc6dc5eda779681f9c6a751f13e2967e4]
+print [b75c8ff892906c6c78671d852290c716d7103dce]
 
  file "libtomcrypt/src/mac/xcbc/xcbc_file.c"
-print [ec61935e31fa3f4b587a97fdc7cdbf8446eb40aa]
+print [401d4515263aebe6a668793e8b04d5136675233f]
 
  file "libtomcrypt/src/mac/xcbc/xcbc_init.c"
-print [90c2e70462d4818018743ceeed746968fd960b8f]
+print [6803d5712866d9f25677daeecd970fba9ba661f5]
 
  file "libtomcrypt/src/mac/xcbc/xcbc_memory.c"
-print [ead78121287b5b61d17719f4848a0f4006bed4d3]
+print [57069317a4bba122ef6ed4b140463fe8589bd116]
 
  file "libtomcrypt/src/mac/xcbc/xcbc_memory_multi.c"
-print [f095d953515b4660d8042e026f46eca4a134be07]
+print [e3fc1a3d64210c27bac8ec84cc14b836dceb5b82]
 
  file "libtomcrypt/src/mac/xcbc/xcbc_process.c"
-print [cea01f1100ecc253ea4ba8a838a9ff5e2f9bc2c2]
+print [9fe2668a54441a9509986606008045c7bcffbd54]
 
  file "libtomcrypt/src/mac/xcbc/xcbc_test.c"
-print [eaa2829417415ad1fc6360bee42add402d111994]
+print [ee3b9b0fcc5705ef15a1a369382e45fb294db710]
 
  file "libtomcrypt/src/math/fp/ltc_ecc_fp_mulmod.c"
-print [0a99dea095782dd4656eefe627b2030f8c84a81b]
+print [b5db1c3ce48b5b553424b7dab3fb32f13584d86f]
 
  file "libtomcrypt/src/math/gmp_desc.c"
-print [10504b52660acb8b7a2f6ea2ada0a51888daf8af]
+print [4be9cad3a0ceb4ec5d89bca81aeaa938e5f105f4]
 
  file "libtomcrypt/src/math/ltm_desc.c"
-print [717b76b6e2a291ffa4ac772ede4915b81fc0b646]
+print [57c75ba2eaff5121f3ed79adef7f3695f38ba26d]
 
  file "libtomcrypt/src/math/multi.c"
-print [b9a14acf1030747f8432ee235b568ce88da4c6a8]
+print [b5a5df5bfab39d1e3753876033689044b3f7eece]
 
  file "libtomcrypt/src/math/rand_prime.c"
-print [60e748d7b2ad38877f2f88134ee488d86d2cba28]
+print [60c820103c83df62f2c44f933101b480423f50e1]
 
  file "libtomcrypt/src/math/tfm_desc.c"
-print [5e6086aa116211f16cc1532e1b1dfaca06881c8f]
+print [6cce5da8cf7e522ef8dda2dbbf5c259d1b85725c]
 
  file "libtomcrypt/src/misc/base64/base64_decode.c"
-print [b57fb136934a811da2eba78b86ccf4632c2cb53f]
+print [f902864515aef3843e66c2ec99ac2e90bdb90725]
 
  file "libtomcrypt/src/misc/base64/base64_encode.c"
-print [5a9670c1bc86e146c6ea0cefc9b698138fc3e6b5]
+print [ad5df2250b18b652506a0ae12b6a21ef6dad811e]
 
  file "libtomcrypt/src/misc/burn_stack.c"
-print [a8d425a2775cba55de6fb99d967210755ea231e2]
+print [1f83f5894cf3213479a7d0cc9e527773c16ed84f]
 
  file "libtomcrypt/src/misc/crypt/crypt.c"
-print [155b024317a680f321669fdccb8a53d36d3d4c03]
+print [354274dcd4db750428f39fe3b408f6a1fbb3bcd8]
 
  file "libtomcrypt/src/misc/crypt/crypt_argchk.c"
-print [63edc4efde182ae14c7a7726d3e560e9f72cd7ba]
+print [de5ecb0859a627398d38eea17827486365fdd902]
 
  file "libtomcrypt/src/misc/crypt/crypt_cipher_descriptor.c"
-print [0c1bff3a8c70e090946d7d64b000c3ffabff3ace]
+print [d7434c2e11c90b2c8339fcbfc0d568b0d913f31a]
 
  file "libtomcrypt/src/misc/crypt/crypt_cipher_is_valid.c"
-print [00b5b44d032779ae0529cdf48ca766daa00d09cc]
+print [bfdbe340d42d5db73621541b622f14d2790dc931]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_cipher.c"
-print [2cc5078dafd23c663598fa70276ff27da163ce92]
+print [5bf7bfbad4f13516e0bfa404ba69292d9d82aa25]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_cipher_any.c"
-print [5a6bbe00e632a0deca3f04c31c1d40300014da34]
+print [400e321ddbb3779b61798420351f7038ea1b8f41]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_cipher_id.c"
-print [8a9291b058aac0afec7a71d532f73be2aa92b8f4]
+print [e48cb61d14d98bef56e8bebb41fa93d20cd5fb58]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_hash.c"
-print [46755a9555ca5292f98182328761b231cc0f8d55]
+print [6c670752490151951d120c453be6977c543095c8]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_hash_any.c"
-print [562b1881f0e8d3c6a95804aaf894755259a10f70]
+print [0e431b6348a9c661947534843178641e7c38da86]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_hash_id.c"
-print [dc4289e168619d295ed46e5136728e94ed92ce5a]
+print [c3565a36099ecb9957de31f4adf51611290d5939]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_hash_oid.c"
-print [fa707c0fad1650241baa97892af3ec84099b5e27]
+print [767b3ccd8bc78e6ef4f56305b950596f1ed6693d]
 
  file "libtomcrypt/src/misc/crypt/crypt_find_prng.c"
-print [4b84f631e73dfff806a0c911e2d063e2d352583b]
+print [6d273a49745de8af8840fc6ec58d6e18da2b4f1e]
 
  file "libtomcrypt/src/misc/crypt/crypt_fsa.c"
-print [12e1ec6e4e9d530a6636847c85a868e78ded8fb9]
+print [710d23e5244b802db4427e2a196d3b21858eb6da]
 
  file "libtomcrypt/src/misc/crypt/crypt_hash_descriptor.c"
-print [eb358b4c63a4d7b768d4b15dd342e47c260efbe0]
+print [99cff10c5f55c45e1b327f0b4c68a0ffd4b8674b]
 
  file "libtomcrypt/src/misc/crypt/crypt_hash_is_valid.c"
-print [d33e1c7f3d330142d6949f7c9888c469209f5cc8]
+print [02f502de385c50fd5a007485982db80eab304606]
 
  file "libtomcrypt/src/misc/crypt/crypt_ltc_mp_descriptor.c"
-print [dbbd1467f6b20bbbc63aa9ed69469d0baba94dd0]
+print [eceaa5301c6877b77b8474fe305a5f052c31f19b]
 
  file "libtomcrypt/src/misc/crypt/crypt_prng_descriptor.c"
-print [e7c277084fe852856af2321eb6c2f7fc46dd5f35]
+print [a21d0f07ee02c8a6de46d72aadf4d219adafa39a]
 
  file "libtomcrypt/src/misc/crypt/crypt_prng_is_valid.c"
-print [355df816e942cb14f0bc520c37ca39f23c54f2a6]
+print [206826b82fd251582a719de97b39df62cdfd94e0]
 
  file "libtomcrypt/src/misc/crypt/crypt_register_cipher.c"
-print [42485e4a3a8349680ccabf6b2f46d5ecc9a95d6e]
+print [57c51dcaeba087d686ecb57454908504c1953aae]
 
  file "libtomcrypt/src/misc/crypt/crypt_register_hash.c"
-print [0819009993a6dfeda0f7a23a4e0ccc9dd264ef62]
+print [41f5e97ef2fdc4a558abfe97248fee78e5c529b9]
 
  file "libtomcrypt/src/misc/crypt/crypt_register_prng.c"
-print [01ebbeced7b66e4b79b54d64a6a65f8b28707db8]
+print [7735d4eaf6a53eda99df775d6079d73d2652c799]
 
  file "libtomcrypt/src/misc/crypt/crypt_unregister_cipher.c"
-print [695f7ac0af09dc8ad253736b93dbd008fe7c1b71]
+print [54e95ca8aa3669feff44966b79fd843f885c2113]
 
  file "libtomcrypt/src/misc/crypt/crypt_unregister_hash.c"
-print [7c39bea95eb882d0461663a50f43a3d415f45c0d]
+print [5441c18983d7705c1182d0a74f1c600ec78859b7]
 
  file "libtomcrypt/src/misc/crypt/crypt_unregister_prng.c"
-print [ed24ea6b7f5a67fbbc0f0a43c0b3e8aac6cd5505]
+print [29b3ed8f6b4116b3080cbff9be396ba0cb628e90]
 
  file "libtomcrypt/src/misc/error_to_string.c"
-print [e72d4e85db1993f5cfbd7edf020d19231bc5038a]
+print [7fc5e3d700b2bb6799746e427abc96b3f0b69b40]
 
  file "libtomcrypt/src/misc/pkcs5/pkcs_5_1.c"
-print [95fd6c964ade8845222427e64dfac86120e788e7]
+print [065dafdd510410ffe0955134e16b603ad61092c4]
 
  file "libtomcrypt/src/misc/pkcs5/pkcs_5_2.c"
-print [aea96ee63f74bd6403ab3a0f4525753c6e6adbb7]
+print [6b0c0c69a0d5db5df809c349275e4f6968750dbd]
 
  file "libtomcrypt/src/misc/zeromem.c"
-print [18c132427e81889c7e2b0b1ea29b99694b3c1b41]
+print [1483e7ff77a45d2dddbfaef809c585a22d5a2fe8]
 
  file "libtomcrypt/src/modes/cbc/cbc_decrypt.c"
-print [310a8fc198e4d3a7c01eac7bf7ab0f628ff7ae16]
+print [9d397b81d4da9c4496963df8eb5fab7f2c119dc5]
 
  file "libtomcrypt/src/modes/cbc/cbc_done.c"
-print [43a20b3745f123a2ca10c40e5894decedd3665b6]
+print [eab87ec0e9090cde593d852ee1666c5cab7cc0f2]
 
  file "libtomcrypt/src/modes/cbc/cbc_encrypt.c"
-print [2f27cb5537d2c560ddbf445a544fb7f27c0bb81d]
+print [2077975cb4c7929747bccb5810bcd2b1996a8080]
 
  file "libtomcrypt/src/modes/cbc/cbc_getiv.c"
-print [ca4c5b693f8cdea5aa04f32a4c79d79df15638f2]
+print [7a5ae768c7a73bb5043ec6568739ff940e0cf384]
 
  file "libtomcrypt/src/modes/cbc/cbc_setiv.c"
-print [91c77a0b19c0382df2d61a5da3e07cbad97083a5]
+print [31bcd712e1318990854d521a60d9648c211bab0c]
 
  file "libtomcrypt/src/modes/cbc/cbc_start.c"
-print [880224d61730ff3ee7777673839e09d637a0a306]
+print [b5ea4da324b2c58f5f0564c90e9cb82699f7359d]
 
  file "libtomcrypt/src/modes/cfb/cfb_decrypt.c"
-print [9c887eb11e3b2f8a28a3dffe3483ae6c6b6898e4]
+print [06f357eed6f1499e16efa21102dcce62c05d091a]
 
  file "libtomcrypt/src/modes/cfb/cfb_done.c"
-print [cded9bbc9cca9c6a895497e752fa874af007e64e]
+print [b98656f40342677380ba926bdd378b6b5ad00c57]
 
  file "libtomcrypt/src/modes/cfb/cfb_encrypt.c"
-print [a64e56c6af60897beaf58eecb074873d1657ef98]
+print [dfebd5d5803e89dac936d40f9a6f8ddf2283e6e9]
 
  file "libtomcrypt/src/modes/cfb/cfb_getiv.c"
-print [00e5fc02c2f3071d7b38e547c17f2cf882a39362]
+print [7b5050637c6c31313ec3b97ddd2f015456d45650]
 
  file "libtomcrypt/src/modes/cfb/cfb_setiv.c"
-print [80354f32dd10955895d9f9e3be9de2d8a5c0ba2a]
+print [8f6033f8c99f8ae025379fed43a5c7f18d5fc9cd]
 
  file "libtomcrypt/src/modes/cfb/cfb_start.c"
-print [0f74a016e63970ab2eb2c9ec82c019b611650f2a]
+print [4d25abe1d2ba5c25336f0e33c550bab364cd3669]
 
  file "libtomcrypt/src/modes/ctr/ctr_decrypt.c"
-print [08a24ea844afe30143b939be2e8eee00f7091945]
+print [8b74bf561d92f0409af4dcfafde09346a47d2584]
 
  file "libtomcrypt/src/modes/ctr/ctr_done.c"
-print [adb610e44314aa949578d5d0497ea5dc7f0a3634]
+print [b98c30558bd18a83a0ca0d4a217136aba879c657]
 
  file "libtomcrypt/src/modes/ctr/ctr_encrypt.c"
-print [31b2077f9a45402efefa27bca260971ea5591738]
+print [9e4492545cd88a0424276f9be822b5f1b0e16015]
 
  file "libtomcrypt/src/modes/ctr/ctr_getiv.c"
-print [907aef4ea0ca98517d82b0e46e309d4abe661e7e]
+print [f2959a2c9c8b1f19652ebdc1f26727e21c4b98ab]
 
  file "libtomcrypt/src/modes/ctr/ctr_setiv.c"
-print [82f93805c92c8d4c36ffeb00a4a58db692281854]
+print [84d3c0004824642b051413a40f68af53d0422487]
 
  file "libtomcrypt/src/modes/ctr/ctr_start.c"
-print [cfb134458069cbb5f17d45d12f383c448885e0f9]
+print [fb83284c0e25643d9db7bc359e12a991a512a877]
 
  file "libtomcrypt/src/modes/ctr/ctr_test.c"
-print [c413df38852fd018113649abf91655ac5f43a7e9]
+print [9863d8860958802568b3b5a30fd607617fc5fc30]
 
  file "libtomcrypt/src/modes/ecb/ecb_decrypt.c"
-print [7959190a184c65404b5758249c86a1eee1a4eb9b]
+print [d06d63f742046a75c344964c0522439375ac8d84]
 
  file "libtomcrypt/src/modes/ecb/ecb_done.c"
-print [e2e87ada3ab1d2bdbb2a9e0ffcb5ede41652bf2d]
+print [b0022b6f365273403f8851ef9e723d35919a83f6]
 
  file "libtomcrypt/src/modes/ecb/ecb_encrypt.c"
-print [1dd95c62077bfe43a0729b3a988af592da23d86d]
+print [5836c41e43bb0e447bba5d65be04771b9135a4ad]
 
  file "libtomcrypt/src/modes/ecb/ecb_start.c"
-print [865b9264e139ec1fce6a37dddf681eef2e07b492]
+print [e82407c1e319cb84f61751bdc59df1d09a2c47b7]
 
  file "libtomcrypt/src/modes/f8/f8_decrypt.c"
-print [505dfd6e48a671fd17af47fcc4918b5f46499c5f]
+print [cf054f482bfef46efe44048e1db547105b35c684]
 
  file "libtomcrypt/src/modes/f8/f8_done.c"
-print [1ce487d408818ec56954b32539aa705859ddd876]
+print [13870d81efae243cc69a89d555ffce3881dc28e5]
 
  file "libtomcrypt/src/modes/f8/f8_encrypt.c"
-print [8be4a5bf0ca5bc46323ba02a6d4bceed8f96ed67]
+print [5ab9050f0a5e40ee737345922a035beec947fe23]
 
  file "libtomcrypt/src/modes/f8/f8_getiv.c"
-print [1bc868e24e70fd39a2119c57ea88d6846ea3c7d3]
+print [4805c7eec064a33a2160542bdc0f5725cd929140]
 
  file "libtomcrypt/src/modes/f8/f8_setiv.c"
-print [9dbc7c21172d493872562958047152852818665e]
+print [4b827bff6aa9efb07f545a9f1796ac6ccc48cf2e]
 
  file "libtomcrypt/src/modes/f8/f8_start.c"
-print [9c9ad6a0fe18d82b74639bd8150e73867cd39a00]
+print [54f3627341230e89a2f1db6eeaaa655c63fc0b87]
 
  file "libtomcrypt/src/modes/f8/f8_test_mode.c"
-print [971d1fca084e95b96f36e139a9c6f9046486ec8f]
+print [20bb3a412cce24f152401097152faac408d533b9]
 
  file "libtomcrypt/src/modes/lrw/lrw_decrypt.c"
-print [fcea9dd45d3662c37c55cdd00ffa9dd88fee49df]
+print [1708cce986ed1c2cb7000ca7b820ccd4d916149b]
 
  file "libtomcrypt/src/modes/lrw/lrw_done.c"
-print [d5f29f4260f580c287c98cc111d6cbcd587e1280]
+print [662fdaeaacb72b7a589e3707f269986541d0d56f]
 
  file "libtomcrypt/src/modes/lrw/lrw_encrypt.c"
-print [6ffcf23ce872a3b36c8d044baad051eec568e577]
+print [76a0cf5166c9ba90d21c34305b0db3d3be297da1]
 
  file "libtomcrypt/src/modes/lrw/lrw_getiv.c"
-print [8753dcae67d13754f6d7e1fa39fb3ddde0e883b4]
+print [34d9ee1ab48aad56543d3f2e75b7232912aea05b]
 
  file "libtomcrypt/src/modes/lrw/lrw_process.c"
-print [e8f823eddad4b749f0aff969d3f436d7bc2413e1]
+print [c642d4cb149eb2a7efea73f6c03f4eaedc1c4fc4]
 
  file "libtomcrypt/src/modes/lrw/lrw_setiv.c"
-print [0645439736de5607421aec743d934a0ca8512c77]
+print [0a09962eb36775e6d46062879d29747dbd6fe8d7]
 
  file "libtomcrypt/src/modes/lrw/lrw_start.c"
-print [e7728180093a8038a670b79fa203c3363286b1ad]
+print [a04028855a551f9f101c3bc199f2c7f7609efb7f]
 
  file "libtomcrypt/src/modes/lrw/lrw_test.c"
-print [0d6814c5a712b8e201a6d672c1295e17969bc5a8]
+print [9d9c57e5cbbf8c7b42d0fb4aa22bb41e5904d6a3]
 
  file "libtomcrypt/src/modes/ofb/ofb_decrypt.c"
-print [0efb2464d222d1a6198b8f3b8df6faf97c4302a8]
+print [502ae44a31485bb0e28b2c49ec404b508cd44474]
 
  file "libtomcrypt/src/modes/ofb/ofb_done.c"
-print [6ad8e7ac523681eff6951026bfdde92a14ac9357]
+print [2a2ae2fdf07d72b4b43f9befcbef74ca81e85588]
 
  file "libtomcrypt/src/modes/ofb/ofb_encrypt.c"
-print [fe885ba8d0a07414a99e31725a61820ba8561418]
+print [e47bf5bb327b4af6a032b2c960f4dfaa8d5c6791]
 
  file "libtomcrypt/src/modes/ofb/ofb_getiv.c"
-print [ed2c0d76f84c5bce961eb2b26b6ffc04db1f6076]
+print [b04b1f70b6147a5d7c53008eba9761a5cd5c0d04]
 
  file "libtomcrypt/src/modes/ofb/ofb_setiv.c"
-print [7f0cf1a17ceea2df87d763144a47709bcbbb04c3]
+print [d3df7ba3f4ffd953c83b18e0397995c8094654ae]
 
  file "libtomcrypt/src/modes/ofb/ofb_start.c"
-print [67d50500448978eb00c110a637ab64a14deb90d2]
+print [186c5ac59b23e7b70af56f5d5c056d2eedce11b9]
 
  file "libtomcrypt/src/pk/asn1/der/bit/der_decode_bit_string.c"
-print [4e607d257add75af7afb46647db97773b82fa716]
+print [ff9537488bae122772adb481752e1411d78615ec]
 
  file "libtomcrypt/src/pk/asn1/der/bit/der_encode_bit_string.c"
-print [b66ac38ded7498477bf386745ac3e4ed85846668]
+print [4e77098e6dd7e4a1514e1e69c02fc72eae28e80f]
 
  file "libtomcrypt/src/pk/asn1/der/bit/der_length_bit_string.c"
-print [61c13947ee173bf81a993d35872e894d4b1a8fed]
+print [8f4cc41953a8490b00cfe537822a3a40de694d16]
 
  file "libtomcrypt/src/pk/asn1/der/boolean/der_decode_boolean.c"
-print [4b0a9193ae2ff56b1f5f994c8e5141fe0a4f13fc]
+print [7c064c3853f7f05100a99a475121f179d8278901]
 
  file "libtomcrypt/src/pk/asn1/der/boolean/der_encode_boolean.c"
-print [032607623be0273cb702ff5a1d6dcb639c5a6ac3]
+print [a866bfad4f909003aafd41adaf2f0568e509c28b]
 
  file "libtomcrypt/src/pk/asn1/der/boolean/der_length_boolean.c"
-print [272cf4825541f42071bf95c20fdf2576d4e2caae]
+print [c34a7c92fddd4a41c6f2a5b3c566652a2583b9c3]
 
  file "libtomcrypt/src/pk/asn1/der/choice/der_decode_choice.c"
-print [9a48248c4a8a721a883d8eee31da456198ff470b]
+print [3e9c03deaf353fc8fafb515a94450309b5048730]
 
  file "libtomcrypt/src/pk/asn1/der/ia5/der_decode_ia5_string.c"
-print [194d02f81f6ca3153629e18c81e19a97475a3fb2]
+print [a58dbe8f3fea0dda84db63a7e6c7e53a0d5c598d]
 
  file "libtomcrypt/src/pk/asn1/der/ia5/der_encode_ia5_string.c"
-print [f2bb42191bae7d7ab8e5b43bcef7f08a4b442fb9]
+print [c9a57180f3bd75600f8334b6b8ca72562c87aedf]
 
  file "libtomcrypt/src/pk/asn1/der/ia5/der_length_ia5_string.c"
-print [38d144153652315612aa9552cbd32e366e0aa241]
+print [d003fd2074c66f2583b1e3dc402cbe02ba030ede]
 
  file "libtomcrypt/src/pk/asn1/der/integer/der_decode_integer.c"
-print [4b4dbc1b2ca3e84c8a3429fd5bf95e89dd73b15e]
+print [bbcec0fbd2888463ccbaf91b37175b88ca8d3e34]
 
  file "libtomcrypt/src/pk/asn1/der/integer/der_encode_integer.c"
-print [686ce3ba85b47e0f5f5524f51eae05ab5a9ef53b]
+print [2329ae595f44109aeaeb2da0018344a7125a6420]
 
  file "libtomcrypt/src/pk/asn1/der/integer/der_length_integer.c"
-print [6e5112782c15edf51e7cfe82732e99f0e81dd50b]
+print [953f3263dd09a9760a6f351fc9fd9c97adadc67b]
 
  file "libtomcrypt/src/pk/asn1/der/object_identifier/der_decode_object_identifier.c"
-print [7455c169be6fce96d4f706d2255b31dfa1e3a8df]
+print [885285f343a521010fea05be456f8a8110b5576e]
 
  file "libtomcrypt/src/pk/asn1/der/object_identifier/der_encode_object_identifier.c"
-print [47dd343a3874cbefb7b02712ab25b43c3067eedc]
+print [a2c8283800cd31620ed8dd923fc72b1638a35c3c]
 
  file "libtomcrypt/src/pk/asn1/der/object_identifier/der_length_object_identifier.c"
-print [4603be9bbe1e7638e8d5f184487daaa1bb93b0b8]
+print [ba0d2c9d16c12ac06105735a09da170c077971ba]
 
  file "libtomcrypt/src/pk/asn1/der/octet/der_decode_octet_string.c"
-print [1b4390a2bd9c4a49eb3056654ab43591c1bf1e7f]
+print [076601d98a74e722c833f3e94a17ed4cf8a41300]
 
  file "libtomcrypt/src/pk/asn1/der/octet/der_encode_octet_string.c"
-print [f9644b475d770c70113d5321eb4d6295f7a91835]
+print [af8beb118a439ea3edd8df5fb43c81ce9640cd3e]
 
  file "libtomcrypt/src/pk/asn1/der/octet/der_length_octet_string.c"
-print [59b2386979d23cdfe96cb69a904c17f478e4c08f]
+print [d4ed0acccb3a660e22faa34352e9b34cef90d704]
 
  file "libtomcrypt/src/pk/asn1/der/printable_string/der_decode_printable_string.c"
-print [b931dec7601994ce21e62cf73bb57975d608caf8]
+print [af86ba7d0ec11ecf4479ee87db010c086f152249]
 
  file "libtomcrypt/src/pk/asn1/der/printable_string/der_encode_printable_string.c"
-print [6ae6effed115e037718172f187142875eddf32e7]
+print [f2e729fa18cdeaf2ace86ba4e0ffe64b12240cc3]
 
  file "libtomcrypt/src/pk/asn1/der/printable_string/der_length_printable_string.c"
-print [c074e6f3b0f64ed737c09b21ff55e798ac5ba912]
+print [ecac109b5461eaa48d20e74af9b08b60cd71e432]
 
  file "libtomcrypt/src/pk/asn1/der/sequence/der_decode_sequence_ex.c"
-print [8d5bbf355f04eb716c39c7f41e5d6682a65b6c79]
+print [92012387991456f019e4915a82ed28f04070b314]
 
  file "libtomcrypt/src/pk/asn1/der/sequence/der_decode_sequence_flexi.c"
-print [da4f77575e945f092eac6b6a44e9ec8f642608f0]
+print [8eec3723cb586f04c49a9f40f3eabcb13567c7de]
 
  file "libtomcrypt/src/pk/asn1/der/sequence/der_decode_sequence_multi.c"
-print [33cc8437a6b7ffbcafc4901c22dad07e56ab2426]
+print [469f6082ae194620365653787e62f29d2e28b24a]
 
  file "libtomcrypt/src/pk/asn1/der/sequence/der_encode_sequence_ex.c"
-print [65312ff22d8cdabd40bae1028f58e913efcf61a1]
+print [678ca859bb26df9feba60d110cea8892bd5b0d73]
 
  file "libtomcrypt/src/pk/asn1/der/sequence/der_encode_sequence_multi.c"
-print [49ee077a0c1fe999f633921fe46711fbbdb512f6]
+print [1e3c3964cc0dea7de138ca5cf0949aab3494baa9]
 
  file "libtomcrypt/src/pk/asn1/der/sequence/der_length_sequence.c"
-print [8eaf09980633df9320168ef42ae832b17712e91d]
+print [437ff9e4d882b6904cc17121f3ef5d44bc05e20d]
 
  file "libtomcrypt/src/pk/asn1/der/sequence/der_sequence_free.c"
-print [73b1d70ffcbef885e8fca6c5dc3c2eaa09958724]
+print [4845556557f8a9a41ac291d20e033d6aac9078a9]
 
  file "libtomcrypt/src/pk/asn1/der/set/der_encode_set.c"
-print [050b4a15194de4e7abe57e74ba08e8b917502838]
+print [765f5f1e716617216a70c7d04bbfcd8fe70c869d]
 
  file "libtomcrypt/src/pk/asn1/der/set/der_encode_setof.c"
-print [d086044aca1e3524479d623a3f3649334ee90921]
+print [f15e1781cf8f6add45eff956081175fec86c1165]
 
  file "libtomcrypt/src/pk/asn1/der/short_integer/der_decode_short_integer.c"
-print [33262cd6b6cf3352ded66544341a66187ad0c98d]
+print [09183af53f026fde352ca6737f414c5f8fd7727e]
 
  file "libtomcrypt/src/pk/asn1/der/short_integer/der_encode_short_integer.c"
-print [fe13af091b1e3baeff7883936ae0521c6fce7c70]
+print [86aeb6a1a18f2e323ba67259cb4d471d1b836220]
 
  file "libtomcrypt/src/pk/asn1/der/short_integer/der_length_short_integer.c"
-print [69c3fa4c891967a2ff207693f5aae7eb1d7fe2dc]
+print [9f3b2d3268ec72d66859c9e459edaef2dd35e34a]
 
  file "libtomcrypt/src/pk/asn1/der/utctime/der_decode_utctime.c"
-print [a95ad694d8d58aa32ef170f571c80d801c5bfbe1]
+print [8ce756402b88b4220fdc19eaad8f83f97daebf6c]
 
  file "libtomcrypt/src/pk/asn1/der/utctime/der_encode_utctime.c"
-print [2524a588c1a0a9d3aa2ad2fa50a69ef51daea7a2]
+print [9b7f69ed0bfbe8520a1d6fbe4ccdbf84a1be9c9c]
 
  file "libtomcrypt/src/pk/asn1/der/utctime/der_length_utctime.c"
-print [392a917d9656c3d93d925a0fe5c653d8b8b42c06]
+print [c73d9c201bde9d254220430a70cf66df04682fcc]
 
  file "libtomcrypt/src/pk/asn1/der/utf8/der_decode_utf8_string.c"
-print [d20dd20596510efd0b23457568124306dc724389]
+print [ed7b1c119f0335d254a92f2af6d4f47eaca2e312]
 
  file "libtomcrypt/src/pk/asn1/der/utf8/der_encode_utf8_string.c"
-print [5c07ef184b95f22f983d0812c91b13774832f9c5]
+print [d0915df7b4d65796625df2d9d440a0b2f127242f]
 
  file "libtomcrypt/src/pk/asn1/der/utf8/der_length_utf8_string.c"
-print [76f9858f803de064cdb3e72259c511bdc1d5cb0e]
+print [338d7f5f1094029692ea9f5bac7ee6542c119c30]
 
  file "libtomcrypt/src/pk/dsa/dsa_decrypt_key.c"
-print [44ed2ebbf371a25546783a4be120729aa4535983]
+print [2970ba0bebf71083b0adac7bc91388e09e992232]
 
  file "libtomcrypt/src/pk/dsa/dsa_encrypt_key.c"
-print [fd8f8f4998b545e97bca29c86d7f3408cae5d6a8]
+print [107ae43b40391cb5014d3954fe1740092481b9de]
 
  file "libtomcrypt/src/pk/dsa/dsa_export.c"
-print [12e1289fe1cf6b6c5fc0857d244b2ca20b5eec46]
+print [2d22f8fa44d5a57f0ac6090e0e15f2a6be481d61]
 
  file "libtomcrypt/src/pk/dsa/dsa_free.c"
-print [11bc5530ea2339443acc294e5d8395f0e44af78f]
+print [8e294a09e64750e244c3453dcd9f184b23418c6d]
 
  file "libtomcrypt/src/pk/dsa/dsa_import.c"
-print [f5baddd572eed9afb265bedef304cea840b89998]
+print [a0d277c1f0d2e6449109352dc690550149599d09]
 
  file "libtomcrypt/src/pk/dsa/dsa_make_key.c"
-print [b70e245d3cb7e1f2432a3035e8181288637d6d29]
+print [422c7c58f760d37a96d5bd563cbe98585f06efe1]
 
  file "libtomcrypt/src/pk/dsa/dsa_shared_secret.c"
-print [d86beaa9e9dc33528fe1258ec87a6c0cec7d82ca]
+print [227617ab7cc608322db0acd0502f6a7a45d63e2f]
 
  file "libtomcrypt/src/pk/dsa/dsa_sign_hash.c"
-print [2c3e705bc133d12d91109aaf57fa4dc86c905f65]
+print [d4054073eaa0b3bd3d9d4adfe301df00c9be21a9]
 
  file "libtomcrypt/src/pk/dsa/dsa_verify_hash.c"
-print [18c88c55ced88d84d0dde949f5761fad85ed60c5]
+print [486bf9100f8fa336e997afb20141462f24cadf97]
 
  file "libtomcrypt/src/pk/dsa/dsa_verify_key.c"
-print [52b6f3827c94c95aeac77c99fb08c8a4c0cab7be]
+print [179becc8a68ee8ed2a5e329ff219438101adfbf5]
 
  file "libtomcrypt/src/pk/ecc/ecc.c"
-print [604318b2e8452905e4d62160df1a7dfefbc1ecbb]
+print [e99f31a687db426d779494ba9747236681f1698b]
 
  file "libtomcrypt/src/pk/ecc/ecc_ansi_x963_export.c"
-print [0da27888f4f3e41c953482a5b997191c3e423a0b]
+print [58a32ca6278004718d97975cd8f0fda7b0da492d]
 
  file "libtomcrypt/src/pk/ecc/ecc_ansi_x963_import.c"
-print [75d5abe3bd12fa7dccb4e189720ad35bc1ea58bd]
+print [5c98badb531673f60108fdf96831e39c24ac12b1]
 
  file "libtomcrypt/src/pk/ecc/ecc_decrypt_key.c"
-print [1f7fe9f783056a06aa68f0d0f6a30fd962e4a55f]
+print [0f970a99f9bba55d067f72c2b7218bcbe942c12d]
 
  file "libtomcrypt/src/pk/ecc/ecc_encrypt_key.c"
-print [35dabd6f9249bc5c045e3be13604190437cc048c]
+print [670301f115512b7b5c01798d6dc6ecbe11f91cbf]
 
  file "libtomcrypt/src/pk/ecc/ecc_export.c"
-print [abc9328bd4b16c4d4de74871e8e69d1624c79b71]
+print [fa4645fad85a0050ecaeaf1b2cfae8e5224ca3dc]
 
  file "libtomcrypt/src/pk/ecc/ecc_free.c"
-print [33bf848e7fd0b5449c28878109430aa1325a9def]
+print [3697e14b200652ea224303da092caf06bee408ba]
 
  file "libtomcrypt/src/pk/ecc/ecc_get_size.c"
-print [d9191e20b221c3e7692e457115e832c237b277bb]
+print [4970d31d1ad7b8e0e89d8a7d959c79d51a9deb44]
 
  file "libtomcrypt/src/pk/ecc/ecc_import.c"
-print [533637e2750a1bd4ffb3037d3cf158413839bb6e]
+print [a84fbe23b8bdd44a62b3e4d37ad04711436439fe]
 
  file "libtomcrypt/src/pk/ecc/ecc_make_key.c"
-print [bac0d53c0b95e0dbb92cfd998e2d65c32abdd6df]
+print [8f73e046f52ed96479a387642ce0de8a84970541]
 
  file "libtomcrypt/src/pk/ecc/ecc_shared_secret.c"
-print [9caaa17e7a26893c1ad154cfa663a5ada6c354cc]
+print [97dd571c6713d243b359e07b355d68830859f8bc]
 
  file "libtomcrypt/src/pk/ecc/ecc_sign_hash.c"
-print [2dd9c9a563558a6b19356d365499b96403a4319d]
+print [07247a8b11cfe5e7569eac585e88f2a40e0859e6]
 
  file "libtomcrypt/src/pk/ecc/ecc_sizes.c"
-print [eb75a6f215aea7b783a7a3d9a43311420442b004]
+print [5622f305837e88271b569eeb22505e971a97a227]
 
  file "libtomcrypt/src/pk/ecc/ecc_test.c"
-print [acde9bdac59a48ecd1e56e38cb4128845ec3ad2d]
+print [49ff02d14225aadb6c10a360a602532bf661f960]
 
  file "libtomcrypt/src/pk/ecc/ecc_verify_hash.c"
-print [ffd155dc07d5f83467955d89fe609e53844fe335]
+print [d907e194f0ddd4f37609f10e53014a3f7b67860f]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_is_valid_idx.c"
-print [db4a49a47d2b216e43a395e84ca6af95b3d1655e]
+print [d917386a390063fa333f0c4892ad6f3d0348f153]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_map.c"
-print [d9f6f3e7bf15a4ceecfd6c85135ea4b8f7cbfd90]
+print [287d13153e70ad02f8416d307827101458a2950f]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_mul2add.c"
-print [29822abbe15006d3dada1d93181a10eb7278249e]
+print [2d1fe5e35dd0a3bc27e5b4a88ba1e370571fe18c]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_mulmod.c"
-print [f3f3e1a7fced55823f8507824d3b5d6accc25a01]
+print [3e8a4a2f7c26269feec4f8bd339ad2eb72fffa65]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_mulmod_timing.c"
-print [3983038a9258af284c1d8cc7b845152600f1b315]
+print [bb9f5b860b85252565b15255bdcf4ad577c041e9]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_points.c"
-print [6e862c1cf1ae6982921d473a87c3fef0ee4a15fa]
+print [148b00ecf1b05e7c722baaebbe581f8fb03fc6cb]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_projective_add_point.c"
-print [62d415cf662a7e6350efa05b5a7b70577c6d7acf]
+print [8326781b20f5f5f3d3de465463895089a6ee468a]
 
  file "libtomcrypt/src/pk/ecc/ltc_ecc_projective_dbl_point.c"
-print [e78b77220a1bf0e6279b72083aa93b96c6e6c5e0]
+print [a6099f52d7d1148738e653d721940fc516c3e55b]
 
  file "libtomcrypt/src/pk/katja/katja_decrypt_key.c"
-print [4ca7e89a8e8eacd36c15ce6d9abe3536bff8a83c]
+print [7caa26ee56ffcd60b37bf1116a408a3b30902198]
 
  file "libtomcrypt/src/pk/katja/katja_encrypt_key.c"
-print [f2ad348a9ad10c6e5acf3af38e7d537c361db7e9]
+print [4a816f6b7290b299b88d89dc910d34987952f058]
 
  file "libtomcrypt/src/pk/katja/katja_export.c"
-print [cea1690db13cdd9d711b95d7630ca7304b4feac7]
+print [67a23b138602608dd11805fe22a0a84f9c657a73]
 
  file "libtomcrypt/src/pk/katja/katja_exptmod.c"
-print [d1c1e6e4a66f441be6f478e88c1c6c52791527f9]
+print [8fdced911e8fd5dd0c88a10a0ef8a97d77e85585]
 
  file "libtomcrypt/src/pk/katja/katja_free.c"
-print [c041a5db8321b102a3594078591e9f78748a3357]
+print [fc5c7522212adca3c700b0d9f89541188ee766e2]
 
  file "libtomcrypt/src/pk/katja/katja_import.c"
-print [c8cefdd7eacc210144b213d2e7a20c5668639f54]
+print [52eb0f4da1838c35e2e380d78eaeec32541e9b31]
 
  file "libtomcrypt/src/pk/katja/katja_make_key.c"
-print [b0cf3aa689d7823442ac0b7939be29c5fc918c3f]
+print [2318e8a171d5b7fc6e3305b72df84087e3cc0cdb]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_i2osp.c"
-print [ec7f0af59e0094dbf5fd263f37f394d800952864]
+print [08817cf7b560a44ffe431907d3aa30f3caa7c518]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_mgf1.c"
-print [c2681c710051a20e843ce331fae62619a032dfd1]
+print [738eb69283ef08bc9eafe5921d0752d9bbdb5892]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_oaep_decode.c"
-print [e86d4f11f98e1e7bf7fe593bb5d017f595c7ba1c]
+print [007b36e957d54e612fc0786f25a3603551becfe6]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_oaep_encode.c"
-print [80942d4d1ededcec1188380ff4ece64dd782ea5d]
+print [e226bbe2b710f56f50f48aa719fcdfd13beb01f0]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_os2ip.c"
-print [b6ddc162e2bcef1f90f53c15f32c051cf6e00602]
+print [4c64fa3871d53300188a641aad3916ec3f2a0763]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_pss_decode.c"
-print [c02016215b120f41c51231cf9dfb71c3d3f55d3f]
+print [b576005d1dc05e6c2678201e34778b3e1fdbb69d]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_pss_encode.c"
-print [66695de9ebfaf61fd6ac7774166c1b62d6bda26e]
+print [2d8d7eb935cb0a27fb39e9df6b25058f1084621b]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_v1_5_decode.c"
-print [a13f690ca20b95bc24d9b8ec07eb67e0a219e8ba]
+print [a1f5561ae7f19dc39fd1656470f4495cbc6ecd67]
 
  file "libtomcrypt/src/pk/pkcs1/pkcs_1_v1_5_encode.c"
-print [fe29604080d4428aa720ff9613efffad120dedff]
+print [471df14e1298cb4192635c892d4b4fd2f8d02904]
 
  file "libtomcrypt/src/pk/rsa/rsa_decrypt_key.c"
-print [17b2da02bfd2995b4a5a18214c524105b71872e8]
+print [4023e9a544e7dc8c5f6be4d66e0009e53fbfc804]
 
  file "libtomcrypt/src/pk/rsa/rsa_encrypt_key.c"
-print [b09f4aa1b3d87e5a1aa4777126c1d4b48381b8e4]
+print [fdcbdb9c5a6a15f7232a4750c1a282b340fc4dfa]
 
  file "libtomcrypt/src/pk/rsa/rsa_export.c"
-print [71031b3d307c2ac77c937dfcd7f4eba8a5655d61]
+print [efc99125b1ee2bb7b91208247e8d1f2edba15bbb]
 
  file "libtomcrypt/src/pk/rsa/rsa_exptmod.c"
-print [0c0a2de2b5fe3d90b5dc65d800b5277db3ef5ead]
+print [42f2787eccc3d7341520af4f5a69c669db0bb7a7]
 
  file "libtomcrypt/src/pk/rsa/rsa_free.c"
-print [69fc70c5a4c3a000aa38df59d4f4275929163b0c]
+print [ceef2dd97585d76e94c8ed67522cccd3226d8f48]
 
  file "libtomcrypt/src/pk/rsa/rsa_import.c"
-print [3958c6d11504075db78a2fdff882b9c0d7a06e1f]
+print [07806a8e9b0b66c3f0e34851826b4ebdce86ec58]
 
  file "libtomcrypt/src/pk/rsa/rsa_make_key.c"
-print [d75e14642175f14ff27e4efdaa6703846fdfb729]
+print [ab2689b86eeca1f1a2eb9d6391c145b959ff1475]
 
  file "libtomcrypt/src/pk/rsa/rsa_sign_hash.c"
-print [bfb76e116ac7adb1133df7e7374ff59829bc88d0]
+print [68b2046cade479c00b7692a43cdbf8a9b28f09a2]
 
  file "libtomcrypt/src/pk/rsa/rsa_verify_hash.c"
-print [aab7d1b92770dde43e4068fb464b556ecbd3b070]
+print [4e79627119e50af274a3a059d2ad0d8f99aa77ee]
 
  file "libtomcrypt/src/prngs/fortuna.c"
-print [c43810b48cfc3518d6b613dd4a1ab4736c52ad86]
+print [7253b4caef070189ce32ab52129154bdb6733257]
 
  file "libtomcrypt/src/prngs/rc4.c"
-print [8cf9e34f5b74918b076e31bf285928cad1f4f485]
+print [cdcdfae77edb9f4e0b6a56cd2f4404207e64d626]
 
  file "libtomcrypt/src/prngs/rng_get_bytes.c"
-print [affc365fb683aecb24872617b63d147331612fbb]
+print [4f821f77f998f8db09f88a5d35b02bf208c0b1ba]
 
  file "libtomcrypt/src/prngs/rng_make_prng.c"
-print [7b1eea10f36cfb18c7e9102be4841c195763b158]
+print [66c1f879c7bd909321f147f2ebbc88bb7e7882dc]
 
  file "libtomcrypt/src/prngs/sober128.c"
-print [aefcb3d4657043ffb3787d265bef7f41ab860bbe]
+print [406d3c5401ef20c41eb71131324dc5e14578bd10]
 
  file "libtomcrypt/src/prngs/sober128tab.c"
-print [f8e819a082e763b79ec87b952947d10509e17d66]
+print [1f47edc6d5346b66cdec8c310c3063a9a08ae722]
 
  file "libtomcrypt/src/prngs/sprng.c"
-print [565b70bf544bdd2585cede22dcb86ba1b06fc573]
+print [d4cb416ec4692ab5827e16b212623bd3cd2b019d]
 
  file "libtomcrypt/src/prngs/yarrow.c"
-print [2ab801c79be028dfd0a4ad48ef267d3ed951ba05]
+print [7ce6e004bbf2590175e0c5f9330dbb9b0c57aebd]
 
  file "libtomcrypt/testbuild.sh"
-print [5c6d1481bf3df3d652002321654f74bf18537d51]
+print [ba5dafa475d7a905aee133f87ea9252c5b474033]
 
  file "libtomcrypt/testme.sh"
-print [a3d3a61936a215d3c88ea90aa4756a3449d5e5fb]
+print [792e5e5cbe73c815070b154d6262692dc7993796]
 
  file "libtomcrypt/testprof/base64_test.c"
-print [600a9c4fe54068d45b8da40cebef88195b081df5]
+print [115d6bdce442b3efa320a294d155c37d35158dd5]
 
  file "libtomcrypt/testprof/cipher_hash_test.c"
-print [f6caa490ec4d05ef998131681d0eeee643c1b721]
+print [16423166ccfa2ba5b51733ab186bb593af20ee61]
 
  file "libtomcrypt/testprof/der_tests.c"
-print [fdbdcb383c42e1812a56a68cfc51f6f82a66c9e1]
+print [7ec31651d3a4a51ef713a18d0b034618e13360df]
 
  file "libtomcrypt/testprof/dsa_test.c"
-print [c3d7e058846e8d528c4e87c3c120d191d6dff54e]
+print [79427687edcbcb50b76409435c6e8c3b322b0651]
 
  file "libtomcrypt/testprof/ecc_test.c"
-print [bfc0c1ed39180632b9c83dc79a4099ad7c520676]
+print [501378ef2a458a641be4f50fb5debb2aabc61a60]
 
  file "libtomcrypt/testprof/katja_test.c"
-print [b0b57e4065b70421026b26f5bfe9601c3b86dfbe]
+print [d1e0c391aff2314be321b25dade5cad2fcb4a49c]
 
  file "libtomcrypt/testprof/mac_test.c"
-print [db75f4c3dd4a3a073d9a55f1e6d613b504baaa4d]
+print [e5a47bc7906234846ef74eccb38307e6b35158a6]
 
  file "libtomcrypt/testprof/makefile"
-print [2855e59f94c0558ee22a1ec071f43473c9f95f16]
+print [6e4dccd996e346eaa4d846547dad2e6ddfdc4519]
 
  file "libtomcrypt/testprof/makefile.icc"
-print [4e33c90abca50c38b49a62addb9893493a6da3b0]
+print [2a838a705665eda82c95e5342eaa067db56415bd]
 
  file "libtomcrypt/testprof/makefile.msvc"
-print [1bb559c3b3f85b8252a8e0bd8e7da8aca05c4938]
+print [d3a0e82d45d80205e2ca5346d80527491cb6ff53]
 
  file "libtomcrypt/testprof/makefile.shared"
-print [edf5edcc2d5c2c48ad79edb198bae988f270997f]
+print [877f883e6b9fe3c6a0b84aa94879f3f546f3722e]
 
  file "libtomcrypt/testprof/modes_test.c"
-print [a016e6f4f61f533b0d1e5dc2de9fd238989fd187]
+print [aa64ae648dff3ff54e3e3ddd4b6ed0b1b4eb196f]
 
  file "libtomcrypt/testprof/pkcs_1_test.c"
-print [83ad3e9b0ed3fe3c87bec9005295d177cd78116f]
+print [6fa4a728ead5a2f7d9a8b8797ccafc36c87b02f6]
 
  file "libtomcrypt/testprof/rsa_test.c"
-print [d6759ff1455b920b4ee05d823f11ad30f4ff2c12]
+print [268874f16f8d0e5a0db3e085db697bdeca8ddcd0]
 
  file "libtomcrypt/testprof/store_test.c"
-print [53cb44cfadb9e247017f68162aee2fb5bb4ca198]
+print [8bf416449a93ccb0927c3d642f2d0f8e5e628d05]
 
  file "libtomcrypt/testprof/test.der"
-print [b59e5aed61f9516a9964f9f6c744a2a6b6e76026]
+print [baa95dd41c0a6dc5c441b3feb63a7bd2f0108caf]
 
  file "libtomcrypt/testprof/test.key"
-print [207453392b2292eeeb5c80c994f81d60fe03dbb8]
+print [e1e444c4a0d6db155232bcc0e6879891ffbf93d6]
 
  file "libtomcrypt/testprof/test_driver.c"
-print [0e48a3ba9135b97395e0901159f79608bab0dfa7]
+print [94e4061cd5326cc3a285a4a8745f2734539b283b]
 
  file "libtomcrypt/testprof/tomcrypt_test.h"
-print [8277a82aac961655a0a6bfb66ddea7eb7f05abd0]
+print [40f49dbdc58bb87afd610d4eb6b486a48919d597]
 
  file "libtomcrypt/testprof/x86_prof.c"
-print [e47ba0732b23a1f000be9335e37d286dadcf5429]
+print [a56b785b94dab939d606fdf257af9e28151e9eed]
 
  file "libtomcrypt/updatemakes.sh"
-print [ca3fb90145d3eb59dc890e1d871a408807ccc89d]
+print [2b77101c2f5dbe4737f2b49fa28739caa92d7920]
 
  file "libtommath/LICENSE"
-print [a38412533b934e71d31e67a7c4a48b002b45e7d3]
+print [7edb9961431e372714b778503cbc96151afff657]
 
  file "libtommath/Makefile.in"
-print [6e1e73405a2b15c476c3fa371a345275d580cd8d]
+print [5e0bf6e53d44ec1407fe5191ebf0dafa912719c1]
 
  file "libtommath/bn.tex"
-print [1195a142db19741be33587f40b14c77304b6e9a2]
+print [9237bedd242e5dc107fbe007945a90101adea449]
 
  file "libtommath/bn_error.c"
-print [8636a00e3a7879103bac20772f4727341b850281]
+print [ff5e99f5a31550498a9aa4363cfaf2f23bc83afd]
 
  file "libtommath/bn_fast_mp_invmod.c"
-print [c49cda9906e39cf58dd50d000e22d7864ee6320c]
+print [20e166478f80546f8f8e1bef1a706261203561e0]
 
  file "libtommath/bn_fast_mp_montgomery_reduce.c"
-print [7e1f048417df037ca60eb23578c43076ceb5a8fb]
+print [85ec804fbf0ca14b2b195f3435753f9794db0734]
 
  file "libtommath/bn_fast_s_mp_mul_digs.c"
-print [081b1c4a5049184c864b147ca9b1ee08a17087a0]
+print [a1a0ea7a1c8eecaaabf5225e7bf2e636e5973620]
 
  file "libtommath/bn_fast_s_mp_mul_high_digs.c"
-print [4ef165863e2891ff0ba44ca91bf1c54ce87da793]
+print [a6b1ec98fa6c989ad01f68634a6e8b5dd4f47621]
 
  file "libtommath/bn_fast_s_mp_sqr.c"
-print [02a77e23dcfefbcb9fb30c5b22a78ba7dd2df07e]
+print [d51c51dea94dfab2e66c4c99cf5e5100ef8861e3]
 
  file "libtommath/bn_mp_2expt.c"
-print [03fff1e51e7208700ab65391d1f5c9076e67cb78]
+print [1c61279c0db4e26a5f99c715d9baf14600036cab]
 
  file "libtommath/bn_mp_abs.c"
-print [a65a1f498ba20db1a88737c44ed3a3119d852d65]
+print [d3fc01e8b21fda02ff4a5bec9538ad33f079b896]
 
  file "libtommath/bn_mp_add.c"
-print [c9bd9950c09c5b5a91dcb1e61a3e38760024bdf1]
+print [13fe21fbebaef6c2feca531646eea5cd5609ae99]
 
  file "libtommath/bn_mp_add_d.c"
-print [00f50a67fff766bb30610d84064a6cfe77eee440]
+print [8e2280ff2ed9f53ef46f54e37e5f39261193ce0a]
 
  file "libtommath/bn_mp_addmod.c"
-print [083454f1f6e35ad65da46270cfcb6a1a387fde80]
+print [24aeeb98a6296c82f890c2292497cfc5c49be56e]
 
  file "libtommath/bn_mp_and.c"
-print [d1ddc4ab5c71f2a056f1779eccbe5c7b732b09fd]
+print [5a62221bc5d297edba5ba07cba77233305555acf]
 
  file "libtommath/bn_mp_clamp.c"
-print [f5f0ab23f298b00b5f291d3bb8875af643b3931e]
+print [7e87762969b4f9587ac90c9d838760d66a9837fe]
 
  file "libtommath/bn_mp_clear.c"
-print [7b04bb16af535ff39c547b9091a649aabf6dca75]
+print [3238d67730f6e3560aeedce7d4d91442c9fefa73]
 
  file "libtommath/bn_mp_clear_multi.c"
-print [b4209be20604224843563a9e7f0fa357360eb749]
+print [e1866360b87c766b053e9d494c6c62c28a5bd6be]
 
  file "libtommath/bn_mp_cmp.c"
-print [57e4859ec81b15f8a2e1db801947c7a4c9d37d85]
+print [9b003a11d098fc0090b96598583271a3531ffd8c]
 
  file "libtommath/bn_mp_cmp_d.c"
-print [14430b838cdf612bb225fd375ff4ea49da80f594]
+print [b3897ca50417c43a9db15c4084bc5a5024b82e8f]
 
  file "libtommath/bn_mp_cmp_mag.c"
-print [4265f4eeb0e1c7ea0ab893f30879bae55c708656]
+print [c8411e06b6f23aed22f49301fbff18ff8da04da2]
 
  file "libtommath/bn_mp_cnt_lsb.c"
-print [ffa47d4311634dcc1186404277c88a4aa87335ef]
+print [21b653e059651c03fb1d478cad32a4d304be39d7]
 
  file "libtommath/bn_mp_copy.c"
-print [3f5d6d623a29618fb7fe7b0a3ddbf8c095d1555a]
+print [74f2c3102639906fc0336a022212e31628444e4c]
 
  file "libtommath/bn_mp_count_bits.c"
-print [da9328c113650016eb0ac73ad44113a2ff5bbf21]
+print [0030947352f13f15df891558fc9c8d1fa4302b7b]
 
  file "libtommath/bn_mp_div.c"
-print [d52f3fd926af26798736939efba18b94e5b5f8d3]
+print [6795cc56a35de28b59c72b9ab85be37794ba05e6]
 
  file "libtommath/bn_mp_div_2.c"
-print [c4e40464eac41d30264468e9407758b8e79588b2]
+print [4c410579916f7adde165d1e630d9d078603c99fa]
 
  file "libtommath/bn_mp_div_2d.c"
-print [b55726390c4835a12bd74272ce346e41e7124657]
+print [f5ddecf52ca72b8faf154f1a369d413b1b19b1bd]
 
  file "libtommath/bn_mp_div_3.c"
-print [3b995c87b3632299155ac9ae435c11af3fc3de61]
+print [132d8938d8ac6a8e9172a4595dde4586b7b5b6dc]
 
  file "libtommath/bn_mp_div_d.c"
-print [3976fa0ff4b6e7028e4e59ab00100cf88932f521]
+print [201756fafa343c79763da4786f0adfb89ae6b2a9]
 
  file "libtommath/bn_mp_dr_is_modulus.c"
-print [98e70c9e79bb3d390981ad906f1fe475ea3602f6]
+print [9d193a8599976e809fb955ac21abcfcac765ccc2]
 
  file "libtommath/bn_mp_dr_reduce.c"
-print [f0586e772785cd97e2e12f4eb9299cc525706324]
+print [1c71edc1f81691e980ab33da087c8d56f58bfbb8]
 
  file "libtommath/bn_mp_dr_setup.c"
-print [2cfba1f0526fb60f27b9d695f4d6af2c030325a5]
+print [ba6560cd49de5bd7a88aa607b5eb7ae33ff2e7dc]
 
  file "libtommath/bn_mp_exch.c"
-print [93d7462f896ec40953d7f3894fc9755818f3a600]
+print [f54ca69d573ca46dfe48b35bfddf624d930d46b4]
 
  file "libtommath/bn_mp_expt_d.c"
-print [aa56e13101e689d7b96c010d778a682870dfcba4]
+print [7588b4fa65ac0e4ad37a498dff31214fea311057]
 
  file "libtommath/bn_mp_exptmod.c"
-print [e11b12129600a940b933c887f5e17da5020ba71a]
+print [c7de35bf45fa23414ff9082dad9ecee6b3a161f3]
 
  file "libtommath/bn_mp_exptmod_fast.c"
-print [9f5a15f1662f2acfa9b277202240a204995b4957]
+print [496251a111890909d8c61251290455608838f953]
 
  file "libtommath/bn_mp_exteuclid.c"
-print [ad960d79e1a42d960c24216b787a3f9c4aac5743]
+print [962dbe0e0336faa89e73a7a7d17157cb070d6e69]
 
  file "libtommath/bn_mp_fread.c"
-print [749c4263bf040ec0db222fa8ccb8c4b433679543]
+print [21d2bb5285419a800969709cb5833ac083b38752]
 
  file "libtommath/bn_mp_fwrite.c"
-print [5b46e1db7c44d618d6292197aef84a6b14a24a27]
+print [4d5da5ba74565cb25bc6121d0efafdec890e1464]
 
  file "libtommath/bn_mp_gcd.c"
-print [5b3b7b2191719e65519708f45b5774ef8262a306]
+print [9e7ce752dc179d75e82c0ad9cee60180388c0536]
 
  file "libtommath/bn_mp_get_int.c"
-print [4ad49fa7f5e64a6344f602c1ec9bc173c8b5b853]
+print [fb16b553a2bdfc48f0846888a5f806edff5d981b]
 
  file "libtommath/bn_mp_grow.c"
-print [46ae1a430200af517f1327477b61f92bb1800206]
+print [2b605b9c5386090c1a1195cfb27fcd09fa57309b]
 
  file "libtommath/bn_mp_init.c"
-print [8836854594cc80e818290abb3bfb269ae8a871f5]
+print [9b68719659d4385b998f5fbfe2268d146ea793b6]
 
  file "libtommath/bn_mp_init_copy.c"
-print [29d1508a15f21802fb326bee596e8a7b59c5e475]
+print [1356ca6945470af6e8b2a1471d4ef08c0ad211a5]
 
  file "libtommath/bn_mp_init_multi.c"
-print [f2677f3def564a4a01982e9730100e850670e340]
+print [a2dbc3d61e30b6d9092f9124a62fd45f5dd1399c]
 
  file "libtommath/bn_mp_init_set.c"
-print [b579ace6eaa4fe3c2e46aa4aad73187c15646357]
+print [677157b58f546ed883dee3010f69c8e01f35ceb6]
 
  file "libtommath/bn_mp_init_set_int.c"
-print [6df9e5b31714c40ae696626e6ccf44dafe4892f8]
+print [0b42b928a54c75aaf6131fc5f6790ac3cc778433]
 
  file "libtommath/bn_mp_init_size.c"
-print [87b3ed544fd358ecde359ca8e59979dbf7a4bd88]
+print [995d8ac6fefdae76926cf6d917953919e1479d75]
 
  file "libtommath/bn_mp_invmod.c"
-print [e2ac512d9d46a2b8c69c48dd9146c5d1d0955cdd]
+print [4a86d12fd83fd8f2c1d306129f0505d7742b4045]
 
  file "libtommath/bn_mp_invmod_slow.c"
-print [a195ab7c54a79a80ffe4304f3898d9a96401994f]
+print [1fb47bad5728d3936be89fb06e6d1b46734e0ac9]
 
  file "libtommath/bn_mp_is_square.c"
-print [987863aaf451253db0c90cf961f8448aadf251c7]
+print [439d9aeb3f6061b35f9977e6fd940392e6116cf7]
 
  file "libtommath/bn_mp_jacobi.c"
-print [db67e74b7046a87f8ff6d260b6826710e43ab9d3]
+print [18acf5f0aa2da98f86010a8a2a43da6af63ca2a4]
 
  file "libtommath/bn_mp_karatsuba_mul.c"
-print [e1b8fb0ba69b1730e7de7d4112b61b77f088d9ea]
+print [9b85e9a85e5cb64ad41da4370ba072278a1d4130]
 
  file "libtommath/bn_mp_karatsuba_sqr.c"
-print [8a35d3ad2474ef393f16d5f329a69ce54a677274]
+print [dca68a04368747700436902d944c65a53cc009a5]
 
  file "libtommath/bn_mp_lcm.c"
-print [82243f1d54d6e571526d49ea9daf9dd74b3fe882]
+print [35f6e2dad02739f3e0fc1fc419ba02258c6d6232]
 
  file "libtommath/bn_mp_lshd.c"
-print [1082d6588edc920441b24bde233cc00cc8b43d98]
+print [47093f829ccfeb5d2936ba1cece23667166dca93]
 
  file "libtommath/bn_mp_mod.c"
-print [e69a04cad32e7c6d8f30ed786d582320f3968078]
+print [a65fbc3cd227b9ee511c7aaf2354b139df764e97]
 
  file "libtommath/bn_mp_mod_2d.c"
-print [65929f4551c5c9dc099091483271e674e766608e]
+print [3540ab312737fb58173e5ffea7b27e18a45006f8]
 
  file "libtommath/bn_mp_mod_d.c"
-print [790447eb42728d5ad053a16ad0c946b690a9d6fa]
+print [5d25d9e7dd1b7b5aa2cc45d7e7a21ad5882fb809]
 
  file "libtommath/bn_mp_montgomery_calc_normalization.c"
-print [61f6a20ac2ced2e1272b0cce51d9cea38c8310ad]
+print [a6041857d985a2199bb4b0cd8a31e16350fc25db]
 
  file "libtommath/bn_mp_montgomery_reduce.c"
-print [b0c43097d7b6680fe352bac344998d8998b00842]
+print [d509e91c75cbb91895016cd8112aa1d12f8c0504]
 
  file "libtommath/bn_mp_montgomery_setup.c"
-print [41e48ec5acaea9e40ae2deb67e8ede05f3c86cfb]
+print [ed734c585c43b00095e330df8a00df4e6aab3d30]
 
  file "libtommath/bn_mp_mul.c"
-print [5ca42e3057ada98414e1cfb230c130c536a065d4]
+print [e2e6cdad4fe9611591739bd76947e92a3073ef6e]
 
  file "libtommath/bn_mp_mul_2.c"
-print [d873bde6d9b9bc41c6202b62af63c3ffbc041262]
+print [1185c20ca1f60caeefea45f303a3f87e4436ef97]
 
  file "libtommath/bn_mp_mul_2d.c"
-print [b2653d40ca343ef6c0debe5c19ef1c900f352c3d]
+print [f5a1a7c2221c7b22db964aaf8992a008194c3455]
 
  file "libtommath/bn_mp_mul_d.c"
-print [0a3347f86fb8658ac69ceecdc611e956af01d97b]
+print [4d46bd75b72feff97742110427ccb19b1e34b529]
 
  file "libtommath/bn_mp_mulmod.c"
-print [bab85cbd076c77d782929487124985a6b805faf0]
+print [9a6ed3fc6a10b8641503d6f6c9f9cbeaad3bcdc5]
 
  file "libtommath/bn_mp_n_root.c"
-print [1eab50d0efaa54ad494b765d2ae9342b4c5f54db]
+print [990633d11f6d253fbf2ae4817dcbb8f498604be1]
 
  file "libtommath/bn_mp_neg.c"
-print [9aef1e69bb506fe7f2c2f85f820185d0f2c55e7a]
+print [33b63e47c7e7cb75de8d64dac609ae15b9a53c9e]
 
  file "libtommath/bn_mp_or.c"
-print [92198379b0402737c021fdccada0b9d96c41c704]
+print [817c80e5b8103cbefd9b4462f86d67f7f84f1116]
 
  file "libtommath/bn_mp_prime_fermat.c"
-print [7810d5f893f03090e577c70c2e7098a78109a657]
+print [887e6e1d4ecf6cfca9711d0e56f555c95bbd10d9]
 
  file "libtommath/bn_mp_prime_is_divisible.c"
-print [697978f40e15f1cc90bcc1ad3ed0c2134da409f8]
+print [5a4e146ed5588ff1ef12cfcbb0ea965234f60bf4]
 
  file "libtommath/bn_mp_prime_is_prime.c"
-print [938dc7a563fed31e3d564020aefb14a3a8f79c6c]
+print [b6ad64b93398472359e354793f9072163f08ae64]
 
  file "libtommath/bn_mp_prime_miller_rabin.c"
-print [81687f13a07e026daeccd9b6dbfc4a7696986907]
+print [c51e9c086d4d77620d6158dc35bfce94a9fb0c44]
 
  file "libtommath/bn_mp_prime_next_prime.c"
-print [8ddb19279152663f97839ad7fbffe182b1934023]
+print [ff91351aef282ce345c27d80e0ae722b78fb45e5]
 
  file "libtommath/bn_mp_prime_rabin_miller_trials.c"
-print [9a1186a91c77b12b2fb0ddf0ac8a26abb143b246]
+print [05f2c628110d9da898af30e1bf42a6b721aecb83]
 
  file "libtommath/bn_mp_prime_random_ex.c"
-print [eff826383f0589f913770eb7f3bf27c3687d3e65]
+print [5b9e1699a54ac630a54b817e62fcc654080589b6]
 
  file "libtommath/bn_mp_radix_size.c"
-print [deafdb7551f1d7c8e93e8d6cd7fdb66cce00a239]
+print [7b76caee9662dcd59c7ad309d96ab57738aba8a4]
 
  file "libtommath/bn_mp_radix_smap.c"
-print [ac1d554b59d0f07d0d5a3efc6ce535c6f781c659]
+print [7c1e70679cc1e67876b134dc9e7e981302dfdf66]
 
  file "libtommath/bn_mp_rand.c"
-print [f9a85f69719e243de545c1557bd6906a60c01a7b]
+print [228c1edb9553ab08210836039116594d0b7558c0]
 
  file "libtommath/bn_mp_read_radix.c"
-print [ec0ea15e5f2b06fc40ab16b9dbf6b8d9e9a6996e]
+print [c37e2e0879407969ae9ac54eddd3a47169b799e1]
 
  file "libtommath/bn_mp_read_signed_bin.c"
-print [0a9653a152ac9ecee71b9bb5f63c8d2840b79ce6]
+print [66f7bb0af22b6f058c3e9ab042bb181038193383]
 
  file "libtommath/bn_mp_read_unsigned_bin.c"
-print [644a5282cf7aa9b632e3ddf6af17be53d35705d0]
+print [dea7a1b8a24d674a7252f015d32279e4c46e42c3]
 
  file "libtommath/bn_mp_reduce.c"
-print [16e3f1bdf57b29ec7a6d7e6c61ec2254ada58a2a]
+print [6df3e4be1c70b2904c40c4788ea5f31add6fa09f]
 
  file "libtommath/bn_mp_reduce_2k.c"
-print [0b77f3f4c229742d53d52ad6fa4f6dbd0565079a]
+print [4db7dd0c4e993b47244bc1be65d3f767ef3a9bfe]
 
  file "libtommath/bn_mp_reduce_2k_l.c"
-print [3ead739161a2988a2c929cf227f36e018946f9ff]
+print [ef3b8864e261e55e8a653da967c7514e3395a0e5]
 
  file "libtommath/bn_mp_reduce_2k_setup.c"
-print [0f4b757d7a37c23a4157e13ee4d9a86e641c33ea]
+print [11a637d04fe38ec0b84f7e495dbb6e4fe0866777]
 
  file "libtommath/bn_mp_reduce_2k_setup_l.c"
-print [ff852f8ee12d26ccd181f76c5e1ae2176d22bfed]
+print [75f3afb2767b17738bd55d8b961bc6706bd6f02c]
 
  file "libtommath/bn_mp_reduce_is_2k.c"
-print [4abf618b6b8b5874a05418ca46292f8b144c7976]
+print [73ed1d12de000fdf83a4229ccbf22770329eb16a]
 
  file "libtommath/bn_mp_reduce_is_2k_l.c"
-print [8aaaa50f7aff152309681616565a16ef0dc33135]
+print [c54b300bcf26ef2d908a8601b3ce26c0fded9dda]
 
  file "libtommath/bn_mp_reduce_setup.c"
-print [f9fec4174d52b832a9778a943fe9a08209d2d1c4]
+print [2491709fc0244b806c6c1ee93e9ce0d12c314ea8]
 
  file "libtommath/bn_mp_rshd.c"
-print [bd3443e61bd6a3277007b8f1c7b4a43a9608193c]
+print [ed5d4b6334218b2c91c9d52c61704a86f3457208]
 
  file "libtommath/bn_mp_set.c"
-print [d98695944deeea17aeee4bb61baabcf760d2c669]
+print [dc433adc83d60898b1dd553d0d8a79d178abf50c]
 
  file "libtommath/bn_mp_set_int.c"
-print [80411442379c38e19db1c17ddbd27f6a14201aab]
+print [fd26448af1c9de88279c0a09961617a26c2fc208]
 
  file "libtommath/bn_mp_shrink.c"
-print [559a466f5e8a50769f25ee4a3a14f9c133dd1a9a]
+print [1da3dc972d3d1d429eb98599f027d3dd0b1a8347]
 
  file "libtommath/bn_mp_signed_bin_size.c"
-print [456762eb6f67aff01738ae6740d35a5b4815d6ad]
+print [943227977acc6adf6be93d3fcbcd15e880c2ba62]
 
  file "libtommath/bn_mp_sqr.c"
-print [88004bed14f17db52761cc9f581b6c39830acb9f]
+print [e108f9058ebebce8d5d62ecb31c48db3652dc739]
 
  file "libtommath/bn_mp_sqrmod.c"
-print [b02e9dfbf45ea206fec807fff90b01a575a0bd1c]
+print [4c40df14fa8b0aec732f4c75e0544d4b7e5d7042]
 
  file "libtommath/bn_mp_sqrt.c"
-print [fcacf73fb8cad57285ff93c27418ad446771f1c8]
+print [96210b05d3f4a2b0d7229a312d1354d7a6fa9855]
 
  file "libtommath/bn_mp_sub.c"
-print [1f258496cd74757ac8c5f1945ce1250b19a3f7a6]
+print [a7ef6acea80a9ad0994a9371c82585f8a89359b9]
 
  file "libtommath/bn_mp_sub_d.c"
-print [4f805a39f7054ccd9e67f54bf8d37c400450d71d]
+print [6844681194265ad82f149e12105c8ac457e142da]
 
  file "libtommath/bn_mp_submod.c"
-print [6daada40e8f29a00ad35465edacba26f85d5bbcc]
+print [c6924d656de5c46aeca875062b55f518bff6619c]
 
  file "libtommath/bn_mp_to_signed_bin.c"
-print [17af4ccae4c60d215f4e3b8dd9687e0bb1d97e22]
+print [d04f83acf9b9b9fd197c11afe2759e3dca821c77]
 
  file "libtommath/bn_mp_to_signed_bin_n.c"
-print [3f2f1db0ff1d1ca09784404553c7807465530139]
+print [a51532183003f0384b6c2adc11ba535d534249c5]
 
  file "libtommath/bn_mp_to_unsigned_bin.c"
-print [522ed6f360f4267b198a91898295233c53adb79e]
+print [fd668b5fb37e7a82f3125e08d7b1bdf870859ec9]
 
  file "libtommath/bn_mp_to_unsigned_bin_n.c"
-print [3975a2f9d1461394cc911ef7d52425d9b045eb94]
+print [d51e2c21cef343930be47eb78c0de8d177ccb87d]
 
  file "libtommath/bn_mp_toom_mul.c"
-print [54c278bac711c432f0a836e06313993da6d20539]
+print [392f47d22e2c34d44f4947582a4af7ce60ebf155]
 
  file "libtommath/bn_mp_toom_sqr.c"
-print [9b2dc9838ca48b9946a1ccf63a133af435264b7a]
+print [0326f027c18ab9cb938436d0cab3d80922c058f4]
 
  file "libtommath/bn_mp_toradix.c"
-print [ad889ce39ef92326ba9c3eb9c96c2fa8098e9be7]
+print [406d6aacd847c499db548955656eac4f806717d3]
 
  file "libtommath/bn_mp_toradix_n.c"
-print [840b5fff90741bfd1258b7eb998a0eb36bf99a21]
+print [5902ec6d603a5891dc11121290ad7d9fc0efc6bc]
 
  file "libtommath/bn_mp_unsigned_bin_size.c"
-print [51b268fa63076f319f2109daf13cfff00cebbdb9]
+print [3d4832ee093cdab439bca44db641c0b77443dc00]
 
  file "libtommath/bn_mp_xor.c"
-print [dcf17cb884a11e6e361846e231515870527461bd]
+print [7398fce82ecd81b43a22a3e2ff35124314fec16b]
 
  file "libtommath/bn_mp_zero.c"
-print [85540769370b566cf9c7806189b758243d15fffe]
+print [d32559f8cd8f246475052d51b1ed60d2620fc1ee]
 
  file "libtommath/bn_prime_tab.c"
-print [257fd57b8146084b10513bda680b9608d0d75b15]
+print [c2f77b86bcf47ca8ea1d0428ef3ad54615d1f0cc]
 
  file "libtommath/bn_reverse.c"
-print [e0e88b88eddd3efda8dff60dc5e62dbc7b8b2f28]
+print [ecf549bdb08370a050c17c0838a72f3904bfa73d]
 
  file "libtommath/bn_s_mp_add.c"
-print [1e7027c338a6c6ba090935133a39ed6e4c0c4f99]
+print [cf4cc9d52a014deabcf61975b63589accc835c87]
 
  file "libtommath/bn_s_mp_exptmod.c"
-print [fb9ff114393c3c069ce8647025a663ab88d0a7c8]
+print [143f82ce5d3f0d6a98023d30d8ac48ecc5302cb3]
 
  file "libtommath/bn_s_mp_mul_digs.c"
-print [3f94b5648c2e16fb0ff98e782b2dbcd28be8e5e3]
+print [012da395466c4c4e0997dfc28e122076b11f169d]
 
  file "libtommath/bn_s_mp_mul_high_digs.c"
-print [da74d9ef9d7c5b88751cdd58747ece3fe83ea81b]
+print [e792841b161e3bff06f55a044dfb8ba40d691193]
 
  file "libtommath/bn_s_mp_sqr.c"
-print [478023cbef8e9b6ac3b044a410ea7392a5cdb6c1]
+print [a24725b9b78859439c15ffae3d33123cee3aaf1e]
 
  file "libtommath/bn_s_mp_sub.c"
-print [ada2a91a614136dc252b79dc33cfff1537eb2d36]
+print [93f32b523c4d0926969091f3f45c0b4460a7d042]
 
  file "libtommath/bncore.c"
-print [0504dd8ed9cf38f51a1e628fc7dc447bc5d40463]
+print [61352b5224690db23c6c7e9d8fdd16bdf9518a4a]
 
  file "libtommath/booker.pl"
-print [289d267a66a8790bad7be7ecd56d41914a8146be]
+print [1ec0b1c643fd40c16c68092cde1f4cbd7ed58c6f]
 
  file "libtommath/changes.txt"
-print [bdadd1cdde215977a98961d973d78c2971495a92]
+print [77a11208aec94d5501d192e5d42879fb1693a9dc]
 
  file "libtommath/demo/demo.c"
-print [74118d9fd833dd358e1ab712e6becb62d4e2e47b]
+print [7e94a3977447f74a781a4059b4bebaf5e7b9de3f]
 
  file "libtommath/demo/timing.c"
-print [5814b318b4a64e42efc3ba1280659163f545dc11]
+print [337f4f351c5e24efae2af276af70c095267e0cbb]
 
  file "libtommath/dep.pl"
-print [70bec2a46c7168a5f24e9047a9b65e91e636a6b0]
+print [02d6111735c7203646de4cdcc7d39dec2f9cd75d]
 
  file "libtommath/etc/2kprime.1"
-print [6249e1cb779c6b654a22d13973f4cfb6e20a679e]
+print [56729fdc275a91863424c159d46c3b9e816478f0]
 
  file "libtommath/etc/2kprime.c"
-print [3d624b8c57109a24e8625d0f52fc33f602a082ff]
+print [97d13f54c2857d857156e0c03a2f997428d01461]
 
  file "libtommath/etc/drprime.c"
-print [0d84dd013a5c0ac77b69dd8ffbb18bb180e7b48e]
+print [1570ea62430a666cd627ae18ba598b99d7ab1a47]
 
  file "libtommath/etc/drprimes.28"
-print [d0e2459e1673de6eea041984434b7b7cf36d64ea]
+print [c9743adad5fce9148bc4618e43c979f046cab6d9]
 
  file "libtommath/etc/drprimes.txt"
-print [4cf49502769b0e77330dcf6a3c66e81f81c7b38b]
+print [0b39399dfbdbff8b8e55f5862c9b924479548807]
 
  file "libtommath/etc/makefile"
-print [ad11cab7c3caf79a55c09ccfb899d8731c90611d]
+print [69b111045865a730e0f2f7769d77653804a8935c]
 
  file "libtommath/etc/makefile.icc"
-print [a62b278ee674219c9cc3b5a72b1ad29b4fec5abf]
+print [58726d19304e656105e185128e20d3cdd6423b30]
 
  file "libtommath/etc/makefile.msvc"
-print [52953331e28e6a95c8cecbb1641a3adfd94e752e]
+print [2fe32adea0fff6f05e3749803fda74f82d1a6f69]
 
  file "libtommath/etc/mersenne.c"
-print [c089530968666144004a1505b6f5eed6f68ce061]
+print [9867bb502fcb5341018c02ff7fa233b6f5acd05e]
 
  file "libtommath/etc/mont.c"
-print [c33744e9e1e51afaadc2f8a49b8d4476f9cb7183]
+print [76fc5e2e8508c70ccc4a5af2f6b9cc861a5dddfd]
 
  file "libtommath/etc/pprime.c"
-print [15acffa610e139b1a787419269efa89c55d3a72e]
+print [02e7134cd2494644ab4eaa09d5b04e062675ed03]
 
  file "libtommath/etc/prime.1024"
-print [808ad0a23ef5565bfd929ccc954ef1b0ea77848e]
+print [6d94deee3f3230b4251bef2dd35d71bc94b70f8c]
 
  file "libtommath/etc/prime.512"
-print [6a00ebeac6b51d16836184ba332c1c16d01a3e36]
+print [b0f6d31ede0f7dab95ba98cd5e3ca974c6e114f0]
 
  file "libtommath/etc/timer.asm"
-print [d4985748f05b97ab70469f91a39d6b1d721b313a]
+print [930c5f398ffe6821b910e36bb12a26c7f9a20bb9]
 
  file "libtommath/etc/tune.c"
-print [a819c956aa73f0fbd4563b5d5c63bce6fbb75156]
+print [2be8fb956861e12cebbf952eee81e263b2845d7a]
 
  file "libtommath/gen.pl"
-print [45be2aa7cc21e13d7a3e20332744e4ef7d228f8b]
+print [1ddabff8b5b6bc491901510606ffeee3b43307f5]
 
  file "libtommath/logs/README"
-print [19a880d7d2e1373dabac0dcf379cab9cd2f79e17]
+print [d5370acb0dfb11edf195462cf60ffc0605f41105]
 
  file "libtommath/logs/add.log"
-print [3863dc9918a41ec2ce2b1cb8ebe4e04f0eb9851f]
+print [0c9ac4bcc67c65888929c90c50d392c23fbe0b03]
 
  file "libtommath/logs/addsub.png"
-print [0dedf6973d431d79bd2661daaebf5f76078384dc]
+print [a89c2c93ed3c2421238c585e7d58b35e106b8538]
 
  file "libtommath/logs/expt.log"
-print [ae4f6c49ad9afc43ffb189ed5f814d51634c8a71]
+print [e7c8b63a5cf8c41de3293f62c23f01e724d64b86]
 
  file "libtommath/logs/expt.png"
-print [dc86bb4dd877728edea2cc0969cc65da1589d876]
+print [b3219ade31173e90e03da16a14d03b0291103021]
 
  file "libtommath/logs/expt_2k.log"
-print [ae4aa214990fd27eb24be323b9870666c91fec3e]
+print [2dcbe3d8d0b9833fbc8dbccbbee390d7287290a1]
 
  file "libtommath/logs/expt_2kl.log"
-print [f9d919aa7a73d626d690c9ef1cf1f99cc7908146]
+print [2573e3d0b5997590e0e5c5c7d87493f40b334688]
 
  file "libtommath/logs/expt_dr.log"
-print [8b280f616f4126929cd9be58b5ce3feeac5650c8]
+print [de7db7b1027d66e6a53efb7f18d598fdfdefcf21]
 
  file "libtommath/logs/graphs.dem"
-print [2046fd51b3e3e06e76606cf39608a7ee8f68b77b]
+print [27d9167011ffba8d28ab66e7a7510451ab9e1ea3]
 
  file "libtommath/logs/index.html"
-print [52e4291cd6777fcb5234283b229dd8808898b2db]
+print [74aa6615973041887a409b7b95e2ffd1d9620808]
 
  file "libtommath/logs/invmod.log"
-print [e9aace3a37d85ffd66b31551a1a196778f2c996c]
+print [a884cc5edeb2cd8868745a4c0b69ca5b783aaba6]
 
  file "libtommath/logs/invmod.png"
-print [2beb9d7903ca392f9719797d3e1936a34e28fde4]
+print [e161774975fbbafd650c3a13a7f860c96b6ec189]
 
  file "libtommath/logs/mult.log"
-print [94b12a53e7eb3c97de5ef76b57642c21a874ff00]
+print [fd4c07d7b784baa76039559e8e63c7988dd59c3e]
 
  file "libtommath/logs/mult.png"
-print [29d722c5f094d9d75cbe5ab4573e35e4abdb5b7c]
+print [3988f4cd7334b2486b00d19b8c5db8fecfcaca83]
 
  file "libtommath/logs/mult_kara.log"
-print [097f0667b43b3ef48137acee2b38f6862d369720]
+print [8d730c8de1beb3ba3e6e0230f86355b2f4ff727f]
 
  file "libtommath/logs/sqr.log"
-print [5c3f1199f076b45846091bd7b9033b4d92c398ad]
+print [26b242c288d4b07b7299f1a3dc1129a5a7a3b61a]
 
  file "libtommath/logs/sqr_kara.log"
-print [e3b68fb7b477eeecc8291892a35be10544f6827b]
+print [77e9a0b2e11fb543fc96f677e2820130e0a72de2]
 
  file "libtommath/logs/sub.log"
-print [9a5098fc8f7e58b67538bf8c33a5edecfdfdd30c]
+print [7928bfda67f3dfb8a2c641b28ab7a3d0bbaffdfa]
 
  file "libtommath/makefile.bcc"
-print [47ca462f1057b47ce9239a241393c367e616a0fb]
+print [99b4c1834e85a85dc69850b99834b8fedd78e870]
 
  file "libtommath/makefile.cygwin_dll"
-print [3f7a31ea92b45f590d1620236292f1027cf90910]
+print [c4ee092699a7da8da4d63ff3c4d3d4c997b1b685]
 
  file "libtommath/makefile.icc"
-print [86bfe48c1d0b6f453db3f1c549400d3eaf32182a]
+print [372e99b8e6ed1ff833eff10368809a9830c3e23f]
 
  file "libtommath/makefile.msvc"
-print [e774f1f03381942d669aea65c5b4f853b8953075]
+print [c122e7a7932890a128435ff2b46ad810569470a0]
 
  file "libtommath/makefile.shared"
-print [ed5ba7b588836a914588f21dd91469e31ae653b5]
+print [0ef9bd4d81fd310294011d5439d3b8d38d1d9968]
 
  file "libtommath/mess.sh"
-print [deb8879743eab3e7c40ea0045d3d3fab91606c44]
+print [57262304f318b79621db769bcdfc9201aba3b904]
 
  file "libtommath/mtest/logtab.h"
-print [5339e308d59e99260c59a7b92e01fea1461e0577]
+print [72275949f01faa0ca949dbf563d9c46f4985b4d1]
 
  file "libtommath/mtest/mpi-config.h"
-print [ab18c642241e38a4ba24c89d32900264cb667a67]
+print [3e0f516d30b27cc5266624ed83b81c987bed1537]
 
  file "libtommath/mtest/mpi-types.h"
-print [b831320186206ac044ab61145060a748c9cd8969]
+print [1733bfde97aa702646017e1b8819bdb9cdc2eb0f]
 
  file "libtommath/mtest/mpi.c"
-print [a201c64859322d30cc0d59d4e49b5799155fcf6a]
+print [ef0c2ab628c595cb74ee4b4f92aeed4da1cf134d]
 
  file "libtommath/mtest/mpi.h"
-print [13ce630f14f8f239179fdf639831c2f303f8e420]
+print [d18d182c606c79e3850fa25acc2b3e51ef69ce5d]
 
  file "libtommath/mtest/mtest.c"
-print [1e1c7535620ac675ce6c894c5244358bbd89cd50]
+print [c3ddf5bf41562675a5b5ce7c23d8483b044f6947]
 
  file "libtommath/pics/design_process.sxd"
-print [1da3ae36b742f4390f2d9407a988d78272669e1d]
+print [04e98a4c8b3a80ad304aef0426ac8d62480a6fdf]
 
  file "libtommath/pics/design_process.tif"
-print [f4d34d0fe111a7d97cbf4bacf8c4e81abf96f072]
+print [05fc6934d08cb52003e0551b990662b1d0be8e7e]
 
  file "libtommath/pics/expt_state.sxd"
-print [e2044d00cc2dac65068f88927c3fc04e89df7226]
+print [861993fb0c0642471a638ab570d575dfb05f6fa4]
 
  file "libtommath/pics/expt_state.tif"
-print [2c812b2aa78817f8a87a7a5c6724f0da2c566aa8]
+print [ec2f4c354b0300e0770d6123402fbd49077d2361]
 
  file "libtommath/pics/makefile"
-print [d45d7884a6d1c5f502da871ae915ea9146325b78]
+print [3c87a1ce883756e7cc0c3a13a498b93afe0103ea]
 
  file "libtommath/pics/primality.tif"
-print [c0d06838715d7aee330b5fffac715a204f78adcc]
+print [7b1c247d8d4500f25d380131939961dcab1281ae]
 
  file "libtommath/pics/radix.sxd"
-print [f7c37586ab707526bb78caa81ae05b6ceb08d779]
+print [ccba54dcf750221365fadf097c981d542e94485c]
 
  file "libtommath/pics/sliding_window.sxd"
-print [9553f2b058225c1542477aa23becd7ae6c743966]
+print [fd3e2965dae654cd6a10fb658105936149aad35c]
 
  file "libtommath/pics/sliding_window.tif"
-print [aa353b82d6745878e6003eec806229d2ac3321ca]
+print [e9b5478be5a1feea734a7754e7c0ba38c805e8a6]
 
  file "libtommath/poster.out"
-print [9c671decb1b39f4a6053f37caa646ae2ca953921]
+print [5d2f72eee5c01873bdcd0372e0904e1cf1728e69]
 
  file "libtommath/poster.tex"
-print [1c5a03b49e11134e4e183d230ddbd24b4772fc34]
+print [cb8bf6bae4a1cf8add39cfe435598dcd36deb762]
 
  file "libtommath/pre_gen/mpi.c"
-print [e6101496bb529bd5c6116c4e76c5c1bd6d13b519]
+print [9b27f9a710964264a1b5e585e3193a8fcab4a5dc]
 
  file "libtommath/pretty.build"
-print [a39caf398cbf22d4b71ed712130a2065874c7586]
+print [d598020b7f238e9d4a603b9dd122c028d1ecd3f2]
 
  file "libtommath/tombc/grammar.txt"
-print [ceba348c80123a467e469d3e1f09be610f4605f1]
+print [fe4061eecc7f35d43f98f42333b2b7ed14a74684]
 
  file "libtommath/tommath.h"
-print [8a8590d52e79f3611f9296cf237b0a2712fc8927]
+print [68f9ad88191d105292da91158c6ac1e9d2219169]
 
  file "libtommath/tommath.out"
-print [d23a2830ff5398c315ff2e9d69eebefdb3a9ebac]
+print [b91aa9ce6dc57cd45e24ff367245e5b160365ad0]
 
  file "libtommath/tommath_class.h"
-print [8a34d71c07127e773adf79c0adf044dc07c2ab77]
+print [b71358e2bc3518476b229a114198a7a563f48c0f]
 
  file "libtommath/tommath_superclass.h"
-print [00a86687f96d987d955304c2cb8791860d653be5]
+print [29a2df6d9e1779201b494dbae8d47b82576b8356]
 
  file "listener.c"
-print [573f1539452ab6ab06662dda4a49604f89571417]
+print [a489a09dcb81c2798c49325f7466910542720021]
 
  file "listener.h"
-print [693dd1a2bda73b3e6f920327dc6e8c439af7446b]
+print [1e55aab612dcf37ff36153007298656d4a54d1e2]
 
  file "loginrec.c"
-print [416cae72c12136e8a78d1e16d565e22013e15fba]
+print [91fb2b96d3bb9e27a203abef99aadb9d21b3e738]
 
  file "loginrec.h"
-print [02d062d6925ad9ca5587534851a63f3c1b829602]
+print [b3f58f704b0007d4bc35ba06bae10507da333b48]
+
+ file "options.h"
+print [b6bd3ebc085f590d62f05a924c0f62c56debd6a8]
 
  file "packet.c"
-print [c3e44b1c6ada0296cbbc51d6101af2357ad1044e]
+print [d5a549548b658c38629cddd52792be6441e4a77e]
 
  file "packet.h"
-print [0438216c2541eff3a8d855d61064e845612293e7]
+print [67d0cc989e9b8bb23c76cdd38de1de93b34e7e96]
 
  file "process-packet.c"
-print [eee4afefb6c8f00e7ece9fe3f0ea341f683b7825]
+print [0ee03449cbce46209e2e922f370fd7596addec20]
 
  file "progressmeter.c"
-print [f6653a43bcb75cbf105fff2b8f0867f03dce45d0]
+print [cb7ce9afbc64b76bddc620fe2ff60000093d337a]
 
  file "progressmeter.h"
-print [6413071eeabca5ecfdbb33e5c1bdee29ed1c59e8]
+print [0ab39997c527df14f768306da7daea4eea3ec385]
 
  file "queue.c"
-print [e62c20aa644143adeaf8df107a8da5eb876f6a6b]
+print [5fdf39a9bc7df83122adb93279b1b3f1cad8fb4b]
 
  file "queue.h"
-print [0b7cfa5a5694540b6fba588bdf6d8d75fb8bccea]
+print [8693cb050df27ec0f22bc00506ad6844a2dcc67f]
 
  file "random.c"
-print [8a5682945f6361c04b3ea00e0f55a2608e5dd7d5]
+print [773934e0e15cc4ee526b7601376c291a9cdb60d7]
 
  file "random.h"
-print [8a4182031b5b59bf16fd3b1ceb3f5641f0fb8c3c]
+print [91a89ba929da2267a64d0ad174f3532ca7c0b7ad]
 
  file "rsa.c"
-print [db1b6cfdac47271cc31f80b2234237d0e3486efb]
+print [f893e4aaed4c6d2e33fc424b7b4c6eec62bd94f1]
 
  file "rsa.h"
-print [72d1e5ef1865500579dcc8df38dd9c4d05052e96]
+print [129d12d7104024b8a6bca52687439a289f3ff451]
 
  file "runopts.h"
-print [3c67dd9623e11ead43e74570871e9257a1a05f1e]
+print [7d8844a9b4e2964848336281d0c66c64d0881e6f]
 
  file "scp.c"
-print [f403daf9c50f106d496d7656f21b8bd1f0b78265]
+print [4c64e1a4b37f9abb8656a4ac9e02f09bbd66f3e4]
 
  file "scpmisc.c"
-print [a4bf9099d83d922b8ebd4d44e1a50ae7c1fb919f]
+print [4c07634e841391e47e360fbb17120bc8d71b9a6c]
 
  file "scpmisc.h"
-print [285656c43eccec57a5009ef3d102b341473927f8]
+print [015fff5f5e9d9ec14c3e70526437d5994201d15a]
 
  file "service.h"
-print [3984005369fc115a50265cf22e5427cccbaa26c7]
+print [99883952937588930e8026335328f4d1fdc92dc9]
 
  file "session.h"
-print [54f0ca867d1c661ac2792a3581f34aec4e9d3d32]
+print [b4775f48448e548f602e8177c588a327b1ab66c0]
 
  file "signkey.c"
-print [c8ace1c7b5ebe4f9ebfc0f98881c696ff15faca0]
+print [f68745caee4012e186af2eacc08568d46cea3f55]
 
  file "signkey.h"
-print [00f1dc2a0da2b433dfc62e9fa46d2d14b63e6122]
+print [386a904b76bacd2a9b03d01d22438f3889921d30]
 
  file "ssh.h"
-print [b319f0d201d5685d2360399f6a3a045339edcb99]
+print [6235d4f7b770992e6f474272d5e08bc8c9e2187c]
 
  file "sshpty.c"
-print [58617aab1aa9849e001085c771855c0397e4f8d9]
+print [85068293d20d06f029853f5ffeafc6445380acae]
 
  file "sshpty.h"
-print [6c67ffbbfb6466c312ce870488e14b06d77bd2c0]
+print [51675e9a480e01b9ecd8deff0601f5bd447ad4d7]
 
  file "svr-agentfwd.c"
-print [bb1bab978b93fab0bfb97f651a9a1b653952357a]
+print [37045d9800cd2cfaec590aedc29bc87892eee45c]
 
  file "svr-algo.c"
-print [3dd45a520c94906cb3ad3bebe64afb1560293f21]
+print [573e2d2784f546c428b54939384644c3e47b3b7f]
 
  file "svr-auth.c"
-print [1531ff87d9137346c3520426a4449caccc7489fb]
+print [b5b01e01e83734e70918028aac8fc49bd327a567]
 
  file "svr-authpam.c"
-print [48a4431ae8542a6e384c8338cb6f6aee1d5d2947]
+print [f6cccaf5825260951a2b1512e680a75ab79fed3a]
 
  file "svr-authpasswd.c"
-print [b4f6be996d85bfe11a4616e2d1f7a64ec97c6c6a]
+print [123051ab600d85134b837f550e18ccc94b28e8d8]
 
  file "svr-authpubkey.c"
-print [71e13311c6b0f531c573eddef45629fbcff70896]
+print [25ee299f116a746c75ce3fe86ee0f80c67d319de]
+
+ file "svr-authpubkeyoptions.c"
+print [a9114824963feb8ef1d8186c5c68cde5af6c43f8]
 
  file "svr-chansession.c"
-print [0e9c72611453ad554983d3870ea8c64d88a3b1fd]
+print [26106a1fd9326323fb12845728ca767627fee6d0]
 
  file "svr-kex.c"
-print [1764b06347786df2e59763121357617f525b750a]
+print [f7ecd54b39d64c22363454f94c0a874ff6ff59fc]
 
  file "svr-main.c"
-print [197a08969b7913edb8f2af86ee082ec431b6394c]
+print [6cdf0be11ecf695b9e278e6d62c4198ae4340094]
 
  file "svr-runopts.c"
-print [c2ddfe4a7da29059475312865a507e24b6f7d1b8]
+print [cd7cf5df165032948e4e1efff5dc8cf59c2995ad]
 
  file "svr-service.c"
-print [ef22672517e6d52bc98f6be30fa176f34712bdf0]
+print [36fcc181cc5034829b963e0a8e71ce5d03c8ae07]
 
  file "svr-session.c"
-print [01b34f1c0ae821435b548ca870780dd9e8aad593]
+print [b2a57d84e86478502096c34105975fd8d3b491b5]
 
  file "svr-tcpfwd.c"
-print [561e6e0f05b94e5c2f0c16b63e80c816c302f9e6]
+print [1a31ee01eaffc1f30ad197c0dfb63e5936532e6b]
 
  file "svr-x11fwd.c"
-print [eb46b5d9323a691598cf3a7d52d9228661dc34a3]
+print [7a403992a46e818e7dd07b8ab99591c208d87e0e]
+
+ file "sysoptions.h"
+print [a64f66dbc28e14f4cdbe615c08905537a8b69fa8]
 
  file "tcp-accept.c"
-print [8a37a0f58e38b60bd7783f768801210867d49b6e]
+print [375ee4291d1ac31415416f3976dd863b7fd73140]
 
  file "tcpfwd.h"
-print [5c06d115ec9107773f2fdc1ebcd29adae8484e05]
+print [efb44d74f1cc9d0de586381c369dfd5c5c9f46b0]
 
  file "termcodes.c"
-print [a59e7da614fea1b32125d19593edb0a3409fcf3b]
+print [3c16b963e96766770ce3df44fc17b37937ceea76]
 
  file "termcodes.h"
-print [256607e6c588e307c89d1ab4f604c87c13647b2d]
+print [1589e02b5c63b2df7696af78b3f1bc23317af427]
 
  file "x11fwd.h"
-print [d5bac19d1df6c874b4473744faa45e54a1ed9895]
+print [4549ec2784ea3929c593fcc3e5601064db1d9662]

=== modified file '_MTN/revision'
--- _MTN/revision	2008-03-27 20:08:06 +0000
+++ _MTN/revision	2008-11-19 20:58:59 +0000
@@ -2,4 +2,4 @@
 
 new_manifest [0000000000000000000000000000000000000004]
 
-old_revision [2f31bc0e5d1c701ad8c03176bbb5722852c0c11d]
+old_revision [f2c4b1b1304914efad934b368d3f6e4e8d91de99]

=== modified file 'algo.h'
--- algo.h	2006-04-16 16:16:40 +0000
+++ algo.h	2008-11-19 20:58:59 +0000
@@ -29,13 +29,18 @@
 #include "includes.h"
 #include "buffer.h"
 
+#define DROPBEAR_MODE_UNUSED 0
+#define DROPBEAR_MODE_CBC 1
+#define DROPBEAR_MODE_CTR 2
+
 struct Algo_Type {
 
 	unsigned char *name; /* identifying name */
 	char val; /* a value for this cipher, or -1 for invalid */
-	void *data; /* algorithm specific data */
-	unsigned usable : 1; /* whether we can use this algorithm */
-
+	const void *data; /* algorithm specific data */
+	char usable; /* whether we can use this algorithm */
+	const void *mode; /* the mode, currently only used for ciphers,
+						 points to a 'struct dropbear_cipher_mode' */
 };
 
 typedef struct Algo_Type algo_type;
@@ -48,6 +53,7 @@
 extern algo_type sshcompress[];
 
 extern const struct dropbear_cipher dropbear_nocipher;
+extern const struct dropbear_cipher_mode dropbear_mode_none;
 extern const struct dropbear_hash dropbear_nohash;
 
 struct dropbear_cipher {
@@ -56,6 +62,16 @@
 	unsigned char blocksize;
 };
 
+struct dropbear_cipher_mode {
+	int (*start)(int cipher, const unsigned char *IV, 
+			const unsigned char *key, 
+			int keylen, int num_rounds, void *cipher_state);
+	int (*encrypt)(const unsigned char *pt, unsigned char *ct, 
+			unsigned long len, void *cipher_state);
+	int (*decrypt)(const unsigned char *ct, unsigned char *pt, 
+			unsigned long len, void *cipher_state);
+};
+
 struct dropbear_hash {
 	const struct ltc_hash_descriptor *hashdesc;
 	unsigned long keysize;

=== modified file 'auth.h'
--- auth.h	2008-03-27 20:08:06 +0000
+++ auth.h	2008-11-19 20:58:59 +0000
@@ -26,6 +26,7 @@
 #define _AUTH_H_
 
 #include "includes.h"
+#include "chansession.h"
 
 void svr_authinitialise();
 void cli_authinitialise();
@@ -38,6 +39,25 @@
 void svr_auth_pubkey();
 void svr_auth_pam();
 
+#ifdef ENABLE_SVR_PUBKEY_OPTIONS
+int svr_pubkey_allows_agentfwd();
+int svr_pubkey_allows_tcpfwd();
+int svr_pubkey_allows_x11fwd();
+int svr_pubkey_allows_pty();
+void svr_pubkey_set_forced_command(struct ChanSess *chansess);
+void svr_pubkey_options_cleanup();
+int svr_add_pubkey_options(buffer *options_buf, int line_num, const char* filename);
+#else
+/* no option : success */
+#define svr_pubkey_allows_agentfwd() 1
+#define svr_pubkey_allows_tcpfwd() 1
+#define svr_pubkey_allows_x11fwd() 1
+#define svr_pubkey_allows_pty() 1
+static inline void svr_pubkey_set_forced_command(struct ChanSess *chansess) { }
+static inline void svr_pubkey_options_cleanup() { }
+#define svr_add_pubkey_options(x,y,z) DROPBEAR_SUCCESS
+#endif
+
 /* Client functions */
 void recv_msg_userauth_failure();
 void recv_msg_userauth_success();
@@ -97,6 +117,10 @@
 	char *pw_shell;
 	char *pw_name;
 	char *pw_passwd;
+#ifdef ENABLE_SVR_PUBKEY_OPTIONS
+	struct PubKeyOptions* pubkey_options;
+#endif
+
 };
 
 struct SignKeyList;
@@ -111,4 +135,18 @@
 
 };
 
+#ifdef ENABLE_SVR_PUBKEY_OPTIONS
+struct PubKeyOptions;
+struct PubKeyOptions {
+	/* Flags */
+	int no_port_forwarding_flag;
+	int no_agent_forwarding_flag;
+	int no_x11_forwarding_flag;
+	int no_pty_flag;
+	/* "command=" option. */
+	unsigned char * forced_command;
+
+};
+#endif
+
 #endif /* _AUTH_H_ */

=== modified file 'chansession.h'
--- chansession.h	2005-12-12 09:14:33 +0000
+++ chansession.h	2008-11-19 20:58:59 +0000
@@ -78,6 +78,9 @@
 void cli_send_chansess_request();
 void cli_tty_cleanup();
 void cli_chansess_winchange();
+#ifdef ENABLE_CLI_NETCAT
+void cli_send_netcat_request();
+#endif
 
 void svr_chansessinitialise();
 extern const struct ChanType svrchansess;

=== modified file 'cli-auth.c'
--- cli-auth.c	2008-03-27 20:08:06 +0000
+++ cli-auth.c	2008-11-19 20:58:59 +0000
@@ -229,6 +229,8 @@
 
 void recv_msg_userauth_success() {
 	TRACE(("received msg_userauth_success"))
+	/* Note: in delayed-zlib mode, setting authdone here 
+	 * will enable compression in the transport layer */
 	ses.authstate.authdone = 1;
 	cli_ses.state = USERAUTH_SUCCESS_RCVD;
 	cli_ses.lastauthtype = AUTH_TYPE_NONE;

=== modified file 'cli-authinteract.c'
--- cli-authinteract.c	2008-03-27 20:08:06 +0000
+++ cli-authinteract.c	2008-11-19 20:58:59 +0000
@@ -77,6 +77,11 @@
 
 	TRACE(("enter recv_msg_recv_userauth_info_request"))
 
+	/* Let the user know what password/host they are authing for */
+	if (!cli_ses.interact_request_received) {
+		fprintf(stderr, "Login for %s@%s\n", cli_opts.username,
+				cli_opts.remotehost);
+	}
 	cli_ses.interact_request_received = 1;
 
 	name = buf_getstring(ses.payload, NULL);

=== modified file 'cli-chansession.c'
--- cli-chansession.c	2008-03-27 20:08:06 +0000
+++ cli-chansession.c	2008-11-19 20:58:59 +0000
@@ -321,7 +321,11 @@
 	TRACE(("enter send_chansess_shell_req"))
 
 	if (cli_opts.cmd) {
-		reqtype = "exec";
+		if (cli_opts.is_subsystem) {
+			reqtype = "subsystem";
+		} else {
+			reqtype = "exec";
+		}
 	} else {
 		reqtype = "shell";
 	}
@@ -338,9 +342,8 @@
 	TRACE(("leave send_chansess_shell_req"))
 }
 
-static int cli_initchansess(struct Channel *channel) {
-
-
+/* Shared for normal client channel and netcat-alike */
+static int cli_init_stdpipe_sess(struct Channel *channel) {
 	channel->writefd = STDOUT_FILENO;
 	setnonblocking(STDOUT_FILENO);
 
@@ -351,6 +354,12 @@
 	setnonblocking(STDERR_FILENO);
 
 	channel->extrabuf = cbuf_new(opts.recv_window);
+	return 0;
+}
+
+static int cli_initchansess(struct Channel *channel) {
+
+	cli_init_stdpipe_sess(channel);
 
 	if (cli_opts.wantpty) {
 		send_chansess_pty_req(channel);
@@ -363,12 +372,48 @@
 	}
 
 	return 0; /* Success */
-
-}
+}
+
+#ifdef ENABLE_CLI_NETCAT
+
+void cli_send_netcat_request() {
+
+	const unsigned char* source_host = "127.0.0.1";
+	const int source_port = 22;
+
+	const struct ChanType cli_chan_netcat = {
+		0, /* sepfds */
+		"direct-tcpip",
+		cli_init_stdpipe_sess, /* inithandler */
+		NULL,
+		NULL,
+		cli_closechansess
+	};
+
+	cli_opts.wantpty = 0;
+
+	if (send_msg_channel_open_init(STDIN_FILENO, &cli_chan_netcat) 
+			== DROPBEAR_FAILURE) {
+		dropbear_exit("Couldn't open initial channel");
+	}
+
+	buf_putstring(ses.writepayload, cli_opts.netcat_host, 
+			strlen(cli_opts.netcat_host));
+	buf_putint(ses.writepayload, cli_opts.netcat_port);
+
+	/* originator ip - localhost is accurate enough */
+	buf_putstring(ses.writepayload, source_host, strlen(source_host));
+	buf_putint(ses.writepayload, source_port);
+
+	encrypt_packet();
+	TRACE(("leave cli_send_chansess_request"))
+}
+#endif
 
 void cli_send_chansess_request() {
 
 	TRACE(("enter cli_send_chansess_request"))
+
 	if (send_msg_channel_open_init(STDIN_FILENO, &clichansess) 
 			== DROPBEAR_FAILURE) {
 		dropbear_exit("Couldn't open initial channel");
@@ -379,3 +424,16 @@
 	TRACE(("leave cli_send_chansess_request"))
 
 }
+
+
+#if 0
+	while (cli_opts.localfwds != NULL) {
+		ret = cli_localtcp(cli_opts.localfwds->listenport,
+				cli_opts.localfwds->connectaddr,
+				cli_opts.localfwds->connectport);
+		if (ret == DROPBEAR_FAILURE) {
+			dropbear_log(LOG_WARNING, "Failed local port forward %d:%s:%d",
+					cli_opts.localfwds->listenport,
+					cli_opts.localfwds->connectaddr,
+					cli_opts.localfwds->connectport);
+#endif

=== modified file 'cli-main.c'
--- cli-main.c	2008-03-27 20:08:06 +0000
+++ cli-main.c	2008-11-19 20:58:59 +0000
@@ -32,6 +32,8 @@
 static void cli_dropbear_exit(int exitcode, const char* format, va_list param);
 static void cli_dropbear_log(int priority, const char* format, va_list param);
 
+static void cli_proxy_cmd(int *sock_in, int *sock_out);
+
 #if defined(DBMULTI_dbclient) || !defined(DROPBEAR_MULTI)
 #if defined(DBMULTI_dbclient) && defined(DROPBEAR_MULTI)
 int cli_main(int argc, char ** argv) {
@@ -39,7 +41,7 @@
 int main(int argc, char ** argv) {
 #endif
 
-	int sock;
+	int sock_in, sock_out;
 	char* error = NULL;
 	char* hostandport;
 	int len;
@@ -58,10 +60,18 @@
 		dropbear_exit("signal() error");
 	}
 
-	sock = connect_remote(cli_opts.remotehost, cli_opts.remoteport, 
-			0, &error);
+#ifdef ENABLE_CLI_PROXYCMD
+	if (cli_opts.proxycmd) {
+		cli_proxy_cmd(&sock_in, &sock_out);
+	} else
+#endif
+	{
+		int sock = connect_remote(cli_opts.remotehost, cli_opts.remoteport, 
+				0, &error);
+		sock_in = sock_out = sock;
+	}
 
-	if (sock < 0) {
+	if (sock_in < 0) {
 		dropbear_exit("%s", error);
 	}
 
@@ -72,7 +82,7 @@
 	snprintf(hostandport, len, "%s:%s", 
 			cli_opts.remotehost, cli_opts.remoteport);
 
-	cli_session(sock, hostandport);
+	cli_session(sock_in, sock_out, hostandport);
 
 	/* not reached */
 	return -1;
@@ -112,3 +122,25 @@
 	fprintf(stderr, "%s: %s\n", cli_opts.progname, printbuf);
 
 }
+
+static void exec_proxy_cmd(void *user_data_cmd) {
+	const char *cmd = user_data_cmd;
+	char *usershell;
+
+	usershell = m_strdup(get_user_shell());
+	run_shell_command(cmd, ses.maxfd, usershell);
+	dropbear_exit("Failed to run '%s'\n", cmd);
+}
+
+static void cli_proxy_cmd(int *sock_in, int *sock_out) {
+	int ret;
+
+	fill_passwd(cli_opts.own_user);
+
+	ret = spawn_command(exec_proxy_cmd, cli_opts.proxycmd,
+			sock_out, sock_in, NULL, NULL);
+	if (ret == DROPBEAR_FAILURE) {
+		dropbear_exit("Failed running proxy command");
+		*sock_in = *sock_out = -1;
+	}
+}

=== modified file 'cli-runopts.c'
--- cli-runopts.c	2008-03-27 20:08:06 +0000
+++ cli-runopts.c	2008-11-19 20:58:59 +0000
@@ -33,18 +33,27 @@
 cli_runopts cli_opts; /* GLOBAL */
 
 static void printhelp();
-static void parsehostname(char* userhostarg);
+static void parse_hostname(const char* orighostarg);
+static void parse_multihop_hostname(const char* orighostarg, const char* argv0);
+static void fill_own_user();
 #ifdef ENABLE_CLI_PUBKEY_AUTH
 static void loadidentityfile(const char* filename);
 #endif
 #ifdef ENABLE_CLI_ANYTCPFWD
-static void addforward(char* str, struct TCPFwdList** fwdlist);
+static void addforward(const char* str, struct TCPFwdList** fwdlist);
+#endif
+#ifdef ENABLE_CLI_NETCAT
+static void add_netcat(const char *str);
 #endif
 
 static void printhelp() {
 
 	fprintf(stderr, "Dropbear client v%s\n"
-					"Usage: %s [options] [user@]host [command]\n"
+#ifdef ENABLE_CLI_MULTIHOP
+					"Usage: %s [options] [user@]host[/port][,[user@]host/port],...] [command]\n"
+#else
+					"Usage: %s [options] [user@]host[/port] [command]\n"
+#endif
 					"Options are:\n"
 					"-p <remoteport>\n"
 					"-l <username>\n"
@@ -53,6 +62,7 @@
 					"-N    Don't run a remote command\n"
 					"-f    Run in background after auth\n"
 					"-y    Always accept remote host key if unknown\n"
+					"-s    Request a subsystem (use for sftp)\n"
 #ifdef ENABLE_CLI_PUBKEY_AUTH
 					"-i <identityfile>   (multiple allowed)\n"
 #endif
@@ -65,11 +75,18 @@
 #endif
 					"-W <receive_window_buffer> (default %d, larger may be faster, max 1MB)\n"
 					"-K <keepalive>  (0 is never, default %d)\n"
+					"-I <idle_timeout>  (0 is never, default %d)\n"
+#ifdef ENABLE_CLI_NETCAT
+					"-B <endhost:endport> Netcat-alike forwarding\n"
+#endif				
+#ifdef ENABLE_CLI_PROXYCMD
+					"-J <proxy_program> Use program pipe rather than TCP connection\n"
+#endif
 #ifdef DEBUG_TRACE
-					"-v    verbose\n"
+					"-v    verbose (compiled with DEBUG_TRACE)\n"
 #endif
 					,DROPBEAR_VERSION, cli_opts.progname,
-					DEFAULT_RECV_WINDOW, DEFAULT_KEEPALIVE);
+					DEFAULT_RECV_WINDOW, DEFAULT_KEEPALIVE, DEFAULT_IDLE_TIMEOUT);
 					
 }
 
@@ -87,10 +104,14 @@
 #ifdef ENABLE_CLI_REMOTETCPFWD
 	int nextisremote = 0;
 #endif
+#ifdef ENABLE_CLI_NETCAT
+	int nextisnetcat = 0;
+#endif
 	char* dummy = NULL; /* Not used for anything real */
 
 	char* recv_window_arg = NULL;
 	char* keepalive_arg = NULL;
+	char* idle_timeout_arg = NULL;
 
 	/* see printhelp() for options */
 	cli_opts.progname = argv[0];
@@ -102,6 +123,7 @@
 	cli_opts.backgrounded = 0;
 	cli_opts.wantpty = 9; /* 9 means "it hasn't been touched", gets set later */
 	cli_opts.always_accept_key = 0;
+	cli_opts.is_subsystem = 0;
 #ifdef ENABLE_CLI_PUBKEY_AUTH
 	cli_opts.privkeys = NULL;
 #endif
@@ -112,12 +134,17 @@
 #ifdef ENABLE_CLI_REMOTETCPFWD
 	cli_opts.remotefwds = NULL;
 #endif
+#ifdef ENABLE_CLI_PROXYCMD
+	cli_opts.proxycmd = NULL;
+#endif
 	/* not yet
 	opts.ipv4 = 1;
 	opts.ipv6 = 1;
 	*/
 	opts.recv_window = DEFAULT_RECV_WINDOW;
 
+	fill_own_user();
+
 	/* Iterate all the arguments */
 	for (i = 1; i < (unsigned int)argc; i++) {
 #ifdef ENABLE_CLI_PUBKEY_AUTH
@@ -144,6 +171,14 @@
 			continue;
 		}
 #endif
+#ifdef ENABLE_CLI_NETCAT
+		if (nextisnetcat) {
+			TRACE(("nextisnetcat true"))
+			add_netcat(argv[i]);
+			nextisnetcat = 0;
+			continue;
+		}
+#endif
 		if (next) {
 			/* The previous flag set a value to assign */
 			*next = argv[i];
@@ -186,6 +221,9 @@
 				case 'f':
 					cli_opts.backgrounded = 1;
 					break;
+				case 's':
+					cli_opts.is_subsystem = 1;
+					break;
 #ifdef ENABLE_CLI_LOCALTCPFWD
 				case 'L':
 					nextislocal = 1;
@@ -199,6 +237,16 @@
 					nextisremote = 1;
 					break;
 #endif
+#ifdef ENABLE_CLI_NETCAT
+				case 'B':
+					nextisnetcat = 1;
+					break;
+#endif
+#ifdef ENABLE_CLI_PROXYCMD
+				case 'J':
+					next = &cli_opts.proxycmd;
+					break;
+#endif
 				case 'l':
 					next = &cli_opts.username;
 					break;
@@ -215,6 +263,9 @@
 				case 'K':
 					next = &keepalive_arg;
 					break;
+				case 'I':
+					next = &idle_timeout_arg;
+					break;
 #ifdef DEBUG_TRACE
 				case 'v':
 					debug_trace = 1;
@@ -254,9 +305,11 @@
 			/* Either the hostname or commands */
 
 			if (cli_opts.remotehost == NULL) {
-
-				parsehostname(argv[i]);
-
+#ifdef ENABLE_CLI_MULTIHOP
+				parse_multihop_hostname(argv[i], argv[0]);
+#else
+				parse_hostname(argv[i]);
+#endif
 			} else {
 
 				/* this is part of the commands to send - after this we
@@ -283,6 +336,8 @@
 		}
 	}
 
+	/* And now a few sanity checks and setup */
+
 	if (cli_opts.remotehost == NULL) {
 		printhelp();
 		exit(EXIT_FAILURE);
@@ -307,21 +362,29 @@
 		dropbear_exit("command required for -f");
 	}
 	
-	if (recv_window_arg)
-	{
+	if (recv_window_arg) {
 		opts.recv_window = atol(recv_window_arg);
-		if (opts.recv_window == 0 || opts.recv_window > MAX_RECV_WINDOW)
-		{
+		if (opts.recv_window == 0 || opts.recv_window > MAX_RECV_WINDOW) {
 			dropbear_exit("Bad recv window '%s'", recv_window_arg);
 		}
 	}
 	if (keepalive_arg) {
-		opts.keepalive_secs = strtoul(keepalive_arg, NULL, 10);
-		if (opts.keepalive_secs == 0 && errno == EINVAL)
-		{
+		if (m_str_to_uint(keepalive_arg, &opts.keepalive_secs) == DROPBEAR_FAILURE) {
 			dropbear_exit("Bad keepalive '%s'", keepalive_arg);
 		}
 	}
+
+	if (idle_timeout_arg) {
+		if (m_str_to_uint(idle_timeout_arg, &opts.idle_timeout_secs) == DROPBEAR_FAILURE) {
+			dropbear_exit("Bad idle_timeout '%s'", idle_timeout_arg);
+		}
+	}
+
+#ifdef ENABLE_CLI_NETCAT
+	if (cli_opts.cmd && cli_opts.netcat_host) {
+		dropbear_log(LOG_INFO, "Ignoring command '%s' in netcat mode", cli_opts.cmd);
+	}
+#endif
 	
 }
 
@@ -350,16 +413,77 @@
 }
 #endif
 
-
-/* Parses a [user@]hostname argument. userhostarg is the argv[i] corresponding
- * - note that it will be modified */
-static void parsehostname(char* orighostarg) {
-
-	uid_t uid;
-	struct passwd *pw = NULL; 
-	char *userhostarg = NULL;
-
-	/* We probably don't want to be editing argvs */
+#ifdef ENABLE_CLI_MULTIHOP
+
+/* Sets up 'onion-forwarding' connections. This will spawn
+ * a separate dbclient process for each hop.
+ * As an example, if the cmdline is
+ *   dbclient wrt,madako,canyons
+ * then we want to run:
+ *   dbclient -J "dbclient -B canyons:22 wrt,madako" canyons
+ * and then the inner dbclient will recursively run:
+ *   dbclient -J "dbclient -B madako:22 wrt" madako
+ * etc for as many hosts as we want.
+ *
+ * Ports for hosts can be specified as host/port.
+ */
+static void parse_multihop_hostname(const char* orighostarg, const char* argv0) {
+	char *userhostarg = NULL;
+	char *last_hop = NULL;;
+	char *remainder = NULL;
+
+	/* both scp and rsync parse a user@host argument
+	 * and turn it into "-l user host". This breaks
+	 * for our multihop syntax, so we suture it back together.
+	 * This will break usernames that have both '@' and ',' in them,
+	 * though that should be fairly uncommon. */
+	if (cli_opts.username 
+			&& strchr(cli_opts.username, ',') 
+			&& strchr(cli_opts.username, '@')) {
+		unsigned int len = strlen(orighostarg) + strlen(cli_opts.username) + 2;
+		userhostarg = m_malloc(len);
+		snprintf(userhostarg, len, "%s@%s", cli_opts.username, orighostarg);
+	} else {
+		userhostarg = m_strdup(orighostarg);
+	}
+
+	last_hop = strrchr(userhostarg, ',');
+	if (last_hop) {
+		if (last_hop == userhostarg) {
+			dropbear_exit("Bad multi-hop hostnames");
+		}
+		*last_hop = '\0';
+		last_hop++;
+		remainder = userhostarg;
+		userhostarg = last_hop;
+	}
+
+	parse_hostname(userhostarg);
+
+	if (last_hop) {
+		/* Set up the proxycmd */
+		unsigned int cmd_len = 0;
+		if (cli_opts.proxycmd) {
+			dropbear_exit("-J can't be used with multihop mode");
+		}
+		if (cli_opts.remoteport == NULL) {
+			cli_opts.remoteport = "22";
+		}
+		cmd_len = strlen(remainder) 
+			+ strlen(cli_opts.remotehost) + strlen(cli_opts.remoteport)
+			+ strlen(argv0) + 30;
+		cli_opts.proxycmd = m_malloc(cmd_len);
+		snprintf(cli_opts.proxycmd, cmd_len, "%s -B %s:%s %s", 
+				argv0, cli_opts.remotehost, cli_opts.remoteport, remainder);
+	}
+}
+#endif /* !ENABLE_CLI_MULTIHOP */
+
+/* Parses a [user@]hostname[/port] argument. */
+static void parse_hostname(const char* orighostarg) {
+	char *userhostarg = NULL;
+	char *port = NULL;
+
 	userhostarg = m_strdup(orighostarg);
 
 	cli_opts.remotehost = strchr(userhostarg, '@');
@@ -374,14 +498,13 @@
 	}
 
 	if (cli_opts.username == NULL) {
-		uid = getuid();
-		
-		pw = getpwuid(uid);
-		if (pw == NULL || pw->pw_name == NULL) {
-			dropbear_exit("Unknown own user");
-		}
+		cli_opts.username = m_strdup(cli_opts.own_user);
+	}
 
-		cli_opts.username = m_strdup(pw->pw_name);
+	port = strchr(cli_opts.remotehost, '/');
+	if (port) {
+		*port = '\0';
+		cli_opts.remoteport = port+1;
 	}
 
 	if (cli_opts.remotehost[0] == '\0') {
@@ -389,10 +512,61 @@
 	}
 }
 
+#ifdef ENABLE_CLI_NETCAT
+static void add_netcat(const char* origstr) {
+	char *portstr = NULL;
+	
+	char * str = m_strdup(origstr);
+	
+	portstr = strchr(str, ':');
+	if (portstr == NULL) {
+		TRACE(("No netcat port"))
+		goto fail;
+	}
+	*portstr = '\0';
+	portstr++;
+	
+	if (strchr(portstr, ':')) {
+		TRACE(("Multiple netcat colons"))
+		goto fail;
+	}
+	
+	if (m_str_to_uint(portstr, &cli_opts.netcat_port) == DROPBEAR_FAILURE) {
+		TRACE(("bad netcat port"))
+		goto fail;
+	}
+	
+	if (cli_opts.netcat_port > 65535) {
+		TRACE(("too large netcat port"))
+		goto fail;
+	}
+	
+	cli_opts.netcat_host = str;
+	return;
+	
+fail:
+	dropbear_exit("Bad netcat endpoint '%s'", origstr);
+}
+#endif
+
+static void fill_own_user() {
+	uid_t uid;
+	struct passwd *pw = NULL; 
+
+	uid = getuid();
+
+	pw = getpwuid(uid);
+	if (pw == NULL || pw->pw_name == NULL) {
+		dropbear_exit("Unknown own user");
+	}
+
+	cli_opts.own_user = m_strdup(pw->pw_name);
+}
+
 #ifdef ENABLE_CLI_ANYTCPFWD
 /* Turn a "listenport:remoteaddr:remoteport" string into into a forwarding
  * set, and add it to the forwarding list */
-static void addforward(char* origstr, struct TCPFwdList** fwdlist) {
+static void addforward(const char* origstr, struct TCPFwdList** fwdlist) {
 
 	char * listenport = NULL;
 	char * connectport = NULL;
@@ -428,15 +602,13 @@
 
 	/* Now we check the ports - note that the port ints are unsigned,
 	 * the check later only checks for >= MAX_PORT */
-	newfwd->listenport = strtol(listenport, NULL, 10);
-	if (errno != 0) {
-		TRACE(("bad listenport strtol"))
+	if (m_str_to_uint(listenport, &newfwd->listenport) == DROPBEAR_FAILURE) {
+		TRACE(("bad listenport strtoul"))
 		goto fail;
 	}
 
-	newfwd->connectport = strtol(connectport, NULL, 10);
-	if (errno != 0) {
-		TRACE(("bad connectport strtol"))
+	if (m_str_to_uint(connectport, &newfwd->connectport) == DROPBEAR_FAILURE) {
+		TRACE(("bad connectport strtoul"))
 		goto fail;
 	}
 
@@ -452,6 +624,7 @@
 		goto badport;
 	}
 
+	newfwd->have_reply = 0;
 	newfwd->next = *fwdlist;
 	*fwdlist = newfwd;
 

=== modified file 'cli-session.c'
--- cli-session.c	2008-03-27 20:08:06 +0000
+++ cli-session.c	2008-11-19 20:58:59 +0000
@@ -64,6 +64,10 @@
 	{SSH_MSG_CHANNEL_OPEN_FAILURE, recv_msg_channel_open_failure},
 	{SSH_MSG_USERAUTH_BANNER, recv_msg_userauth_banner}, /* client */
 	{SSH_MSG_USERAUTH_SPECIFIC_60, recv_msg_userauth_specific_60}, /* client */
+#ifdef  ENABLE_CLI_REMOTETCPFWD
+	{SSH_MSG_REQUEST_SUCCESS, cli_recv_msg_request_success}, /* client */
+	{SSH_MSG_REQUEST_FAILURE, cli_recv_msg_request_failure}, /* client */
+#endif
 	{0, 0} /* End */
 };
 
@@ -74,13 +78,13 @@
 	NULL /* Null termination */
 };
 
-void cli_session(int sock, char* remotehost) {
+void cli_session(int sock_in, int sock_out, char* remotehost) {
 
 	seedrandom();
 
 	crypto_init();
 
-	common_session_init(sock, remotehost);
+	common_session_init(sock_in, sock_out, remotehost);
 
 	chaninitialise(cli_chantypes);
 
@@ -197,20 +201,6 @@
 			TRACE(("leave cli_sessionloop: cli_auth_try"))
 			return;
 
-			/*
-		case USERAUTH_SUCCESS_RCVD:
-			send_msg_service_request(SSH_SERVICE_CONNECTION);
-			cli_ses.state = SERVICE_CONN_REQ_SENT;
-			TRACE(("leave cli_sessionloop: sent ssh-connection service req"))
-			return;
-
-		case SERVICE_CONN_ACCEPT_RCVD:
-			cli_send_chansess_request();
-			TRACE(("leave cli_sessionloop: cli_send_chansess_request"))
-			cli_ses.state = SESSION_RUNNING;
-			return;
-			*/
-
 		case USERAUTH_SUCCESS_RCVD:
 
 			if (cli_opts.backgrounded) {
@@ -235,7 +225,13 @@
 #ifdef ENABLE_CLI_REMOTETCPFWD
 			setup_remotetcp();
 #endif
-			if (!cli_opts.no_cmd) {
+
+#ifdef ENABLE_CLI_NETCAT
+			if (cli_opts.netcat_host) {
+				cli_send_netcat_request();
+			} else 
+#endif
+				if (!cli_opts.no_cmd) {
 				cli_send_chansess_request();
 			}
 			TRACE(("leave cli_sessionloop: running"))
@@ -294,8 +290,10 @@
 
 	/* XXX TODO perhaps print a friendlier message if we get this but have
 	 * already sent/received disconnect message(s) ??? */
-	close(ses.sock);
-	ses.sock = -1;
+	m_close(ses.sock_in);
+	m_close(ses.sock_out);
+	ses.sock_in = -1;
+	ses.sock_out = -1;
 	dropbear_exit("remote closed the connection");
 }
 

=== modified file 'cli-tcpfwd.c'
--- cli-tcpfwd.c	2006-04-16 16:16:40 +0000
+++ cli-tcpfwd.c	2008-11-19 20:58:59 +0000
@@ -128,7 +128,7 @@
 	CHECKCLEARTOWRITE();
 	buf_putbyte(ses.writepayload, SSH_MSG_GLOBAL_REQUEST);
 	buf_putstring(ses.writepayload, "tcpip-forward", 13);
-	buf_putbyte(ses.writepayload, 0);
+	buf_putbyte(ses.writepayload, 1); /* want_reply */
 	if (opts.listen_fwd_all) {
 		listenspec = "";
 	} else {
@@ -143,6 +143,42 @@
 	TRACE(("leave send_msg_global_request_remotetcp"))
 }
 
+/* The only global success/failure messages are for remotetcp.
+ * Since there isn't any identifier in these messages, we have to rely on them
+ * being in the same order as we sent the requests. This is the ordering
+ * of the cli_opts.remotefwds list */
+void cli_recv_msg_request_success() {
+
+	/* Nothing in the packet. We just mark off that we have received the reply,
+	 * so that we can report failure for later ones. */
+	struct TCPFwdList * iter = NULL;
+
+	iter = cli_opts.remotefwds;
+	while (iter != NULL) {
+		if (!iter->have_reply)
+		{
+			iter->have_reply = 1;
+			return;
+		}
+		iter = iter->next;
+	}
+}
+
+void cli_recv_msg_request_failure() {
+	struct TCPFwdList * iter = NULL;
+
+	iter = cli_opts.remotefwds;
+	while (iter != NULL) {
+		if (!iter->have_reply)
+		{
+			iter->have_reply = 1;
+			dropbear_log(LOG_WARNING, "Remote TCP forward request failed (port %d -> %s:%d)", iter->listenport, iter->connectaddr, iter->connectport);
+			return;
+		}
+		iter = iter->next;
+	}
+}
+
 void setup_remotetcp() {
 
 	struct TCPFwdList * iter = NULL;

=== modified file 'common-algo.c'
--- common-algo.c	2008-03-27 20:08:06 +0000
+++ common-algo.c	2008-11-19 20:58:59 +0000
@@ -29,32 +29,44 @@
 /* This file (algo.c) organises the ciphers which can be used, and is used to
  * decide which ciphers/hashes/compression/signing to use during key exchange*/
 
+static int void_cipher(const unsigned char* in, unsigned char* out,
+		unsigned long len, void *cipher_state) {
+	memcpy(out, in, len);
+	return CRYPT_OK;
+}
+
+static int void_start(int cipher, const unsigned char *IV, 
+			const unsigned char *key, 
+			int keylen, int num_rounds, void *cipher_state) {
+	return CRYPT_OK;
+}
+
 /* Mappings for ciphers, parameters are
    {&cipher_desc, keysize, blocksize} */
 /* NOTE: if keysize > 2*SHA1_HASH_SIZE, code such as hashkeys()
    needs revisiting */
 
-#ifdef DROPBEAR_AES256_CBC
+#ifdef DROPBEAR_AES256
 static const struct dropbear_cipher dropbear_aes256 = 
 	{&aes_desc, 32, 16};
 #endif
-#ifdef DROPBEAR_AES128_CBC
+#ifdef DROPBEAR_AES128
 static const struct dropbear_cipher dropbear_aes128 = 
 	{&aes_desc, 16, 16};
 #endif
-#ifdef DROPBEAR_BLOWFISH_CBC
+#ifdef DROPBEAR_BLOWFISH
 static const struct dropbear_cipher dropbear_blowfish = 
 	{&blowfish_desc, 16, 8};
 #endif
-#ifdef DROPBEAR_TWOFISH256_CBC
+#ifdef DROPBEAR_TWOFISH256
 static const struct dropbear_cipher dropbear_twofish256 = 
 	{&twofish_desc, 32, 16};
 #endif
-#ifdef DROPBEAR_TWOFISH128_CBC
+#ifdef DROPBEAR_TWOFISH128
 static const struct dropbear_cipher dropbear_twofish128 = 
 	{&twofish_desc, 16, 16};
 #endif
-#ifdef DROPBEAR_3DES_CBC
+#ifdef DROPBEAR_3DES
 static const struct dropbear_cipher dropbear_3des = 
 	{&des3_desc, 24, 8};
 #endif
@@ -63,6 +75,24 @@
 const struct dropbear_cipher dropbear_nocipher =
 	{NULL, 16, 8}; 
 
+/* A few void* s are required to silence warnings
+ * about the symmetric_CBC vs symmetric_CTR cipher_state pointer */
+const struct dropbear_cipher_mode dropbear_mode_cbc =
+	{(void*)cbc_start, (void*)cbc_encrypt, (void*)cbc_decrypt};
+const struct dropbear_cipher_mode dropbear_mode_none =
+	{void_start, void_cipher, void_cipher};
+#ifdef DROPBEAR_ENABLE_CTR_MODE
+/* a wrapper to make ctr_start and cbc_start look the same */
+static int dropbear_big_endian_ctr_start(int cipher, 
+		const unsigned char *IV, 
+		const unsigned char *key, int keylen, 
+		int num_rounds, symmetric_CTR *ctr) {
+	return ctr_start(cipher, IV, key, keylen, num_rounds, CTR_COUNTER_BIG_ENDIAN, ctr);
+}
+const struct dropbear_cipher_mode dropbear_mode_ctr =
+	{(void*)dropbear_big_endian_ctr_start, (void*)ctr_encrypt, (void*)ctr_decrypt};
+#endif
+
 /* Mapping of ssh hashes to libtomcrypt hashes, including keysize etc.
    {&hash_desc, keysize, hashsize} */
 
@@ -83,65 +113,81 @@
 	{NULL, 16, 0}; /* used initially */
 	
 
-/* The following map ssh names to internal values */
+/* The following map ssh names to internal values.
+ * The ordering here is important for the client - the first mode
+ * that is also supported by the server will get used. */
 
 algo_type sshciphers[] = {
-#ifdef DROPBEAR_AES128_CBC
-	{"aes128-cbc", 0, (void*)&dropbear_aes128, 1},
-#endif
-#ifdef DROPBEAR_3DES_CBC
-	{"3des-cbc", 0, (void*)&dropbear_3des, 1},
-#endif
-#ifdef DROPBEAR_AES256_CBC
-	{"aes256-cbc", 0, (void*)&dropbear_aes256, 1},
-#endif
-#ifdef DROPBEAR_TWOFISH256_CBC
-	{"twofish256-cbc", 0, (void*)&dropbear_twofish256, 1},
-	{"twofish-cbc", 0, (void*)&dropbear_twofish256, 1},
-#endif
-#ifdef DROPBEAR_TWOFISH128_CBC
-	{"twofish128-cbc", 0, (void*)&dropbear_twofish128, 1},
-#endif
-#ifdef DROPBEAR_BLOWFISH_CBC
-	{"blowfish-cbc", 0, (void*)&dropbear_blowfish, 1},
-#endif
-	{NULL, 0, NULL, 0}
+#ifdef DROPBEAR_ENABLE_CTR_MODE
+#ifdef DROPBEAR_AES128
+	{"aes128-ctr", 0, &dropbear_aes128, 1, &dropbear_mode_ctr},
+#endif
+#ifdef DROPBEAR_3DES
+	{"3des-ctr", 0, &dropbear_3des, 1, &dropbear_mode_ctr},
+#endif
+#ifdef DROPBEAR_AES256
+	{"aes256-ctr", 0, &dropbear_aes256, 1, &dropbear_mode_ctr},
+#endif
+#endif /* DROPBEAR_ENABLE_CTR_MODE */
+
+/* CBC modes are always enabled */
+#ifdef DROPBEAR_AES128
+	{"aes128-cbc", 0, &dropbear_aes128, 1, &dropbear_mode_cbc},
+#endif
+#ifdef DROPBEAR_3DES
+	{"3des-cbc", 0, &dropbear_3des, 1, &dropbear_mode_cbc},
+#endif
+#ifdef DROPBEAR_AES256
+	{"aes256-cbc", 0, &dropbear_aes256, 1, &dropbear_mode_cbc},
+#endif
+#ifdef DROPBEAR_TWOFISH256
+	{"twofish256-cbc", 0, &dropbear_twofish256, 1, &dropbear_mode_cbc},
+	{"twofish-cbc", 0, &dropbear_twofish256, 1, &dropbear_mode_cbc},
+#endif
+#ifdef DROPBEAR_TWOFISH128
+	{"twofish128-cbc", 0, &dropbear_twofish128, 1, &dropbear_mode_cbc},
+#endif
+#ifdef DROPBEAR_BLOWFISH
+	{"blowfish-cbc", 0, &dropbear_blowfish, 1, &dropbear_mode_cbc},
+#endif
+	{NULL, 0, NULL, 0, NULL}
 };
 
 algo_type sshhashes[] = {
 #ifdef DROPBEAR_SHA1_96_HMAC
-	{"hmac-sha1-96", 0, (void*)&dropbear_sha1_96, 1},
+	{"hmac-sha1-96", 0, &dropbear_sha1_96, 1, NULL},
 #endif
 #ifdef DROPBEAR_SHA1_HMAC
-	{"hmac-sha1", 0, (void*)&dropbear_sha1, 1},
+	{"hmac-sha1", 0, &dropbear_sha1, 1, NULL},
 #endif
 #ifdef DROPBEAR_MD5_HMAC
-	{"hmac-md5", 0, (void*)&dropbear_md5, 1},
+	{"hmac-md5", 0, &dropbear_md5, 1, NULL},
 #endif
-	{NULL, 0, NULL, 0}
+	{NULL, 0, NULL, 0, NULL}
 };
 
 algo_type sshcompress[] = {
 #ifndef DISABLE_ZLIB
-	{"zlib", DROPBEAR_COMP_ZLIB, NULL, 1},
+	{"zlib", DROPBEAR_COMP_ZLIB, NULL, 1, NULL},
+	{"zlib@openssh.com", DROPBEAR_COMP_ZLIB_DELAY, NULL, 1, NULL},
 #endif
-	{"none", DROPBEAR_COMP_NONE, NULL, 1},
-	{NULL, 0, NULL, 0}
+	{"none", DROPBEAR_COMP_NONE, NULL, 1, NULL},
+	{NULL, 0, NULL, 0, NULL}
 };
 
 algo_type sshhostkey[] = {
 #ifdef DROPBEAR_RSA
-	{"ssh-rsa", DROPBEAR_SIGNKEY_RSA, NULL, 1},
+	{"ssh-rsa", DROPBEAR_SIGNKEY_RSA, NULL, 1, NULL},
 #endif
 #ifdef DROPBEAR_DSS
-	{"ssh-dss", DROPBEAR_SIGNKEY_DSS, NULL, 1},
+	{"ssh-dss", DROPBEAR_SIGNKEY_DSS, NULL, 1, NULL},
 #endif
-	{NULL, 0, NULL, 0}
+	{NULL, 0, NULL, 0, NULL}
 };
 
 algo_type sshkex[] = {
-	{"diffie-hellman-group1-sha1", DROPBEAR_KEX_DH_GROUP1, NULL, 1},
-	{NULL, 0, NULL, 0}
+	{"diffie-hellman-group1-sha1", DROPBEAR_KEX_DH_GROUP1, NULL, 1, NULL},
+	{NULL, 0, NULL, 0, NULL}
 };
 
 
@@ -150,16 +196,16 @@
 void crypto_init() {
 
 	const struct ltc_cipher_descriptor *regciphers[] = {
-#ifdef DROPBEAR_AES_CBC
+#ifdef DROPBEAR_AES
 		&aes_desc,
 #endif
-#ifdef DROPBEAR_BLOWFISH_CBC
+#ifdef DROPBEAR_BLOWFISH
 		&blowfish_desc,
 #endif
-#ifdef DROPBEAR_TWOFISH_CBC
+#ifdef DROPBEAR_TWOFISH
 		&twofish_desc,
 #endif
-#ifdef DROPBEAR_3DES_CBC
+#ifdef DROPBEAR_3DES
 		&des3_desc,
 #endif
 		NULL
@@ -215,7 +261,7 @@
 	unsigned int donefirst = 0;
 	buffer *algolist = NULL;
 
-	algolist = buf_new(100);
+	algolist = buf_new(160);
 	for (i = 0; localalgos[i].name != NULL; i++) {
 		if (localalgos[i].usable) {
 			if (donefirst)

=== modified file 'common-channel.c'
--- common-channel.c	2008-03-27 20:08:06 +0000
+++ common-channel.c	2008-11-19 20:58:59 +0000
@@ -276,10 +276,10 @@
 		channel->flushing = 1;
 	}
 	
-	// if a type-specific check_close is defined we will only exit
-	// once that has been triggered. this is only used for a server "session"
-	// channel, to ensure that the shell has exited (and the exit status 
-	// retrieved) before we close things up.	
+	/* if a type-specific check_close is defined we will only exit
+	   once that has been triggered. this is only used for a server "session"
+	   channel, to ensure that the shell has exited (and the exit status 
+	   retrieved) before we close things up. */
 	if (!channel->type->check_close	
 			|| channel->type->check_close(channel)) {
 		close_allowed = 1;
@@ -572,6 +572,11 @@
 	
 	channel = getchannel();
 
+	if (channel->sent_close) {
+		TRACE(("leave recv_msg_channel_request: already closed channel"))
+		return;
+	}
+
 	if (channel->type->reqhandler) {
 		channel->type->reqhandler(channel);
 	} else {
@@ -686,7 +691,7 @@
 		dropbear_exit("received data after eof");
 	}
 
- 	if (fd < 0) {
+	if (fd < 0) {
 		/* If we have encountered failed write, the far side might still
 		 * be sending data without having yet received our close notification.
 		 * We just drop the data. */

=== modified file 'common-kex.c'
--- common-kex.c	2008-03-27 20:08:06 +0000
+++ common-kex.c	2008-11-19 20:58:59 +0000
@@ -295,19 +295,20 @@
 	recv_cipher = find_cipher(ses.newkeys->recv_algo_crypt->cipherdesc->name);
 	if (recv_cipher < 0)
 	    dropbear_exit("crypto error");
-		
-	if (cbc_start(recv_cipher, recv_IV, recv_key, 
+	if (ses.newkeys->recv_crypt_mode->start(recv_cipher, 
+			recv_IV, recv_key, 
 			ses.newkeys->recv_algo_crypt->keysize, 0, 
-			&ses.newkeys->recv_symmetric_struct) != CRYPT_OK) {
+			&ses.newkeys->recv_cipher_state) != CRYPT_OK) {
 		dropbear_exit("crypto error");
 	}
+
 	trans_cipher = find_cipher(ses.newkeys->trans_algo_crypt->cipherdesc->name);
 	if (trans_cipher < 0)
 	    dropbear_exit("crypto error");
-		
-	if (cbc_start(trans_cipher, trans_IV, trans_key, 
+	if (ses.newkeys->trans_crypt_mode->start(trans_cipher, 
+			trans_IV, trans_key, 
 			ses.newkeys->trans_algo_crypt->keysize, 0, 
-			&ses.newkeys->trans_symmetric_struct) != CRYPT_OK) {
+			&ses.newkeys->trans_cipher_state) != CRYPT_OK) {
 		dropbear_exit("crypto error");
 	}
 	
@@ -331,12 +332,26 @@
 }
 
 #ifndef DISABLE_ZLIB
+
+int is_compress_trans() {
+	return ses.keys->trans_algo_comp == DROPBEAR_COMP_ZLIB
+		|| (ses.authstate.authdone
+			&& ses.keys->trans_algo_comp == DROPBEAR_COMP_ZLIB_DELAY);
+}
+
+int is_compress_recv() {
+	return ses.keys->recv_algo_comp == DROPBEAR_COMP_ZLIB
+		|| (ses.authstate.authdone
+			&& ses.keys->recv_algo_comp == DROPBEAR_COMP_ZLIB_DELAY);
+}
+
 /* Set up new zlib compression streams, close the old ones. Only
  * called from gen_new_keys() */
 static void gen_new_zstreams() {
 
 	/* create new zstreams */
-	if (ses.newkeys->recv_algo_comp == DROPBEAR_COMP_ZLIB) {
+	if (ses.newkeys->recv_algo_comp == DROPBEAR_COMP_ZLIB
+			|| ses.newkeys->recv_algo_comp == DROPBEAR_COMP_ZLIB_DELAY) {
 		ses.newkeys->recv_zstream = (z_streamp)m_malloc(sizeof(z_stream));
 		ses.newkeys->recv_zstream->zalloc = Z_NULL;
 		ses.newkeys->recv_zstream->zfree = Z_NULL;
@@ -348,7 +363,8 @@
 		ses.newkeys->recv_zstream = NULL;
 	}
 
-	if (ses.newkeys->trans_algo_comp == DROPBEAR_COMP_ZLIB) {
+	if (ses.newkeys->trans_algo_comp == DROPBEAR_COMP_ZLIB
+			|| ses.newkeys->trans_algo_comp == DROPBEAR_COMP_ZLIB_DELAY) {
 		ses.newkeys->trans_zstream = (z_streamp)m_malloc(sizeof(z_stream));
 		ses.newkeys->trans_zstream->zalloc = Z_NULL;
 		ses.newkeys->trans_zstream->zfree = Z_NULL;
@@ -360,7 +376,7 @@
 	} else {
 		ses.newkeys->trans_zstream = NULL;
 	}
-	
+
 	/* clean up old keys */
 	if (ses.keys->recv_zstream != NULL) {
 		if (inflateEnd(ses.keys->recv_zstream) == Z_STREAM_ERROR) {
@@ -377,7 +393,7 @@
 		m_free(ses.keys->trans_zstream);
 	}
 }
-#endif
+#endif /* DISABLE_ZLIB */
 
 
 /* Executed upon receiving a kexinit message from the client to initiate
@@ -686,6 +702,10 @@
 			(struct dropbear_cipher*)s2c_cipher_algo->data;
 		ses.newkeys->trans_algo_crypt = 
 			(struct dropbear_cipher*)c2s_cipher_algo->data;
+		ses.newkeys->recv_crypt_mode = 
+			(struct dropbear_cipher_mode*)s2c_cipher_algo->mode;
+		ses.newkeys->trans_crypt_mode =
+			(struct dropbear_cipher_mode*)c2s_cipher_algo->mode;
 		ses.newkeys->recv_algo_mac = 
 			(struct dropbear_hash*)s2c_hash_algo->data;
 		ses.newkeys->trans_algo_mac = 
@@ -698,6 +718,10 @@
 			(struct dropbear_cipher*)c2s_cipher_algo->data;
 		ses.newkeys->trans_algo_crypt = 
 			(struct dropbear_cipher*)s2c_cipher_algo->data;
+		ses.newkeys->recv_crypt_mode =
+			(struct dropbear_cipher_mode*)c2s_cipher_algo->mode;
+		ses.newkeys->trans_crypt_mode =
+			(struct dropbear_cipher_mode*)s2c_cipher_algo->mode;
 		ses.newkeys->recv_algo_mac = 
 			(struct dropbear_hash*)c2s_hash_algo->data;
 		ses.newkeys->trans_algo_mac = 

=== modified file 'common-session.c'
--- common-session.c	2008-03-27 20:08:06 +0000
+++ common-session.c	2008-11-19 20:58:59 +0000
@@ -52,16 +52,18 @@
 
 
 /* called only at the start of a session, set up initial state */
-void common_session_init(int sock, char* remotehost) {
+void common_session_init(int sock_in, int sock_out, char* remotehost) {
 
 	TRACE(("enter session_init"))
 
 	ses.remotehost = remotehost;
 
-	ses.sock = sock;
-	ses.maxfd = sock;
+	ses.sock_in = sock_in;
+	ses.sock_out = sock_out;
+	ses.maxfd = MAX(sock_in, sock_out);
 
 	ses.connect_time = 0;
+	ses.last_trx_packet_time = 0;
 	ses.last_packet_time = 0;
 	
 	if (pipe(ses.signal_pipe) < 0) {
@@ -95,6 +97,8 @@
 	ses.newkeys = NULL;
 	ses.keys->recv_algo_crypt = &dropbear_nocipher;
 	ses.keys->trans_algo_crypt = &dropbear_nocipher;
+	ses.keys->recv_crypt_mode = &dropbear_mode_none;
+	ses.keys->trans_crypt_mode = &dropbear_mode_none;
 	
 	ses.keys->recv_algo_mac = &dropbear_nohash;
 	ses.keys->trans_algo_mac = &dropbear_nohash;
@@ -137,11 +141,11 @@
 		FD_ZERO(&writefd);
 		FD_ZERO(&readfd);
 		dropbear_assert(ses.payload == NULL);
-		if (ses.sock != -1) {
-			FD_SET(ses.sock, &readfd);
-			if (!isempty(&ses.writequeue)) {
-				FD_SET(ses.sock, &writefd);
-			}
+		if (ses.sock_in != -1) {
+			FD_SET(ses.sock_in, &readfd);
+		}
+		if (ses.sock_out != -1 && !isempty(&ses.writequeue)) {
+			FD_SET(ses.sock_out, &writefd);
 		}
 		
 		/* We get woken up when signal handlers write to this pipe.
@@ -183,12 +187,14 @@
 		checktimeouts();
 
 		/* process session socket's incoming/outgoing data */
-		if (ses.sock != -1) {
-			if (FD_ISSET(ses.sock, &writefd) && !isempty(&ses.writequeue)) {
+		if (ses.sock_out != -1) {
+			if (FD_ISSET(ses.sock_out, &writefd) && !isempty(&ses.writequeue)) {
 				write_packet();
 			}
+		}
 
-			if (FD_ISSET(ses.sock, &readfd)) {
+		if (ses.sock_in != -1) {
+			if (FD_ISSET(ses.sock_in, &readfd)) {
 				read_packet();
 			}
 			
@@ -248,14 +254,14 @@
 	int i;
 
 	/* write our version string, this blocks */
-	if (atomicio(write, ses.sock, LOCAL_IDENT "\r\n",
+	if (atomicio(write, ses.sock_out, LOCAL_IDENT "\r\n",
 				strlen(LOCAL_IDENT "\r\n")) == DROPBEAR_FAILURE) {
 		ses.remoteclosed();
 	}
 
-    /* If they send more than 50 lines, something is wrong */
+	/* If they send more than 50 lines, something is wrong */
 	for (i = 0; i < 50; i++) {
-		len = ident_readln(ses.sock, linebuf, sizeof(linebuf));
+		len = ident_readln(ses.sock_in, linebuf, sizeof(linebuf));
 
 		if (len < 0 && errno != EINTR) {
 			/* It failed */
@@ -278,11 +284,11 @@
 		memcpy(ses.remoteident, linebuf, len);
 	}
 
-    /* Shall assume that 2.x will be backwards compatible. */
-    if (strncmp(ses.remoteident, "SSH-2.", 6) != 0
-            && strncmp(ses.remoteident, "SSH-1.99-", 9) != 0) {
-        dropbear_exit("Incompatible remote version '%s'", ses.remoteident);
-    }
+	/* Shall assume that 2.x will be backwards compatible. */
+	if (strncmp(ses.remoteident, "SSH-2.", 6) != 0
+			&& strncmp(ses.remoteident, "SSH-1.99-", 9) != 0) {
+		dropbear_exit("Incompatible remote version '%s'", ses.remoteident);
+	}
 
 	TRACE(("remoteident: %s", ses.remoteident))
 
@@ -394,9 +400,14 @@
 	}
 	
 	if (opts.keepalive_secs > 0 
-		&& now - ses.last_packet_time >= opts.keepalive_secs) {
+			&& now - ses.last_trx_packet_time >= opts.keepalive_secs) {
 		send_msg_ignore();
 	}
+
+	if (opts.idle_timeout_secs > 0 && ses.last_packet_time > 0
+			&& now - ses.last_packet_time >= opts.idle_timeout_secs) {
+		dropbear_close("Idle timeout");
+	}
 }
 
 static long select_timeout() {
@@ -409,5 +420,39 @@
 		ret = MIN(AUTH_TIMEOUT, ret);
 	if (opts.keepalive_secs > 0)
 		ret = MIN(opts.keepalive_secs, ret);
+    if (opts.idle_timeout_secs > 0)
+        ret = MIN(opts.idle_timeout_secs, ret);
 	return ret;
 }
+
+const char* get_user_shell() {
+	/* an empty shell should be interpreted as "/bin/sh" */
+	if (ses.authstate.pw_shell[0] == '\0') {
+		return "/bin/sh";
+	} else {
+		return ses.authstate.pw_shell;
+	}
+}
+void fill_passwd(const char* username) {
+	struct passwd *pw = NULL;
+	if (ses.authstate.pw_name)
+		m_free(ses.authstate.pw_name);
+	if (ses.authstate.pw_dir)
+		m_free(ses.authstate.pw_dir);
+	if (ses.authstate.pw_shell)
+		m_free(ses.authstate.pw_shell);
+	if (ses.authstate.pw_passwd)
+		m_free(ses.authstate.pw_passwd);
+
+	pw = getpwnam(username);
+	if (!pw) {
+		return;
+	}
+	ses.authstate.pw_uid = pw->pw_uid;
+	ses.authstate.pw_gid = pw->pw_gid;
+	ses.authstate.pw_name = m_strdup(pw->pw_name);
+	ses.authstate.pw_dir = m_strdup(pw->pw_dir);
+	ses.authstate.pw_shell = m_strdup(pw->pw_shell);
+	ses.authstate.pw_passwd = m_strdup(pw->pw_passwd);
+}
+

=== modified file 'dbclient.1'
--- dbclient.1	2008-03-27 20:08:06 +0000
+++ dbclient.1	2008-11-19 20:58:59 +0000
@@ -10,6 +10,13 @@
 .I l\fR:\fIh\fR:\fIr\fR] [\-l
 .IR user ]
 .I host
+.RI [ command ]
+
+.B dbclient
+[
+.I args ]
+.I [user1]@host1[/port1],[user2]@host2[/port2],...
+
 .SH DESCRIPTION
 .B dbclient
 is a SSH 2 client designed to be small enough to be used in small memory
@@ -86,22 +93,52 @@
 a certain period of inactivity. The trade-off is that a session may be
 closed if there is a temporary lapse of network connectivity. A setting
 if 0 disables keepalives.
+.TP
+.B \-I \fIidle_timeout
+Disconnect the session if no traffic is transmitted or received for \fIidle_timeout\fR seconds.
+.TP
+.B \-J \fIproxy_command
+Use the standard input/output of the program \fIproxy_command\fR rather than using
+a normal TCP connection. A hostname should be still be provided, as this is used for
+comparing saved hostkeys.
+.TP
+.B \-B \fIendhost:endport
+"Netcat-alike" mode, where Dropbear will connect to the given host, then create a
+forwarded connection to \fIendhost\fR. This will then be presented as dbclient's
+standard input/output.
+
+Dropbear will also allow multiple "hops" to be specified, separated by commas. In
+this case a connection will be made to the first host, then a TCP forwarded 
+connection will be made through that to the second host, and so on. Hosts other than
+the final destination will not see anything other than the encrypted SSH stream. 
+A port for a host can be specified with a slash (eg matt@martello/44 ).
+This syntax can also be used with scp or rsync (specifying dbclient as the 
+ssh/rsh command). A file can be "bounced" through multiple SSH hops, eg
+
+scp -S dbclient matt@martello,root@wrt,canyons:/tmp/dump .
+
+Note that hostnames are resolved by the prior hop (so "canyons" would be resolved by the host "wrt")
+in the example above, the same way as other -L TCP forwarded hosts are. Host keys are 
+checked locally based on the given hostname.
+
 .SH ENVIRONMENT
 .TP
+.B DROPBEAR_PASSWORD
+A password to use for remote authentication can be specified in the environment
+variable DROPBEAR_PASSWORD. Care should be taken that the password is not
+exposed to other users on a multi-user system, or stored in accessible files.
+.TP
 .B SSH_ASKPASS
 dbclient can use an external program to request a password from a user.
 SSH_ASKPASS should be set to the path of a program that will return a password
 on standard output. This program will only be used if either DISPLAY is set and
 standard input is not a TTY, or the environment variable SSH_ASKPASS_ALWAYS is
 set.
-.TP
-.B DROPBEAR_PASSWORD
-A password to use for remote authentication can be specified in the environment
-variable DROPBEAR_PASSWORD. Care should be taken that the password is not
-exposed to other users on a multi-user system, or stored in accessible files.
 .SH AUTHOR
 Matt Johnston (matt@ucc.asn.au).
 .br
+Mihnea Stoenescu wrote initial Dropbear client support
+.br
 Gerrit Pape (pape@smarden.org) wrote this manual page.
 .SH SEE ALSO
 dropbear(8), dropbearkey(8)

=== modified file 'dbutil.c'
--- dbutil.c	2008-03-27 20:08:06 +0000
+++ dbutil.c	2008-11-19 20:58:59 +0000
@@ -146,7 +146,7 @@
 	}
 
 	va_start(param, format);
-	fprintf(stderr, "TRACE: ");
+	fprintf(stderr, "TRACE (%d): ", getpid());
 	vfprintf(stderr, format, param);
 	fprintf(stderr, "\n");
 	va_end(param);
@@ -321,9 +321,10 @@
 	if (err) {
 		if (errstring != NULL && *errstring == NULL) {
 			int len;
-			len = 20 + strlen(gai_strerror(err));
+			len = 100 + strlen(gai_strerror(err));
 			*errstring = (char*)m_malloc(len);
-			snprintf(*errstring, len, "Error resolving: %s", gai_strerror(err));
+			snprintf(*errstring, len, "Error resolving '%s' port '%s'. %s", 
+					remotehost, remoteport, gai_strerror(err));
 		}
 		TRACE(("Error resolving: %s", gai_strerror(err)))
 		return -1;
@@ -389,6 +390,141 @@
 	return sock;
 }
 
+/* Sets up a pipe for a, returning three non-blocking file descriptors
+ * and the pid. exec_fn is the function that will actually execute the child process,
+ * it will be run after the child has fork()ed, and is passed exec_data.
+ * If ret_errfd == NULL then stderr will not be captured.
+ * ret_pid can be passed as  NULL to discard the pid. */
+int spawn_command(void(*exec_fn)(void *user_data), void *exec_data,
+		int *ret_writefd, int *ret_readfd, int *ret_errfd, pid_t *ret_pid) {
+	int infds[2];
+	int outfds[2];
+	int errfds[2];
+	pid_t pid;
+
+	const int FDIN = 0;
+	const int FDOUT = 1;
+
+	/* redirect stdin/stdout/stderr */
+	if (pipe(infds) != 0) {
+		return DROPBEAR_FAILURE;
+	}
+	if (pipe(outfds) != 0) {
+		return DROPBEAR_FAILURE;
+	}
+	if (ret_errfd && pipe(errfds) != 0) {
+		return DROPBEAR_FAILURE;
+	}
+
+#ifdef __uClinux__
+	pid = vfork();
+#else
+	pid = fork();
+#endif
+
+	if (pid < 0) {
+		return DROPBEAR_FAILURE;
+	}
+
+	if (!pid) {
+		/* child */
+
+		TRACE(("back to normal sigchld"))
+		/* Revert to normal sigchld handling */
+		if (signal(SIGCHLD, SIG_DFL) == SIG_ERR) {
+			dropbear_exit("signal() error");
+		}
+
+		/* redirect stdin/stdout */
+
+		if ((dup2(infds[FDIN], STDIN_FILENO) < 0) ||
+			(dup2(outfds[FDOUT], STDOUT_FILENO) < 0) ||
+			(ret_errfd && dup2(errfds[FDOUT], STDERR_FILENO) < 0)) {
+			TRACE(("leave noptycommand: error redirecting FDs"))
+			dropbear_exit("child dup2() failure");
+		}
+
+		close(infds[FDOUT]);
+		close(infds[FDIN]);
+		close(outfds[FDIN]);
+		close(outfds[FDOUT]);
+		if (ret_errfd)
+		{
+			close(errfds[FDIN]);
+			close(errfds[FDOUT]);
+		}
+
+		exec_fn(exec_data);
+		/* not reached */
+		return DROPBEAR_FAILURE;
+	} else {
+		/* parent */
+		close(infds[FDIN]);
+		close(outfds[FDOUT]);
+
+		setnonblocking(outfds[FDIN]);
+		setnonblocking(infds[FDOUT]);
+
+		if (ret_errfd) {
+			close(errfds[FDOUT]);
+			setnonblocking(errfds[FDIN]);
+		}
+
+		if (ret_pid) {
+			*ret_pid = pid;
+		}
+
+		*ret_writefd = infds[FDOUT];
+		*ret_readfd = outfds[FDIN];
+		if (ret_errfd) {
+			*ret_errfd = errfds[FDIN];
+		}
+		return DROPBEAR_SUCCESS;
+	}
+}
+
+/* Runs a command with "sh -c". Will close FDs (except stdin/stdout/stderr) and
+ * re-enabled SIGPIPE. If cmd is NULL, will run a login shell.
+ */
+void run_shell_command(const char* cmd, unsigned int maxfd, char* usershell) {
+	char * argv[4];
+	char * baseshell = NULL;
+	unsigned int i;
+
+	baseshell = basename(usershell);
+
+	if (cmd != NULL) {
+		argv[0] = baseshell;
+	} else {
+		/* a login shell should be "-bash" for "/bin/bash" etc */
+		int len = strlen(baseshell) + 2; /* 2 for "-" */
+		argv[0] = (char*)m_malloc(len);
+		snprintf(argv[0], len, "-%s", baseshell);
+	}
+
+	if (cmd != NULL) {
+		argv[1] = "-c";
+		argv[2] = (char*)cmd;
+		argv[3] = NULL;
+	} else {
+		/* construct a shell of the form "-bash" etc */
+		argv[1] = NULL;
+	}
+
+	/* Re-enable SIGPIPE for the executed process */
+	if (signal(SIGPIPE, SIG_DFL) == SIG_ERR) {
+		dropbear_exit("signal() error");
+	}
+
+	/* close file descriptors except stdin/stdout/stderr
+	 * Need to be sure FDs are closed here to avoid reading files as root */
+	for (i = 3; i <= maxfd; i++) {
+		m_close(i);
+	}
+
+	execv(usershell, argv);
+}
+
 /* Return a string representation of the socket address passed. The return
  * value is allocated with malloc() */
 unsigned char * getaddrstring(struct sockaddr_storage* addr, int withport) {
@@ -699,3 +835,17 @@
 	lim.rlim_cur = lim.rlim_max = 0;
 	setrlimit(RLIMIT_CORE, &lim);
 }
+
+/* Returns DROPBEAR_SUCCESS or DROPBEAR_FAILURE, with the result in *val */
+int m_str_to_uint(const char* str, unsigned int *val) {
+	errno = 0;
+	*val = strtoul(str, NULL, 10);
+	/* The c99 spec doesn't actually seem to define EINVAL, but most platforms
+	 * I've looked at mention it in their manpage */
+	if ((*val == 0 && errno == EINVAL)
+		|| (*val == ULONG_MAX && errno == ERANGE)) {
+		return DROPBEAR_FAILURE;
+	} else {
+		return DROPBEAR_SUCCESS;
+	}
+}

=== modified file 'dbutil.h'
--- dbutil.h	2008-03-27 20:08:06 +0000
+++ dbutil.h	2008-11-19 20:58:59 +0000
@@ -49,6 +49,9 @@
 unsigned char * getaddrstring(struct sockaddr_storage* addr, int withport);
 int dropbear_listen(const char* address, const char* port,
 		int *socks, unsigned int sockcount, char **errstring, int *maxfd);
+int spawn_command(void(*exec_fn)(void *user_data), void *exec_data,
+		int *writefd, int *readfd, int *errfd, pid_t *pid);
+void run_shell_command(const char* cmd, unsigned int maxfd, char* usershell);
 int connect_remote(const char* remotehost, const char* remoteport,
 		int nonblocking, char ** errstring);
 char* getaddrhostname(struct sockaddr_storage * addr);
@@ -64,6 +67,7 @@
 void m_burn(void* data, unsigned int len);
 void setnonblocking(int fd);
 void disallow_core();
+int m_str_to_uint(const char* str, unsigned int *val);
 
 /* Used to force mp_ints to be initialised */
 #define DEF_MP_INT(X) mp_int X = {0, 0, 0, NULL}

=== modified file 'debian/changelog'
--- debian/changelog	2008-03-27 20:08:06 +0000
+++ debian/changelog	2008-11-19 20:58:59 +0000
@@ -1,3 +1,25 @@
+dropbear (0.52-1) unstable; urgency=low
+
+  [ Matt Johnston ]
+  * New upstream release.
+    * dbclient.1: mention optional 'command' argument (closes: #495823).
+
+  [ Gerrit Pape ]
+  * debian/diff/0001-dbclient.1-dbclient-uses-compression-if...diff:
+    new; dbclient.1: dbclient uses compression if compiled with zlib
+    support (thx Luca Capello, closes: #495825).
+  * debian/initramfs/*: new; cryptroot remote unlocking on boot feature
+    (thx debian@x.ray.net).
+  * debian/rules: install debian/initramfs/* (thx debian@x.ray.net).
+  * debian/control: Suggests: udev (for cryptroot support, thx
+    debian@x.ray.net).
+  * debian/dropbear.postinst: conditionally run update-initramfs -u
+    (for cryptroot support, thx debian@x.ray.net. closes: #465903).
+  * debian/diff/0002-dropbearkey.8-mention-y-option-add-example.diff:
+    new; mention -y option, add example (thx debian@x.ray.net).
+
+ -- Gerrit Pape <pape@smarden.org>  Wed, 19 Nov 2008 20:58:59 +0000
+
 dropbear (0.51-1) unstable; urgency=low
 
   [ Matt Johnston ]

=== modified file 'debian/control'
--- debian/control	2008-03-27 20:08:06 +0000
+++ debian/control	2008-11-19 20:58:59 +0000
@@ -8,7 +8,7 @@
 Package: dropbear
 Architecture: any
 Depends: ${shlibs:Depends}
-Suggests: openssh-client, runit
+Suggests: openssh-client, udev, runit
 Description: lightweight SSH2 server and client
  dropbear is a SSH 2 server and client designed to be small enough to
  be used in small memory environments, while still being functional and

=== added directory 'debian/diff'
=== added file 'debian/diff/0001-dbclient.1-dbclient-uses-compression-if-compiled-wit.diff'
--- debian/diff/0001-dbclient.1-dbclient-uses-compression-if-compiled-wit.diff	1970-01-01 00:00:00 +0000
+++ debian/diff/0001-dbclient.1-dbclient-uses-compression-if-compiled-wit.diff	2008-11-19 20:58:59 +0000
@@ -0,0 +1,46 @@
+From 5b0c6006ef0b9c2c3a8770921b21965eba0e4372 Mon Sep 17 00:00:00 2001
+From: Gerrit Pape <pape@smarden.org>
+Date: Wed, 19 Nov 2008 20:00:53 +0000
+Subject: [PATCH] dbclient.1: dbclient uses compression if compiled with zlib support
+
+On Fri, Sep 26, 2008 at 03:40:57PM +0200, Luca Capello wrote:
+> On Tue, 23 Sep 2008 16:24:25 +0200, Matt Johnston wrote:
+> > On Wed, Aug 20, 2008 at 07:43:58PM +0200, Luca Capello wrote:
+> >> Could you please clarify if dbclient really support compression or not?
+> >> If yes, could you please explain in the manpage how to enable it?
+> >
+> > As long as Dropbear was compiled with zlib support (which I
+> > assume is the case for Debian)
+>
+> It seems so, at least the source build-depends on libz-dev and the
+> binary depends on zlib1g.
+>
+> > dbclient will always use compression if the server supports it. There
+> > isn't any option to disable it at the moment.
+>
+> Is there a way to test that compression is used?  I'm sorry, but I'm
+> really not an expert about these stuff.
+>
+> Could the following patch against version 0.51 be applied to the
+> dbclient manpage?
+---
+ dbclient.1 |    3 +++
+ 1 files changed, 3 insertions(+), 0 deletions(-)
+
+diff --git a/dbclient.1 b/dbclient.1
+index 96e6c5c..99f999b 100644
+--- a/dbclient.1
++++ b/dbclient.1
+@@ -21,6 +21,9 @@ dbclient \- lightweight SSH2 client
+ .B dbclient
+ is a SSH 2 client designed to be small enough to be used in small memory
+ environments, while still being functional and secure enough for general use.
++.P
++If compiled with zlib support and if the server supports it, dbclient will
++always use compression.
+ .SH OPTIONS
+ .TP
+ .B \-p \fIport
+-- 
+1.6.0
+

=== added file 'debian/diff/0002-dropbearkey.8-mention-y-option-add-example.diff'
--- debian/diff/0002-dropbearkey.8-mention-y-option-add-example.diff	1970-01-01 00:00:00 +0000
+++ debian/diff/0002-dropbearkey.8-mention-y-option-add-example.diff	2008-11-19 20:58:59 +0000
@@ -0,0 +1,43 @@
+From 133beee38cbde31f153668426a9ea717e4f57603 Mon Sep 17 00:00:00 2001
+From: Gerrit Pape <pape@smarden.org>
+Date: Wed, 19 Nov 2008 20:57:36 +0000
+Subject: [PATCH] dropbearkey.8: mention -y option, add example
+
+Patch from debian@x.ray.net through
+ http://bugs.debian.org/465903
+---
+ dropbearkey.8 |    9 +++++++++
+ 1 files changed, 9 insertions(+), 0 deletions(-)
+
+diff --git a/dropbearkey.8 b/dropbearkey.8
+index b5745dd..d6632d2 100644
+--- a/dropbearkey.8
++++ b/dropbearkey.8
+@@ -9,6 +9,7 @@ dropbearkey \- create private keys for the use with dropbear(8)
+ .I file
+ [\-s
+ .IR bits ]
++[\-y]
+ .SH DESCRIPTION
+ .B dropbearkey
+ generates a
+@@ -38,8 +39,16 @@ Write the secret key to the file
+ Set the key size to
+ .I bits
+ bits, should be multiple of 8 (optional).
++.TP
++.B \-y
++Just print the publickey and fingerprint for the private key in
++.IR file .
+ .SH EXAMPLE
++generate a host-key:
+  # dropbearkey -t rsa -f /etc/dropbear/dropbear_rsa_host_key
++
++extract a public key suitable for authorized_keys from private key:
++ # dropbearkey -y -f id_rsa | grep "^ssh-rsa " >> authorized_keys
+ .SH AUTHOR
+ Matt Johnston (matt@ucc.asn.au).
+ .br
+-- 
+1.6.0
+

=== modified file 'debian/dropbear.postinst'
--- debian/dropbear.postinst	2008-03-27 20:08:06 +0000
+++ debian/dropbear.postinst	2008-11-19 20:58:59 +0000
@@ -61,6 +61,26 @@
 EOT
 fi
 
+# cryptroot support (debian@x.ray.net)
+#   if dropbear is to be installed to initramfs, we have to update initramfs.
+if test -r /etc/initramfs-tools/initramfs.conf &&
+   test -x /usr/sbin/update-initramfs; then
+  . /etc/initramfs-tools/initramfs.conf
+  if test "${DROPBEAR}" = "y" || test -r "/etc/crypttab"; then
+    # here we could read the configured network-config, and use it for
+    # default values for prompting the user for the initramfs-network-
+    # config (subsequently writing it to menu.lst:# kopt= or lilo.conf),
+    # instead of just printing the reminder below.
+    update-initramfs -u
+    cat <<-\EOT
+	Dropbear has been added to the initramfs. Don't forget to check
+	your "ip=" kernel bootparameter to match your desired initramfs
+	ip configuration.
+	
+	EOT
+  fi
+fi
+
 if test -x /etc/init.d/dropbear; then
   update-rc.d dropbear defaults >/dev/null
   if test -x /usr/sbin/invoke-rc.d; then

=== added directory 'debian/initramfs'
=== added file 'debian/initramfs/bottom-dropbear'
--- debian/initramfs/bottom-dropbear	1970-01-01 00:00:00 +0000
+++ debian/initramfs/bottom-dropbear	2008-11-19 20:58:59 +0000
@@ -0,0 +1,23 @@
+#!/bin/sh
+
+PREREQ=""
+
+prereqs() {
+	echo "$PREREQ"
+}
+
+case "$1" in
+	prereqs)
+		prereqs
+		exit 0
+	;;
+esac
+
+. /scripts/functions
+
+[ -r /var/run/dropbear.pid ] || exit 0
+
+log_begin_msg "Stopping dropbear"
+
+kill `cat /var/run/dropbear.pid`
+

=== added file 'debian/initramfs/dropbear-conf'
--- debian/initramfs/dropbear-conf	1970-01-01 00:00:00 +0000
+++ debian/initramfs/dropbear-conf	2008-11-19 20:58:59 +0000
@@ -0,0 +1,8 @@
+#
+# DROPBEAR: [ y | n ]
+#
+# Use dropbear if available. If not specified, dropbear will be used - if
+# possible - in case of cryptroot.
+#
+
+#DROPBEAR=y

=== added file 'debian/initramfs/dropbear-hook'
--- debian/initramfs/dropbear-hook	1970-01-01 00:00:00 +0000
+++ debian/initramfs/dropbear-hook	2008-11-19 20:58:59 +0000
@@ -0,0 +1,49 @@
+#!/bin/sh
+
+PREREQ=""
+
+prereqs() {
+	echo "$PREREQ"
+}
+
+case "$1" in
+	prereqs)
+		prereqs
+		exit 0
+	;;
+esac
+
+. "${CONFDIR}/initramfs.conf"
+. /usr/share/initramfs-tools/hook-functions
+
+# Install dropbear if explicitly enabled, or in case of a cryptroot setup if not explicitly disabled
+if [ "${DROPBEAR}" = "y" ] || ( [ "${DROPBEAR}" != "n" ] && [ -r "/etc/crypttab" ] ); then
+	if [ ! -x "/usr/sbin/dropbear" ]; then
+		if [ "${DROPBEAR}" = "y" ]; then
+			echo "dropbear: FAILURE: Dropbear not found!"
+		else
+			echo "dropbear: WARNING: Dropbear not found, remote unlocking of cryptroot via ssh won't work!"
+		fi
+	else
+		rm -f "${DESTDIR}/sbin/dropbear"
+		copy_exec "/usr/sbin/dropbear" "/sbin/"
+		cp /lib/libnss_* "${DESTDIR}/lib/"
+		echo "root:x:0:0:root:/root:/bin/sh" > "${DESTDIR}/etc/passwd"
+		for keytype in "dss" "rsa"; do
+			if [ ! -f "/etc/initramfs-tools/etc/dropbear/dropbear_${keytype}_host_key" ]; then
+				mkdir -p "/etc/initramfs-tools/etc/dropbear"
+				dropbearkey -t "${keytype}" -f "/etc/initramfs-tools/etc/dropbear/dropbear_${keytype}_host_key"
+			fi
+		done
+		cp -R /etc/initramfs-tools/etc/dropbear "${DESTDIR}/etc/"
+		if [ ! -f "/etc/initramfs-tools/root/.ssh/id_rsa.pub" ]; then
+			mkdir -p "/etc/initramfs-tools/root/.ssh"
+			dropbearkey -t rsa -f /etc/initramfs-tools/root/.ssh/id_rsa.dropbear
+			/usr/lib/dropbear/dropbearconvert dropbear openssh /etc/initramfs-tools/root/.ssh/id_rsa.dropbear /etc/initramfs-tools/root/.ssh/id_rsa
+			dropbearkey -y -f /etc/initramfs-tools/root/.ssh/id_rsa.dropbear | grep "^ssh-rsa " > /etc/initramfs-tools/root/.ssh/id_rsa.pub
+		fi
+		mkdir -p "${DESTDIR}/root/.ssh"
+		cp /etc/initramfs-tools/root/.ssh/id_rsa.pub "${DESTDIR}/root/.ssh/authorized_keys"
+	fi
+fi
+

=== added file 'debian/initramfs/premount-devpts'
--- debian/initramfs/premount-devpts	1970-01-01 00:00:00 +0000
+++ debian/initramfs/premount-devpts	2008-11-19 20:58:59 +0000
@@ -0,0 +1,24 @@
+#!/bin/sh
+
+PREREQ="udev"
+
+prereqs() {
+	echo "$PREREQ"
+}
+
+case "$1" in
+	prereqs)
+		prereqs
+		exit 0
+	;;
+esac
+
+. /scripts/functions
+
+grep -E "[[:space:]]+devpts$" /proc/filesystems >/dev/null 2>&1 || exit 0
+
+log_begin_msg "Mounting devpts"
+
+mkdir -p /dev/pts
+mount -t devpts none /dev/pts
+

=== added file 'debian/initramfs/premount-dropbear'
--- debian/initramfs/premount-dropbear	1970-01-01 00:00:00 +0000
+++ debian/initramfs/premount-dropbear	2008-11-19 20:58:59 +0000
@@ -0,0 +1,36 @@
+#!/bin/sh
+
+PREREQ="udev devpts"
+
+prereqs() {
+	echo "$PREREQ"
+}
+
+case "$1" in
+	prereqs)
+		prereqs
+		exit 0
+	;;
+esac
+
+. /scripts/functions
+
+[ -x /sbin/dropbear ] || exit 0
+
+log_begin_msg "Starting dropbear"
+
+. /conf/initramfs.conf
+
+for x in $(cat /proc/cmdline); do
+	case "$x" in
+		ip=*)
+			IPOPTS="${x#ip=}"
+			;;
+	esac
+done
+
+configure_networking
+
+mkdir -p /var/run
+/sbin/dropbear
+

=== modified file 'debian/rules'
--- debian/rules	2008-03-27 20:08:06 +0000
+++ debian/rules	2008-11-19 20:58:59 +0000
@@ -77,6 +77,23 @@
 	install -d -m0755 '$(DIR)'/etc/dropbear/log
 	install -m0755 debian/service/log '$(DIR)'/etc/dropbear/log/run
 	ln -s /var/log/dropbear '$(DIR)'/etc/dropbear/log/main
+	# cryptroot support (debian@x.ray.net)
+	install -d -m0755 '$(DIR)'/usr/share/initramfs-tools/hooks
+	install -m0755 debian/initramfs/dropbear-hook \
+	  '$(DIR)'/usr/share/initramfs-tools/hooks/dropbear
+	install -d -m0755 \
+	  '$(DIR)'/usr/share/initramfs-tools/scripts/init-premount
+	install -m0755 debian/initramfs/premount-devpts \
+	  '$(DIR)'/usr/share/initramfs-tools/scripts/init-premount/devpts
+	install -m0755 debian/initramfs/premount-dropbear \
+	  '$(DIR)'/usr/share/initramfs-tools/scripts/init-premount/dropbear
+	install -d -m0755 \
+	  '$(DIR)'/usr/share/initramfs-tools/scripts/init-bottom
+	install -m0755 debian/initramfs/bottom-dropbear \
+	  '$(DIR)'/usr/share/initramfs-tools/scripts/init-bottom/dropbear
+	install -d -m0755 '$(DIR)'/usr/share/initramfs-tools/conf-hooks.d
+	install -m0644 debian/initramfs/dropbear-conf \
+	  '$(DIR)'/usr/share/initramfs-tools/conf-hooks.d/dropbear
 	# man pages
 	install -d -m0755 '$(DIR)'/usr/share/man/man8
 	for i in dropbear.8 dropbearkey.8; do \

=== modified file 'debug.h'
--- debug.h	2008-03-27 20:08:06 +0000
+++ debug.h	2008-11-19 20:58:59 +0000
@@ -67,6 +67,11 @@
 #define TRACE(X)
 #endif /*DEBUG_TRACE*/
 
+/* To debug with GDB it is easier to run with no forking of child processes.
+   You will need to pass "-F" as well. */
+/* #define DEBUG_NOFORK */
+
+
 /* For testing as non-root on shadowed systems, include the crypt of a password
  * here. You can then log in as any user with this password. Ensure that you
  * make your own password, and are careful about using this. This will also

=== modified file 'dropbear.8'
--- dropbear.8	2008-03-27 20:08:06 +0000
+++ dropbear.8	2008-11-19 20:58:59 +0000
@@ -24,7 +24,10 @@
 dsskeyfile.
 Use the contents of the file
 .I dsskey
-for the dss host key (default: /etc/dropbear/dropbear_dss_host_key).
+for the DSS host key (default: /etc/dropbear/dropbear_dss_host_key). 
+Note that 
+some SSH implementations
+use the term "DSA" rather than "DSS", they mean the same thing.
 This file is generated with
 .BR dropbearkey (8).
 .TP
@@ -94,6 +97,63 @@
 a certain period of inactivity. The trade-off is that a session may be
 closed if there is a temporary lapse of network connectivity. A setting
 if 0 disables keepalives.
+.TP
+.B \-I \fIidle_timeout
+Disconnect the session if no traffic is transmitted or received for \fIidle_timeout\fR seconds.
+.SH FILES
+
+.TP
+Authorized Keys
+
+~/.ssh/authorized_keys can be set up to allow remote login with a RSA or DSS
+key. Each line is of the form
+.TP
+[restrictions] ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIgAsp... [comment]
+
+and can be extracted from a Dropbear private host key with "dropbearkey -y". This is the same format as used by OpenSSH, though the restrictions are a subset (keys with unknown restrictions are ignored).
+Restrictions are comma separated, with double quotes around spaces in arguments.
+Available restrictions are:
+
+.TP
+.B no-port-forwarding
+Don't allow port forwarding for this connection
+
+.TP
+.B no-agent-forwarding
+Don't allow agent forwarding for this connection
+
+.TP
+.B no-X11-forwarding
+Don't allow X11 forwarding for this connection
+
+.TP
+.B no-pty
+Disable PTY allocation. Note that a user can still obtain most of the
+same functionality with other means even if no-pty is set.
+
+.TP
+.B command="\fIforced_command\fR"
+Disregard the command provided by the user and always run \fIforced_command\fR.
+
+The authorized_keys file and its containing ~/.ssh directory must only be
+writable by the user, otherwise Dropbear will not allow a login using public
+key authentication.
+
+.TP
+Host Key Files
+
+Host key files are read at startup from a standard location, by default
+/etc/dropbear/dropbear_dss_host_key and /etc/dropbear/dropbear_rsa_host_key
+or specified on the commandline with -d or -r. These are of the form generated
+by dropbearkey.
+
+.TP
+Message Of The Day
+
+By default the file /etc/motd will be printed for any login shell (unless 
+disabled at compile-time). This can also be disabled per-user
+by creating a file ~/.hushlogin .
+
 .SH AUTHOR
 Matt Johnston (matt@ucc.asn.au).
 .br

=== modified file 'dropbearkey.8'
--- dropbearkey.8	2006-04-16 16:16:40 +0000
+++ dropbearkey.8	2008-11-19 20:58:59 +0000
@@ -11,13 +11,16 @@
 .IR bits ]
 .SH DESCRIPTION
 .B dropbearkey
-generates a type
-.I rsa
+generates a
+.I RSA
 or
-.I dss
-SSH private key, and saves it to a file for the use with the
+.I DSS
+format SSH private key, and saves it to a file for the use with the
 .BR dropbear (8)
 SSH 2 server.
+Note that 
+some SSH implementations
+use the term "DSA" rather than "DSS", they mean the same thing.
 .SH OPTIONS
 .TP
 .B \-t \fItype

=== modified file 'genrsa.c'
--- genrsa.c	2006-04-16 16:16:40 +0000
+++ genrsa.c	2008-11-19 20:58:59 +0000
@@ -62,17 +62,13 @@
 		exit(1);
 	}
 
-	/* PuTTY doesn't like it if the modulus isn't a multiple of 8 bits,
-	 * so we just generate them until we get one which is OK */
 	getrsaprime(key->p, &pminus, key->e, size/2);
-	do {
-		getrsaprime(key->q, &qminus, key->e, size/2);
+	getrsaprime(key->q, &qminus, key->e, size/2);
 
-		if (mp_mul(key->p, key->q, key->n) != MP_OKAY) {
-			fprintf(stderr, "rsa generation failed\n");
-			exit(1);
-		}
-	} while (mp_count_bits(key->n) % 8 != 0);
+	if (mp_mul(key->p, key->q, key->n) != MP_OKAY) {
+		fprintf(stderr, "rsa generation failed\n");
+		exit(1);
+	}
 
 	/* lcm(p-1, q-1) */
 	if (mp_lcm(&pminus, &qminus, &lcm) != MP_OKAY) {

=== modified file 'kex.h'
--- kex.h	2008-03-27 20:08:06 +0000
+++ kex.h	2008-11-19 20:58:59 +0000
@@ -37,6 +37,11 @@
 void kexdh_comb_key(mp_int *dh_pub_us, mp_int *dh_priv, mp_int *dh_pub_them,
 		sign_key *hostkey);
 
+#ifndef DISABLE_ZLIB
+int is_compress_trans();
+int is_compress_recv();
+#endif
+
 void recv_msg_kexdh_init(); /* server */
 
 void send_msg_kexdh_init(); /* client */

=== modified file 'keyimport.c'
--- keyimport.c	2008-03-27 20:08:06 +0000
+++ keyimport.c	2008-11-19 20:58:59 +0000
@@ -701,7 +701,6 @@
 	int nnumbers = -1, pos, len, seqlen, i;
 	char *header = NULL, *footer = NULL;
 	char zero[1];
-	unsigned char iv[8];
 	int ret = 0;
 	FILE *fp;
 	int keytype = -1;

=== modified file 'libtomcrypt/src/headers/tomcrypt_custom.h'
--- libtomcrypt/src/headers/tomcrypt_custom.h	2008-03-27 20:08:06 +0000
+++ libtomcrypt/src/headers/tomcrypt_custom.h	2008-11-19 20:58:59 +0000
@@ -90,15 +90,15 @@
 /* #define LTC_NO_BSWAP */
 
 
-#ifdef DROPBEAR_BLOWFISH_CBC
+#ifdef DROPBEAR_BLOWFISH
 #define BLOWFISH
 #endif
 
-#ifdef DROPBEAR_AES_CBC
+#ifdef DROPBEAR_AES
 #define RIJNDAEL
 #endif
 
-#ifdef DROPBEAR_TWOFISH_CBC
+#ifdef DROPBEAR_TWOFISH
 #define TWOFISH
 
 /* enabling just TWOFISH_SMALL will make the binary ~1kB smaller, turning on
@@ -108,12 +108,16 @@
 /*#define TWOFISH_TABLES*/
 #endif
 
-#ifdef DROPBEAR_3DES_CBC
+#ifdef DROPBEAR_3DES
 #define DES
 #endif
 
 #define LTC_CBC_MODE
 
+#ifdef DROPBEAR_ENABLE_CTR_MODE
+#define LTC_CTR_MODE
+#endif
+
 #if defined(DROPBEAR_DSS) && defined(DSS_PROTOK)
 #define SHA512
 #endif

=== modified file 'loginrec.c'
--- loginrec.c	2005-12-12 09:14:33 +0000
+++ loginrec.c	2008-11-19 20:58:59 +0000
@@ -1334,7 +1334,7 @@
 			return 0;
 	}
 
-	*fd = open(lastlog_file, filemode);
+	*fd = open(lastlog_file, filemode, 0600);
 	if ( *fd < 0) {
 		dropbear_log(LOG_INFO, "lastlog_openseek: Couldn't open %s: %s",
 		    lastlog_file, strerror(errno));

=== modified file 'options.h'
--- options.h	2008-03-27 20:08:06 +0000
+++ options.h	2008-11-19 20:58:59 +0000
@@ -66,19 +66,36 @@
 /* Enable Authentication Agent Forwarding - server only for now */
 #define ENABLE_AGENTFWD
 
+
+/* Note: Both ENABLE_CLI_PROXYCMD and ENABLE_CLI_NETCAT must be set to
+ * allow multihop dbclient connections */
+
+/* Allow using -J <proxycommand> to run the connection through a 
+   pipe to a program, rather the normal TCP connection */
+#define ENABLE_CLI_PROXYCMD
+
+/* Enable "Netcat mode" option. This will forward standard input/output
+ * to a remote TCP-forwarded connection */
+#define ENABLE_CLI_NETCAT
+
 /* Encryption - at least one required.
- * RFC Draft requires 3DES and recommends AES128 for interoperability.
+ * Protocol RFC requires 3DES and recommends AES128 for interoperability.
  * Including multiple keysize variants the same cipher 
  * (eg AES256 as well as AES128) will result in a minimal size increase.*/
-#define DROPBEAR_AES128_CBC
-#define DROPBEAR_3DES_CBC
-#define DROPBEAR_AES256_CBC
-#define DROPBEAR_BLOWFISH_CBC
-#define DROPBEAR_TWOFISH256_CBC
-#define DROPBEAR_TWOFISH128_CBC
+#define DROPBEAR_AES128
+#define DROPBEAR_3DES
+#define DROPBEAR_AES256
+#define DROPBEAR_BLOWFISH
+#define DROPBEAR_TWOFISH256
+#define DROPBEAR_TWOFISH128
+
+/* Enable "Counter Mode" for ciphers. This is more secure than normal
+ * CBC mode against certain attacks. This adds around 1kB to binary 
+ * size and is recommended for most cases */
+#define DROPBEAR_ENABLE_CTR_MODE
 
 /* Message Integrity - at least one required.
- * RFC Draft requires sha1 and recommends sha1-96.
+ * Protocol RFC requires sha1 and recommends sha1-96.
  * sha1-96 may be of use for slow links, as it has a smaller overhead.
  *
  * Note: there's no point disabling sha1 to save space, since it's used
@@ -133,9 +150,15 @@
  * You can't enable both PASSWORD and PAM. */
 
 #define ENABLE_SVR_PASSWORD_AUTH
-/*#define ENABLE_SVR_PAM_AUTH */ /* requires ./configure --enable-pam */
+/* PAM requires ./configure --enable-pam */
+/*#define ENABLE_SVR_PAM_AUTH*/
 #define ENABLE_SVR_PUBKEY_AUTH
 
+/* Wether to ake public key options in authorized_keys file into account */
+#ifdef ENABLE_SVR_PUBKEY_AUTH
+#define ENABLE_SVR_PUBKEY_OPTIONS
+#endif
+
 #define ENABLE_CLI_PASSWORD_AUTH
 #define ENABLE_CLI_PUBKEY_AUTH
 #define ENABLE_CLI_INTERACT_AUTH
@@ -235,205 +258,15 @@
 be overridden at runtime with -K. 0 disables keepalives */
 #define DEFAULT_KEEPALIVE 0
 
-/*******************************************************************
- * You shouldn't edit below here unless you know you need to.
- *******************************************************************/
-
-#ifndef DROPBEAR_VERSION
-#define DROPBEAR_VERSION "0.51"
-#endif
-
-#define LOCAL_IDENT "SSH-2.0-dropbear_" DROPBEAR_VERSION
-#define PROGNAME "dropbear"
-
-/* Spec recommends after one hour or 1 gigabyte of data. One hour
- * is a bit too verbose, so we try 8 hours */
-#ifndef KEX_REKEY_TIMEOUT
-#define KEX_REKEY_TIMEOUT (3600 * 8)
-#endif
-#ifndef KEX_REKEY_DATA
-#define KEX_REKEY_DATA (1<<30) /* 2^30 == 1GB, this value must be < INT_MAX */
-#endif
-/* Close connections to clients which haven't authorised after AUTH_TIMEOUT */
-#ifndef AUTH_TIMEOUT
-#define AUTH_TIMEOUT 300 /* we choose 5 minutes */
-#endif
-
-/* Minimum key sizes for DSS and RSA */
-#ifndef MIN_DSS_KEYLEN
-#define MIN_DSS_KEYLEN 512
-#endif
-#ifndef MIN_RSA_KEYLEN
-#define MIN_RSA_KEYLEN 512
-#endif
-
-#define MAX_BANNER_SIZE 2000 /* this is 25*80 chars, any more is foolish */
-#define MAX_BANNER_LINES 20 /* How many lines the client will display */
-
-/* the number of NAME=VALUE pairs to malloc for environ, if we don't have
- * the clearenv() function */
-#define ENV_SIZE 100
-
-#define MAX_CMD_LEN 1024 /* max length of a command */
-#define MAX_TERM_LEN 200 /* max length of TERM name */
-
-#define MAX_HOST_LEN 254 /* max hostname len for tcp fwding */
-#define MAX_IP_LEN 15 /* strlen("255.255.255.255") == 15 */
-
-#define DROPBEAR_MAX_PORTS 10 /* max number of ports which can be specified,
-								 ipv4 and ipv6 don't count twice */
-
-/* Each port might have at least a v4 and a v6 address */
-#define MAX_LISTEN_ADDR (DROPBEAR_MAX_PORTS*3)
-
-#define _PATH_TTY "/dev/tty"
-
-#define _PATH_CP "/bin/cp"
-
-/* success/failure defines */
-#define DROPBEAR_SUCCESS 0
-#define DROPBEAR_FAILURE -1
-
-/* various algorithm identifiers */
-#define DROPBEAR_KEX_DH_GROUP1 0
-
-#define DROPBEAR_SIGNKEY_ANY 0
-#define DROPBEAR_SIGNKEY_RSA 1
-#define DROPBEAR_SIGNKEY_DSS 2
-#define DROPBEAR_SIGNKEY_NONE 3
-
-#define DROPBEAR_COMP_NONE 0
-#define DROPBEAR_COMP_ZLIB 1
-
-/* Required for pubkey auth */
-#if defined(ENABLE_SVR_PUBKEY_AUTH) || defined(DROPBEAR_CLIENT)
-#define DROPBEAR_SIGNKEY_VERIFY
-#endif
-
-/* SHA1 is 20 bytes == 160 bits */
-#define SHA1_HASH_SIZE 20
-/* SHA512 is 64 bytes == 512 bits */
-#define SHA512_HASH_SIZE 64
-/* MD5 is 16 bytes = 128 bits */
-#define MD5_HASH_SIZE 16
-
-/* largest of MD5 and SHA1 */
-#define MAX_MAC_LEN SHA1_HASH_SIZE
-
-
-#define MAX_KEY_LEN 32 /* 256 bits for aes256 etc */
-#define MAX_IV_LEN 20 /* must be same as max blocksize, 
-						 and >= SHA1_HASH_SIZE */
-#define MAX_MAC_KEY 20
-
-#define MAX_NAME_LEN 64 /* maximum length of a protocol name, isn't
-						   explicitly specified for all protocols (just
-						   for algos) but seems valid */
-
-#define MAX_PROPOSED_ALGO 20
-
-/* size/count limits */
-#define MIN_PACKET_LEN 16
-
-#define RECV_MAX_PACKET_LEN (MAX(35000, ((RECV_MAX_PAYLOAD_LEN)+100)))
-
-/* for channel code */
-#define TRANS_MAX_WINDOW 500000000 /* 500MB is sufficient, stopping overflow */
-#define TRANS_MAX_WIN_INCR 500000000 /* overflow prevention */
-
-#define RECV_WINDOWEXTEND (opts.recv_window / 3) /* We send a "window extend" every
-								RECV_WINDOWEXTEND bytes */
-#define MAX_RECV_WINDOW (1024*1024) /* 1 MB should be enough */
-
-#define MAX_CHANNELS 100 /* simple mem restriction, includes each tcp/x11
-							connection, so can't be _too_ small */
-
-#define MAX_STRING_LEN 1400 /* ~= MAX_PROPOSED_ALGO * MAX_NAME_LEN, also
-							   is the max length for a password etc */
-
-/* For a 4096 bit DSS key, empirically determined */
-#define MAX_PUBKEY_SIZE 1700
-/* For a 4096 bit DSS key, empirically determined */
-#define MAX_PRIVKEY_SIZE 1700
-
-/* The maximum size of the bignum portion of the kexhash buffer */
-/* Sect. 8 of the transport draft, K_S + e + f + K */
-#define KEXHASHBUF_MAX_INTS (1700 + 130 + 130 + 130)
-
-#define DROPBEAR_MAX_SOCKS 2 /* IPv4, IPv6 are all we'll get for now. Revisit
-								in a few years time.... */
-
-#define DROPBEAR_MAX_CLI_PASS 1024
-
-#define DROPBEAR_MAX_CLI_INTERACT_PROMPTS 80 /* The number of prompts we'll 
-												accept for keyb-interactive
-												auth */
-
-#if defined(DROPBEAR_AES256_CBC) || defined(DROPBEAR_AES128_CBC)
-#define DROPBEAR_AES_CBC
-#endif
-
-#if defined(DROPBEAR_TWOFISH256_CBC) || defined(DROPBEAR_TWOFISH128_CBC)
-#define DROPBEAR_TWOFISH_CBC
-#endif
-
-#ifndef ENABLE_X11FWD
-#define DISABLE_X11FWD
-#endif
-
-#ifndef ENABLE_AGENTFWD
-#define DISABLE_AGENTFWD
-#endif
-
-#if defined(ENABLE_CLI_REMOTETCPFWD) || defined(ENABLE_CLI_LOCALTCPFWD)
-#define ENABLE_CLI_ANYTCPFWD 
-#endif
-
-#if defined(ENABLE_CLI_LOCALTCPFWD) || defined(ENABLE_SVR_REMOTETCPFWD)
-#define DROPBEAR_TCP_ACCEPT
-#endif
-
-#if defined(ENABLE_CLI_REMOTETCPFWD) || defined(ENABLE_CLI_LOCALTCPFWD) || \
-	defined(ENABLE_SVR_REMOTETCPFWD) || defined(ENABLE_SVR_LOCALTCPFWD) || \
-	defined(ENABLE_AGENTFWD) || defined(ENABLE_X11FWD)
-#define USING_LISTENERS
-#endif
-
-#if defined(DROPBEAR_CLIENT) || defined(ENABLE_SVR_PUBKEY_AUTH)
-#define DROPBEAR_KEY_LINES /* ie we're using authorized_keys or known_hosts */
-#endif
-
-#if defined(ENABLE_SVR_PASSWORD_AUTH) && defined(ENABLE_SVR_PAM_AUTH)
-#error "You can't turn on PASSWORD and PAM auth both at once. Fix it in options.h"
-#endif
-
-#if defined(DROPBEAR_RANDOM_DEV) && defined(DROPBEAR_PRNGD_SOCKET)
-#error "You can't turn on DROPBEAR_PRNGD_SOCKET and DROPBEAR_RANDOM_DEV at once"
-#endif
-
-#if !defined(DROPBEAR_RANDOM_DEV) && !defined(DROPBEAR_PRNGD_SOCKET)
-#error "You must choose one of DROPBEAR_PRNGD_SOCKET or DROPBEAR_RANDOM_DEV in options.h"
-#endif
-
-/* We use dropbear_client and dropbear_server as shortcuts to avoid redundant
- * code, if we're just compiling as client or server */
-#if defined(DROPBEAR_SERVER) && defined(DROPBEAR_CLIENT)
-
-#define IS_DROPBEAR_SERVER (ses.isserver == 1)
-#define IS_DROPBEAR_CLIENT (ses.isserver == 0)
-
-#elif defined(DROPBEAR_SERVER)
-
-#define IS_DROPBEAR_SERVER 1
-#define IS_DROPBEAR_CLIENT 0
-
-#elif defined(DROPBEAR_CLIENT)
-
-#define IS_DROPBEAR_SERVER 0
-#define IS_DROPBEAR_CLIENT 1
-
-#else
-#error You must compiled with either DROPBEAR_CLIENT or DROPBEAR_SERVER selected
-#endif
+/* Ensure that data is received within IDLE_TIMEOUT seconds. This can
+be overridden at runtime with -I. 0 disables idle timeouts */
+#define DEFAULT_IDLE_TIMEOUT 0
+
+/* The default path. This will often get replaced by the shell */
+#define DEFAULT_PATH "/usr/bin:/bin"
+
+/* Some other defines (that mostly should be left alone) are defined
+ * in sysoptions.h */
+#include "sysoptions.h"
 
 #endif /* _OPTIONS_H_ */

=== modified file 'packet.c'
--- packet.c	2008-03-27 20:08:06 +0000
+++ packet.c	2008-11-19 20:58:59 +0000
@@ -61,7 +61,7 @@
 	len = writebuf->len - writebuf->pos;
 	dropbear_assert(len > 0);
 	/* Try to write as much as possible */
-	written = write(ses.sock, buf_getptr(writebuf, len), len);
+	written = write(ses.sock_out, buf_getptr(writebuf, len), len);
 
 	if (written < 0) {
 		if (errno == EINTR) {
@@ -72,6 +72,7 @@
 		}
 	} 
 	
+	ses.last_trx_packet_time = time(NULL);
 	ses.last_packet_time = time(NULL);
 
 	if (written == 0) {
@@ -122,7 +123,7 @@
 	 * mightn't be any available (EAGAIN) */
 	dropbear_assert(ses.readbuf != NULL);
 	maxlen = ses.readbuf->len - ses.readbuf->pos;
-	len = read(ses.sock, buf_getptr(ses.readbuf, maxlen), maxlen);
+	len = read(ses.sock_in, buf_getptr(ses.readbuf, maxlen), maxlen);
 
 	if (len == 0) {
 		ses.remoteclosed();
@@ -171,7 +172,7 @@
 	maxlen = blocksize - ses.readbuf->pos;
 			
 	/* read the rest of the packet if possible */
-	len = read(ses.sock, buf_getwriteptr(ses.readbuf, maxlen),
+	len = read(ses.sock_in, buf_getwriteptr(ses.readbuf, maxlen),
 			maxlen);
 	if (len == 0) {
 		ses.remoteclosed();
@@ -194,19 +195,11 @@
 	/* now we have the first block, need to get packet length, so we decrypt
 	 * the first block (only need first 4 bytes) */
 	buf_setpos(ses.readbuf, 0);
-	if (ses.keys->recv_algo_crypt->cipherdesc == NULL) {
-		/* copy it */
-		memcpy(buf_getwriteptr(ses.decryptreadbuf, blocksize),
-				buf_getptr(ses.readbuf, blocksize),
-				blocksize);
-	} else {
-		/* decrypt it */
-		if (cbc_decrypt(buf_getptr(ses.readbuf, blocksize), 
-					buf_getwriteptr(ses.decryptreadbuf,blocksize),
-					blocksize,
-					&ses.keys->recv_symmetric_struct) != CRYPT_OK) {
-			dropbear_exit("error decrypting");
-		}
+	if (ses.keys->recv_crypt_mode->decrypt(buf_getptr(ses.readbuf, blocksize), 
+				buf_getwriteptr(ses.decryptreadbuf,blocksize),
+				blocksize,
+				&ses.keys->recv_cipher_state) != CRYPT_OK) {
+		dropbear_exit("error decrypting");
 	}
 	buf_setlen(ses.decryptreadbuf, blocksize);
 	len = buf_getint(ses.decryptreadbuf) + 4 + macsize;
@@ -246,24 +239,17 @@
 	buf_setlen(ses.decryptreadbuf, ses.decryptreadbuf->size);
 	buf_setpos(ses.decryptreadbuf, blocksize);
 
-	/* decrypt if encryption is set, memcpy otherwise */
-	if (ses.keys->recv_algo_crypt->cipherdesc == NULL) {
-		/* copy it */
-		len = ses.readbuf->len - macsize - blocksize;
-		memcpy(buf_getwriteptr(ses.decryptreadbuf, len),
-				buf_getptr(ses.readbuf, len), len);
-	} else {
-		/* decrypt */
-		while (ses.readbuf->pos < ses.readbuf->len - macsize) {
-			if (cbc_decrypt(buf_getptr(ses.readbuf, blocksize), 
-						buf_getwriteptr(ses.decryptreadbuf, blocksize),
-						blocksize,
-						&ses.keys->recv_symmetric_struct) != CRYPT_OK) {
-				dropbear_exit("error decrypting");
-			}
-			buf_incrpos(ses.readbuf, blocksize);
-			buf_incrwritepos(ses.decryptreadbuf, blocksize);
+	/* decrypt it */
+	while (ses.readbuf->pos < ses.readbuf->len - macsize) {
+		if (ses.keys->recv_crypt_mode->decrypt(
+					buf_getptr(ses.readbuf, blocksize), 
+					buf_getwriteptr(ses.decryptreadbuf, blocksize),
+					blocksize,
+					&ses.keys->recv_cipher_state) != CRYPT_OK) {
+			dropbear_exit("error decrypting");
 		}
+		buf_incrpos(ses.readbuf, blocksize);
+		buf_incrwritepos(ses.decryptreadbuf, blocksize);
 	}
 
 	/* check the hmac */
@@ -290,10 +276,9 @@
 	buf_setpos(ses.decryptreadbuf, PACKET_PAYLOAD_OFF);
 
 #ifndef DISABLE_ZLIB
-	if (ses.keys->recv_algo_comp == DROPBEAR_COMP_ZLIB) {
+	if (is_compress_recv()) {
 		/* decompress */
 		ses.payload = buf_decompress(ses.decryptreadbuf, len);
-
 	} else 
 #endif
 	{
@@ -469,6 +454,7 @@
 	buffer * writebuf; /* the packet which will go on the wire */
 	buffer * clearwritebuf; /* unencrypted, possibly compressed */
 	unsigned char type;
+	unsigned int clear_len;
 	
 	type = ses.writepayload->data[0];
 	TRACE(("enter encrypt_packet()"))
@@ -488,11 +474,12 @@
 	/* Encrypted packet len is payload+5, then worst case is if we are 3 away
 	 * from a blocksize multiple. In which case we need to pad to the
 	 * multiple, then add another blocksize (or MIN_PACKET_LEN) */
-	clearwritebuf = buf_new((ses.writepayload->len+4+1) + MIN_PACKET_LEN + 3
+	clear_len = (ses.writepayload->len+4+1) + MIN_PACKET_LEN + 3;
+
 #ifndef DISABLE_ZLIB
-			+ ZLIB_COMPRESS_INCR /* bit of a kludge, but we can't know len*/
+	clear_len += ZLIB_COMPRESS_INCR; /* bit of a kludge, but we can't know len*/
 #endif
-			);
+	clearwritebuf = buf_new(clear_len);
 	buf_setlen(clearwritebuf, PACKET_PAYLOAD_OFF);
 	buf_setpos(clearwritebuf, PACKET_PAYLOAD_OFF);
 
@@ -500,7 +487,7 @@
 
 #ifndef DISABLE_ZLIB
 	/* compression */
-	if (ses.keys->trans_algo_comp == DROPBEAR_COMP_ZLIB) {
+	if (is_compress_trans()) {
 		buf_compress(clearwritebuf, ses.writepayload, ses.writepayload->len);
 	} else
 #endif
@@ -543,24 +530,17 @@
 	 * wire by writepacket() */
 	writebuf = buf_new(clearwritebuf->len + macsize);
 
-	if (ses.keys->trans_algo_crypt->cipherdesc == NULL) {
-		/* copy it */
-		memcpy(buf_getwriteptr(writebuf, clearwritebuf->len),
-				buf_getptr(clearwritebuf, clearwritebuf->len),
-				clearwritebuf->len);
-		buf_incrwritepos(writebuf, clearwritebuf->len);
-	} else {
-		/* encrypt it */
-		while (clearwritebuf->pos < clearwritebuf->len) {
-			if (cbc_encrypt(buf_getptr(clearwritebuf, blocksize),
-						buf_getwriteptr(writebuf, blocksize),
-						blocksize,
-						&ses.keys->trans_symmetric_struct) != CRYPT_OK) {
-				dropbear_exit("error encrypting");
-			}
-			buf_incrpos(clearwritebuf, blocksize);
-			buf_incrwritepos(writebuf, blocksize);
+	/* encrypt it */
+	while (clearwritebuf->pos < clearwritebuf->len) {
+		if (ses.keys->trans_crypt_mode->encrypt(
+					buf_getptr(clearwritebuf, blocksize),
+					buf_getwriteptr(writebuf, blocksize),
+					blocksize,
+					&ses.keys->trans_cipher_state) != CRYPT_OK) {
+			dropbear_exit("error encrypting");
 		}
+		buf_incrpos(clearwritebuf, blocksize);
+		buf_incrwritepos(writebuf, blocksize);
 	}
 
 	/* now add a hmac and we're done */

=== modified file 'process-packet.c'
--- process-packet.c	2008-03-27 20:08:06 +0000
+++ process-packet.c	2008-11-19 20:58:59 +0000
@@ -70,6 +70,7 @@
 			dropbear_close("Disconnect received");
 	}
 
+    ses.last_packet_time = time(NULL);
 
 	/* This applies for KEX, where the spec says the next packet MUST be
 	 * NEWKEYS */

=== modified file 'runopts.h'
--- runopts.h	2008-03-27 20:08:06 +0000
+++ runopts.h	2008-11-19 20:58:59 +0000
@@ -37,7 +37,8 @@
 	int listen_fwd_all;
 #endif
 	unsigned int recv_window;
-	time_t keepalive_secs;
+	unsigned int keepalive_secs;
+	unsigned int idle_timeout_secs;
 
 } runopts;
 
@@ -101,6 +102,7 @@
 	char *remotehost;
 	char *remoteport;
 
+	char *own_user;
 	char *username;
 
 	char *cmd;
@@ -108,6 +110,7 @@
 	int always_accept_key;
 	int no_cmd;
 	int backgrounded;
+	int is_subsystem;
 #ifdef ENABLE_CLI_PUBKEY_AUTH
 	struct SignKeyList *privkeys; /* Keys to use for public-key auth */
 #endif
@@ -118,6 +121,14 @@
 	struct TCPFwdList * localfwds;
 #endif
 
+#ifdef ENABLE_CLI_NETCAT
+	char *netcat_host;
+	unsigned int netcat_port;
+#endif
+#ifdef ENABLE_CLI_PROXYCMD
+	char *proxycmd;
+#endif
+
 } cli_runopts;
 
 extern cli_runopts cli_opts;

=== modified file 'scp.c'
--- scp.c	2008-03-27 20:08:06 +0000
+++ scp.c	2008-11-19 20:58:59 +0000
@@ -130,13 +130,22 @@
 			fprintf(stderr, " %s", a->list[i]);
 		fprintf(stderr, "\n");
 	}
-	if ((pid = fork()) == -1)
+#ifdef __uClinux__
+	pid = vfork();
+#else
+	pid = fork();
+#endif /* __uClinux__ */
+	if (pid == -1)
 		fatal("do_local_cmd: fork: %s", strerror(errno));
 
 	if (pid == 0) {
 		execvp(a->list[0], a->list);
 		perror(a->list[0]);
+#ifdef __uClinux__
+		_exit(1);
+#else
 		exit(1);
+#endif /* __uClinux__ */
 	}
 
 	do_cmd_pid = pid;
@@ -225,7 +234,11 @@
 
 		execvp(ssh_program, args.list);
 		perror(ssh_program);
+#ifndef __uClinux__
 		exit(1);
+#else
+		_exit(1);
+#endif /* __uClinux__ */
 	} else if (do_cmd_pid == -1) {
 		fatal("fork: %s", strerror(errno));
 	}

=== modified file 'session.h'
--- session.h	2008-03-27 20:08:06 +0000
+++ session.h	2008-11-19 20:58:59 +0000
@@ -41,12 +41,14 @@
 extern int sessinitdone; /* Is set to 0 somewhere */
 extern int exitflag;
 
-void common_session_init(int sock, char* remotehost);
+void common_session_init(int sock_in, int sock_out, char* remotehost);
 void session_loop(void(*loophandler)());
 void common_session_cleanup();
 void session_identification();
 void send_msg_ignore();
 
+const char* get_user_shell();
+void fill_passwd(const char* username);
 
 /* Server */
 void svr_session(int sock, int childpipe, char *remotehost, char *addrstring);
@@ -54,7 +56,7 @@
 void svr_dropbear_log(int priority, const char* format, va_list param);
 
 /* Client */
-void cli_session(int sock, char *remotehost);
+void cli_session(int sock_in, int sock_out, char *remotehost);
 void cli_session_cleanup();
 void cleantext(unsigned char* dirtytext);
 
@@ -62,6 +64,8 @@
 
 	const struct dropbear_cipher *recv_algo_crypt; /* NULL for none */
 	const struct dropbear_cipher *trans_algo_crypt; /* NULL for none */
+	const struct dropbear_cipher_mode *recv_crypt_mode;
+	const struct dropbear_cipher_mode *trans_crypt_mode;
 	const struct dropbear_hash *recv_algo_mac; /* NULL for none */
 	const struct dropbear_hash *trans_algo_mac; /* NULL for none */
 	char algo_kex;
@@ -69,14 +73,26 @@
 
 	char recv_algo_comp; /* compression */
 	char trans_algo_comp;
+	int allow_compress; /* whether compression has started (useful in 
+							zlib@openssh.com delayed compression case) */
 #ifndef DISABLE_ZLIB
 	z_streamp recv_zstream;
 	z_streamp trans_zstream;
 #endif
 
 	/* actual keys */
-	symmetric_CBC recv_symmetric_struct;
-	symmetric_CBC trans_symmetric_struct;
+	union {
+		symmetric_CBC cbc;
+#ifdef DROPBEAR_ENABLE_CTR_MODE
+		symmetric_CTR ctr;
+#endif
+	} recv_cipher_state;
+	union {
+		symmetric_CBC cbc;
+#ifdef DROPBEAR_ENABLE_CTR_MODE
+		symmetric_CTR ctr;
+#endif
+	} trans_cipher_state;
 	unsigned char recvmackey[MAX_MAC_KEY];
 	unsigned char transmackey[MAX_MAC_KEY];
 
@@ -97,7 +113,8 @@
 							(cleared after auth once we're not
 							respecting AUTH_TIMEOUT any more) */
 
-	int sock;
+	int sock_in;
+	int sock_out;
 
 	unsigned char *remotehost; /* the peer hostname */
 
@@ -131,12 +148,16 @@
 
 	unsigned char lastpacket; /* What the last received packet type was */
 	
-    int signal_pipe[2]; /* stores endpoints of a self-pipe used for
+	int signal_pipe[2]; /* stores endpoints of a self-pipe used for
 						   race-free signal handling */
 						
-	time_t last_packet_time; /* time of the last packet transmission, for
+	time_t last_trx_packet_time; /* time of the last packet transmission, for
 							keepalive purposes */
 
+	time_t last_packet_time; /* time of the last packet transmission or receive, for
+								idle timeout purposes */
+
+
 	/* KEX/encryption related */
 	struct KEXState kexstate;
 	struct key_context *keys;

=== modified file 'svr-agentfwd.c'
--- svr-agentfwd.c	2008-03-27 20:08:06 +0000
+++ svr-agentfwd.c	2008-11-19 20:58:59 +0000
@@ -39,6 +39,7 @@
 #include "buffer.h"
 #include "random.h"
 #include "listener.h"
+#include "auth.h"
 
 #define AGENTDIRPREFIX "/tmp/dropbear-"
 
@@ -52,6 +53,10 @@
 
 	int fd;
 
+	if (!svr_pubkey_allows_agentfwd()) {
+		return DROPBEAR_FAILURE;
+	}
+
 	if (chansess->agentlistener != NULL) {
 		return DROPBEAR_FAILURE;
 	}

=== modified file 'svr-auth.c'
--- svr-auth.c	2008-03-27 20:08:06 +0000
+++ svr-auth.c	2008-11-19 20:58:59 +0000
@@ -203,29 +203,6 @@
 	m_free(methodname);
 }
 
-static int fill_passwd(const char* username) {
-	struct passwd *pw = NULL;
-	if (ses.authstate.pw_name)
-		m_free(ses.authstate.pw_name);
-	if (ses.authstate.pw_dir)
-		m_free(ses.authstate.pw_dir);
-	if (ses.authstate.pw_shell)
-		m_free(ses.authstate.pw_shell);
-	if (ses.authstate.pw_passwd)
-		m_free(ses.authstate.pw_passwd);
-
-	pw = getpwnam(username);
-	if (!pw) {
-		return;
-	}
-	ses.authstate.pw_uid = pw->pw_uid;
-	ses.authstate.pw_gid = pw->pw_gid;
-	ses.authstate.pw_name = m_strdup(pw->pw_name);
-	ses.authstate.pw_dir = m_strdup(pw->pw_dir);
-	ses.authstate.pw_shell = m_strdup(pw->pw_shell);
-	ses.authstate.pw_passwd = m_strdup(pw->pw_passwd);
-}
-
 
 /* Check that the username exists, has a non-empty password, and has a valid
  * shell.
@@ -391,6 +368,8 @@
 	buf_putbyte(ses.writepayload, SSH_MSG_USERAUTH_SUCCESS);
 	encrypt_packet();
 
+	/* authdone must be set after encrypt_packet() for 
+	 * delayed-zlib mode */
 	ses.authstate.authdone = 1;
 	ses.connect_time = 0;
 

=== modified file 'svr-authpubkey.c'
--- svr-authpubkey.c	2008-03-27 20:08:06 +0000
+++ svr-authpubkey.c	2008-11-19 20:58:59 +0000
@@ -21,6 +21,37 @@
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE. */
+/*
+ * This file incorporates work covered by the following copyright and  
+ * permission notice:
+ *
+ * 	Copyright (c) 2000 Markus Friedl.  All rights reserved.
+ * 	
+ * 	Redistribution and use in source and binary forms, with or without
+ * 	modification, are permitted provided that the following conditions
+ * 	are met:
+ * 	1. Redistributions of source code must retain the above copyright
+ * 	   notice, this list of conditions and the following disclaimer.
+ * 	2. Redistributions in binary form must reproduce the above copyright
+ * 	   notice, this list of conditions and the following disclaimer in the
+ * 	   documentation and/or other materials provided with the distribution.
+ * 	
+ * 	THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * 	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * 	OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * 	IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * 	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * 	NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * 	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * 	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * 	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * 	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * This copyright and permission notice applies to the code parsing public keys
+ * options string which can also be found in OpenSSH auth2-pubkey.c file 
+ * (user_key_allowed2). It has been adapted to work with buffers.
+ *
+ */
 
 /* Process a pubkey auth request */
 
@@ -159,7 +190,9 @@
 	int ret = DROPBEAR_FAILURE;
 	buffer * line = NULL;
 	unsigned int len, pos;
-	
+	buffer * options_buf = NULL;
+	int line_num;
+
 	TRACE(("enter checkpubkey"))
 
 	/* check that we can use the algo */
@@ -193,25 +226,82 @@
 	TRACE(("checkpubkey: opened authorized_keys OK"))
 
 	line = buf_new(MAX_AUTHKEYS_LINE);
+	line_num = 0;
 
 	/* iterate through the lines */
 	do {
+		/* new line : potentially new options */
+		if (options_buf) {
+			buf_free(options_buf);
+			options_buf = NULL;
+		}
 
 		if (buf_getline(line, authfile) == DROPBEAR_FAILURE) {
 			/* EOF reached */
 			TRACE(("checkpubkey: authorized_keys EOF reached"))
 			break;
 		}
+		line_num++;
 
 		if (line->len < MIN_AUTHKEYS_LINE) {
 			TRACE(("checkpubkey: line too short"))
 			continue; /* line is too short for it to be a valid key */
 		}
 
-		/* check the key type - this also stops us from using keys
-		 * which have options with them */
+		/* check the key type - will fail if there are options */
+		TRACE(("a line!"))
+
 		if (strncmp(buf_getptr(line, algolen), algo, algolen) != 0) {
-			continue;
+			int is_comment = 0;
+			char *options_start = NULL;
+			int options_len = 0;
+			int escape, quoted;
+			
+			/* skip over any comments or leading whitespace */
+			while (line->pos < line->len) {
+				const char c = buf_getbyte(line);
+				if (c == ' ' || c == '\t') {
+					continue;
+				} else if (c == '#') {
+					is_comment = 1;
+					break;
+				}
+				buf_incrpos(line, -1);
+				break;
+			}
+			if (is_comment) {
+				/* next line */
+				continue;
+			}
+
+			/* remember start of options */
+			options_start = buf_getptr(line, 1);
+			quoted = 0;
+			escape = 0;
+			options_len = 0;
+			
+			/* figure out where the options are */
+			while (line->pos < line->len) {
+				const char c = buf_getbyte(line);
+				if (!quoted && (c == ' ' || c == '\t')) {
+					break;
+				}
+				escape = (!escape && c == '\\');
+				if (!escape && c == '"') {
+					quoted = !quoted;
+				}
+				options_len++;
+			}
+			options_buf = buf_new(options_len);
+			buf_putbytes(options_buf, options_start, options_len);
+
+			/* compare the algorithm */
+			if (line->pos + algolen > line->len) {
+				continue;
+			}
+			if (strncmp(buf_getptr(line, algolen), algo, algolen) != 0) { 
+				continue;
+			}
 		}
 		buf_incrpos(line, algolen);
 		
@@ -232,6 +322,11 @@
 		TRACE(("checkpubkey: line pos = %d len = %d", line->pos, line->len))
 
 		ret = cmp_base64_key(keyblob, keybloblen, algo, algolen, line, NULL);
+
+		if (ret == DROPBEAR_SUCCESS && options_buf) {
+			ret = svr_add_pubkey_options(options_buf, line_num, filename);
+		}
+
 		if (ret == DROPBEAR_SUCCESS) {
 			break;
 		}
@@ -248,6 +343,9 @@
 		buf_free(line);
 	}
 	m_free(filename);
+	if (options_buf) {
+		buf_free(options_buf);
+	}
 	TRACE(("leave checkpubkey: ret=%d", ret))
 	return ret;
 }
@@ -343,5 +441,4 @@
 	return DROPBEAR_SUCCESS;
 }
 
-
-#endif 
+#endif

=== added file 'svr-authpubkeyoptions.c'
--- svr-authpubkeyoptions.c	1970-01-01 00:00:00 +0000
+++ svr-authpubkeyoptions.c	2008-11-19 20:58:59 +0000
@@ -0,0 +1,202 @@
+/*
+ * Dropbear - a SSH2 server
+ * 
+ * Copyright (c) 2008 Frederic Moulins
+ * All rights reserved.
+ * 
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ * 
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+ * SOFTWARE. 
+ *
+ * This file incorporates work covered by the following copyright and  
+ * permission notice:
+ *
+ * 	Author: Tatu Ylonen <ylo@cs.hut.fi>
+ * 	Copyright (c) 1995 Tatu Ylonen <ylo@cs.hut.fi>, Espoo, Finland
+ * 	              All rights reserved
+ * 	As far as I am concerned, the code I have written for this software
+ * 	can be used freely for any purpose.  Any derived versions of this
+ * 	software must be clearly marked as such, and if the derived work is
+ * 	incompatible with the protocol description in the RFC file, it must be
+ * 	called by a name other than "ssh" or "Secure Shell".
+ *
+ * This copyright and permission notice applies to the code parsing public keys
+ * options string which can also be found in OpenSSH auth-options.c file 
+ * (auth_parse_options).
+ *
+ */
+
+/* Process pubkey options during a pubkey auth request */
+#include "includes.h"
+#include "session.h"
+#include "dbutil.h"
+#include "signkey.h"
+#include "auth.h"
+
+#ifdef ENABLE_SVR_PUBKEY_OPTIONS
+
+/* Returns 1 if pubkey allows agent forwarding,
+ * 0 otherwise */
+int svr_pubkey_allows_agentfwd() {
+	if (ses.authstate.pubkey_options 
+		&& ses.authstate.pubkey_options->no_agent_forwarding_flag) {
+		return 0;
+	}
+	return 1;
+}
+
+/* Returns 1 if pubkey allows tcp forwarding,
+ * 0 otherwise */
+int svr_pubkey_allows_tcpfwd() {
+	if (ses.authstate.pubkey_options 
+		&& ses.authstate.pubkey_options->no_port_forwarding_flag) {
+		return 0;
+	}
+	return 1;
+}
+
+/* Returns 1 if pubkey allows x11 forwarding,
+ * 0 otherwise */
+int svr_pubkey_allows_x11fwd() {
+	if (ses.authstate.pubkey_options 
+		&& ses.authstate.pubkey_options->no_x11_forwarding_flag) {
+		return 0;
+	}
+	return 1;
+}
+
+/* Returns 1 if pubkey allows pty, 0 otherwise */
+int svr_pubkey_allows_pty() {
+	if (ses.authstate.pubkey_options 
+		&& ses.authstate.pubkey_options->no_pty_flag) {
+		return 0;
+	}
+	return 1;
+}
+
+/* Set chansession command to the one forced by 'command' public key option */
+void svr_pubkey_set_forced_command(struct ChanSess *chansess) {
+	if (ses.authstate.pubkey_options)
+		chansess->cmd = ses.authstate.pubkey_options->forced_command;
+}
+
+/* Free potential public key options */
+void svr_pubkey_options_cleanup() {
+	if (ses.authstate.pubkey_options) {
+		m_free(ses.authstate.pubkey_options);
+		ses.authstate.pubkey_options = NULL;
+	}
+}
+
+/* helper for svr_add_pubkey_options. returns DROPBEAR_SUCCESS if the option is matched,
+   and increments the options_buf */
+static int match_option(buffer *options_buf, const char *opt_name) {
+	const unsigned int len = strlen(opt_name);
+	if (options_buf->len - options_buf->pos < len) {
+		return DROPBEAR_FAILURE;
+	}
+	if (strncasecmp(buf_getptr(options_buf, len), opt_name, len) == 0) {
+		buf_incrpos(options_buf, len);
+		return DROPBEAR_SUCCESS;
+	}
+	return DROPBEAR_FAILURE;
+}
+
+/* Parse pubkey options and set ses.authstate.pubkey_options accordingly.
+ * Returns DROPBEAR_SUCCESS if key is ok for auth, DROPBEAR_FAILURE otherwise */
+int svr_add_pubkey_options(buffer *options_buf, int line_num, const char* filename) {
+	int ret = DROPBEAR_FAILURE;
+
+	TRACE(("enter addpubkeyoptions"))
+
+	ses.authstate.pubkey_options = (struct PubKeyOptions*)m_malloc(sizeof( struct PubKeyOptions ));
+	memset(ses.authstate.pubkey_options, '\0', sizeof(*ses.authstate.pubkey_options));
+
+	buf_setpos(options_buf, 0);
+	while (options_buf->pos < options_buf->len) {
+		if (match_option(options_buf, "no-port-forwarding") == DROPBEAR_SUCCESS) {
+			dropbear_log(LOG_WARNING, "Port forwarding disabled.");
+			ses.authstate.pubkey_options->no_port_forwarding_flag = 1;
+			goto next_option;
+		}
+#ifdef ENABLE_AGENTFWD
+		if (match_option(options_buf, "no-agent-forwarding") == DROPBEAR_SUCCESS) {
+			dropbear_log(LOG_WARNING, "Agent forwarding disabled.");
+			ses.authstate.pubkey_options->no_agent_forwarding_flag = 1;
+			goto next_option;
+		}
+#endif
+#ifdef ENABLE_X11FWD
+		if (match_option(options_buf, "no-X11-forwarding") == DROPBEAR_SUCCESS) {
+			dropbear_log(LOG_WARNING, "X11 forwarding disabled.");
+			ses.authstate.pubkey_options->no_x11_forwarding_flag = 1;
+			goto next_option;
+		}
+#endif
+		if (match_option(options_buf, "no-pty") == DROPBEAR_SUCCESS) {
+			dropbear_log(LOG_WARNING, "Pty allocation disabled.");
+			ses.authstate.pubkey_options->no_pty_flag = 1;
+			goto next_option;
+		}
+		if (match_option(options_buf, "command=\"") == DROPBEAR_SUCCESS) {
+			int escaped = 0;
+			const unsigned char* command_start = buf_getptr(options_buf, 0);
+			while (options_buf->pos < options_buf->len) {
+				const char c = buf_getbyte(options_buf);
+				if (!escaped && c == '"') {
+					const int command_len = buf_getptr(options_buf, 0) - command_start;
+					ses.authstate.pubkey_options->forced_command = m_malloc(command_len);
+					memcpy(ses.authstate.pubkey_options->forced_command,
+							command_start, command_len-1);
+					ses.authstate.pubkey_options->forced_command[command_len-1] = '\0';
+					dropbear_log(LOG_WARNING, "Forced command '%s'", 
+						ses.authstate.pubkey_options->forced_command);
+					goto next_option;
+				}
+				escaped = (!escaped && c == '\\');
+			}
+			dropbear_log(LOG_WARNING, "Badly formatted command= authorized_keys option");
+			goto bad_option;
+		}
+
+next_option:
+		/*
+		 * Skip the comma, and move to the next option
+		 * (or break out if there are no more).
+		 */
+		if (options_buf->pos < options_buf->len 
+				&& buf_getbyte(options_buf) != ',') {
+			goto bad_option;
+		}
+		/* Process the next option. */
+	}
+	/* parsed all options with no problem */
+	ret = DROPBEAR_SUCCESS;
+	goto end;
+
+bad_option:
+	ret = DROPBEAR_FAILURE;
+	m_free(ses.authstate.pubkey_options);
+	ses.authstate.pubkey_options = NULL;
+	dropbear_log(LOG_WARNING, "Bad public key options at %s:%d", filename, line_num);
+
+end:
+	TRACE(("leave addpubkeyoptions"))
+	return ret;
+}
+
+#endif

=== modified file 'svr-chansession.c'
--- svr-chansession.c	2008-03-27 20:08:06 +0000
+++ svr-chansession.c	2008-11-19 20:58:59 +0000
@@ -37,6 +37,7 @@
 #include "x11fwd.h"
 #include "agentfwd.h"
 #include "runopts.h"
+#include "auth.h"
 
 /* Handles sessions (either shells or programs) requested by the client */
 
@@ -47,7 +48,7 @@
 static int noptycommand(struct Channel *channel, struct ChanSess *chansess);
 static int ptycommand(struct Channel *channel, struct ChanSess *chansess);
 static int sessionwinchange(struct ChanSess *chansess);
-static void execchild(struct ChanSess *chansess);
+static void execchild(void *user_data_chansess);
 static void addchildpid(struct ChanSess *chansess, pid_t pid);
 static void sesssigchild_handler(int val);
 static void closechansess(struct Channel *channel);
@@ -527,6 +528,12 @@
 	struct passwd * pw = NULL;
 
 	TRACE(("enter sessionpty"))
+
+	if (!svr_pubkey_allows_pty()) {
+		TRACE(("leave sessionpty : pty forbidden by public key option"))
+		return DROPBEAR_FAILURE;
+	}
+
 	chansess->term = buf_getstring(ses.payload, &termlen);
 	if (termlen > MAX_TERM_LEN) {
 		/* TODO send disconnect ? */
@@ -582,14 +589,19 @@
 		return DROPBEAR_FAILURE;
 	}
 
+	/* take public key option 'command' into account */
+	svr_pubkey_set_forced_command(chansess);
+
 	if (iscmd) {
 		/* "exec" */
-		chansess->cmd = buf_getstring(ses.payload, &cmdlen);
+		if (chansess->cmd == NULL) {
+			chansess->cmd = buf_getstring(ses.payload, &cmdlen);
 
-		if (cmdlen > MAX_CMD_LEN) {
-			m_free(chansess->cmd);
-			/* TODO - send error - too long ? */
-			return DROPBEAR_FAILURE;
+			if (cmdlen > MAX_CMD_LEN) {
+				m_free(chansess->cmd);
+				/* TODO - send error - too long ? */
+				return DROPBEAR_FAILURE;
+			}
 		}
 		if (issubsys) {
 #ifdef SFTPSERVER_PATH
@@ -633,100 +645,37 @@
  * pty.
  * Returns DROPBEAR_SUCCESS or DROPBEAR_FAILURE */
 static int noptycommand(struct Channel *channel, struct ChanSess *chansess) {
-
-	int infds[2];
-	int outfds[2];
-	int errfds[2];
-	pid_t pid;
-	unsigned int i;
+	int ret;
 
 	TRACE(("enter noptycommand"))
-
-	/* redirect stdin/stdout/stderr */
-	if (pipe(infds) != 0)
-		return DROPBEAR_FAILURE;
-	if (pipe(outfds) != 0)
-		return DROPBEAR_FAILURE;
-	if (pipe(errfds) != 0)
-		return DROPBEAR_FAILURE;
-
-#ifdef __uClinux__
-	pid = vfork();
-#else
-	pid = fork();
-#endif
-
-	if (pid < 0)
-		return DROPBEAR_FAILURE;
-
-	if (!pid) {
-		/* child */
-
-		TRACE(("back to normal sigchld"))
-		/* Revert to normal sigchld handling */
-		if (signal(SIGCHLD, SIG_DFL) == SIG_ERR) {
-			dropbear_exit("signal() error");
-		}
-
-		/* redirect stdin/stdout */
-#define FDIN 0
-#define FDOUT 1
-		if ((dup2(infds[FDIN], STDIN_FILENO) < 0) ||
-			(dup2(outfds[FDOUT], STDOUT_FILENO) < 0) ||
-			(dup2(errfds[FDOUT], STDERR_FILENO) < 0)) {
-			TRACE(("leave noptycommand: error redirecting FDs"))
-			return DROPBEAR_FAILURE;
-		}
-
-		close(infds[FDOUT]);
-		close(infds[FDIN]);
-		close(outfds[FDIN]);
-		close(outfds[FDOUT]);
-		close(errfds[FDIN]);
-		close(errfds[FDOUT]);
-
-		execchild(chansess);
-		/* not reached */
-
-	} else {
-		/* parent */
-		TRACE(("continue noptycommand: parent"))
-		chansess->pid = pid;
-		TRACE(("child pid is %d", pid))
-
-		addchildpid(chansess, pid);
-
-		if (svr_ses.lastexit.exitpid != -1) {
-			TRACE(("parent side: lastexitpid is %d", svr_ses.lastexit.exitpid))
-			/* The child probably exited and the signal handler triggered
-			 * possibly before we got around to adding the childpid. So we fill
-			 * out its data manually */
-			for (i = 0; i < svr_ses.childpidsize; i++) {
-				if (svr_ses.childpids[i].pid == svr_ses.lastexit.exitpid) {
-					TRACE(("found match for lastexitpid"))
-					svr_ses.childpids[i].chansess->exit = svr_ses.lastexit;
-					svr_ses.lastexit.exitpid = -1;
-				}
+	ret = spawn_command(execchild, chansess, 
+			&channel->writefd, &channel->readfd, &channel->errfd,
+			&chansess->pid);
+
+	if (ret == DROPBEAR_FAILURE) {
+		return ret;
+	}
+
+	ses.maxfd = MAX(ses.maxfd, channel->writefd);
+	ses.maxfd = MAX(ses.maxfd, channel->readfd);
+	ses.maxfd = MAX(ses.maxfd, channel->errfd);
+
+	addchildpid(chansess, chansess->pid);
+
+	if (svr_ses.lastexit.exitpid != -1) {
+		unsigned int i;
+		TRACE(("parent side: lastexitpid is %d", svr_ses.lastexit.exitpid))
+		/* The child probably exited and the signal handler triggered
+		 * possibly before we got around to adding the childpid. So we fill
+		 * out its data manually */
+		for (i = 0; i < svr_ses.childpidsize; i++) {
+			if (svr_ses.childpids[i].pid == svr_ses.lastexit.exitpid) {
+				TRACE(("found match for lastexitpid"))
+				svr_ses.childpids[i].chansess->exit = svr_ses.lastexit;
+				svr_ses.lastexit.exitpid = -1;
 			}
 		}
-
-		close(infds[FDIN]);
-		close(outfds[FDOUT]);
-		close(errfds[FDOUT]);
-		channel->writefd = infds[FDOUT];
-		channel->readfd = outfds[FDIN];
-		channel->errfd = errfds[FDIN];
-		ses.maxfd = MAX(ses.maxfd, channel->writefd);
-		ses.maxfd = MAX(ses.maxfd, channel->readfd);
-		ses.maxfd = MAX(ses.maxfd, channel->errfd);
-
-		setnonblocking(channel->readfd);
-		setnonblocking(channel->writefd);
-		setnonblocking(channel->errfd);
-
 	}
-#undef FDIN
-#undef FDOUT
 
 	TRACE(("leave noptycommand"))
 	return DROPBEAR_SUCCESS;
@@ -871,12 +820,9 @@
 
 /* Clean up, drop to user privileges, set up the environment and execute
  * the command/shell. This function does not return. */
-static void execchild(struct ChanSess *chansess) {
-
-	char *argv[4];
-	char * usershell = NULL;
-	char * baseshell = NULL;
-	unsigned int i;
+static void execchild(void *user_data) {
+	struct ChanSess *chansess = user_data;
+	char *usershell = NULL;
 
     /* with uClinux we'll have vfork()ed, so don't want to overwrite the
      * hostkey. can't think of a workaround to clear it */
@@ -889,12 +835,6 @@
 	reseedrandom();
 #endif
 
-	/* close file descriptors except stdin/stdout/stderr
-	 * Need to be sure FDs are closed here to avoid reading files as root */
-	for (i = 3; i <= (unsigned int)ses.maxfd; i++) {
-		m_close(i);
-	}
-
 	/* clear environment */
 	/* if we're debugging using valgrind etc, we need to keep the LD_PRELOAD
 	 * etc. This is hazardous, so should only be used for debugging. */
@@ -933,18 +873,12 @@
 		}
 	}
 
-	/* an empty shell should be interpreted as "/bin/sh" */
-	if (ses.authstate.pw_shell[0] == '\0') {
-		usershell = "/bin/sh";
-	} else {
-		usershell = ses.authstate.pw_shell;
-	}
-
 	/* set env vars */
 	addnewvar("USER", ses.authstate.pw_name);
 	addnewvar("LOGNAME", ses.authstate.pw_name);
 	addnewvar("HOME", ses.authstate.pw_dir);
-	addnewvar("SHELL", usershell);
+	addnewvar("SHELL", get_user_shell());
+	addnewvar("PATH", DEFAULT_PATH);
 	if (chansess->term != NULL) {
 		addnewvar("TERM", chansess->term);
 	}
@@ -963,32 +897,8 @@
 	agentset(chansess);
 #endif
 
-	/* Re-enable SIGPIPE for the executed process */
-	if (signal(SIGPIPE, SIG_DFL) == SIG_ERR) {
-		dropbear_exit("signal() error");
-	}
-
-	baseshell = basename(usershell);
-
-	if (chansess->cmd != NULL) {
-		argv[0] = baseshell;
-	} else {
-		/* a login shell should be "-bash" for "/bin/bash" etc */
-		int len = strlen(baseshell) + 2; /* 2 for "-" */
-		argv[0] = (char*)m_malloc(len);
-		snprintf(argv[0], len, "-%s", baseshell);
-	}
-
-	if (chansess->cmd != NULL) {
-		argv[1] = "-c";
-		argv[2] = chansess->cmd;
-		argv[3] = NULL;
-	} else {
-		/* construct a shell of the form "-bash" etc */
-		argv[1] = NULL;
-	}
-
-	execv(usershell, argv);
+	usershell = m_strdup(get_user_shell());
+	run_shell_command(chansess->cmd, ses.maxfd, usershell);
 
 	/* only reached on error */
 	dropbear_exit("child failed");

=== modified file 'svr-main.c'
--- svr-main.c	2008-03-27 20:08:06 +0000
+++ svr-main.c	2008-11-19 20:58:59 +0000
@@ -266,7 +266,11 @@
 				goto out;
 			}
 
+#ifdef DEBUG_NOFORK
+			fork_ret = 0;
+#else
 			fork_ret = fork();
+#endif
 			if (fork_ret < 0) {
 				dropbear_log(LOG_WARNING, "error forking: %s", strerror(errno));
 				goto out;
@@ -292,9 +296,11 @@
 				addrstring = getaddrstring(&remoteaddr, 1);
 				dropbear_log(LOG_INFO, "Child connection from %s", addrstring);
 
+#ifndef DEBUG_NOFORK
 				if (setsid() < 0) {
 					dropbear_exit("setsid: %s", strerror(errno));
 				}
+#endif
 
 				/* make sure we close sockets */
 				for (i = 0; i < listensockcount; i++) {

=== modified file 'svr-runopts.c'
--- svr-runopts.c	2008-03-27 20:08:06 +0000
+++ svr-runopts.c	2008-11-19 20:58:59 +0000
@@ -82,8 +82,9 @@
 #endif
 					"-W <receive_window_buffer> (default %d, larger may be faster, max 1MB)\n"
 					"-K <keepalive>  (0 is never, default %d)\n"
+					"-I <idle_timeout>  (0 is never, default %d)\n"
 #ifdef DEBUG_TRACE
-					"-v		verbose\n"
+					"-v		verbose (compiled with DEBUG_TRACE)\n"
 #endif
 					,DROPBEAR_VERSION, progname,
 #ifdef DROPBEAR_DSS
@@ -93,7 +94,7 @@
 					RSA_PRIV_FILENAME,
 #endif
 					DROPBEAR_MAX_PORTS, DROPBEAR_DEFPORT, DROPBEAR_PIDFILE,
-					DEFAULT_RECV_WINDOW, DEFAULT_KEEPALIVE);
+					DEFAULT_RECV_WINDOW, DEFAULT_KEEPALIVE, DEFAULT_IDLE_TIMEOUT);
 }
 
 void svr_getopts(int argc, char ** argv) {
@@ -103,6 +104,7 @@
 	int nextisport = 0;
 	char* recv_window_arg = NULL;
 	char* keepalive_arg = NULL;
+	char* idle_timeout_arg = NULL;
 
 	/* see printhelp() for options */
 	svr_opts.rsakeyfile = NULL;
@@ -134,7 +136,8 @@
 	svr_opts.usingsyslog = 1;
 #endif
 	opts.recv_window = DEFAULT_RECV_WINDOW;
-	opts.keepalive_secs = DEFAULT_KEEPALIVE;	
+	opts.keepalive_secs = DEFAULT_KEEPALIVE;
+	opts.idle_timeout_secs = DEFAULT_IDLE_TIMEOUT;
 	
 #ifdef ENABLE_SVR_REMOTETCPFWD
 	opts.listen_fwd_all = 0;
@@ -218,6 +221,9 @@
 				case 'K':
 					next = &keepalive_arg;
 					break;
+				case 'I':
+					next = &idle_timeout_arg;
+					break;
 #if defined(ENABLE_SVR_PASSWORD_AUTH) || defined(ENABLE_SVR_PAM_AUTH)
 				case 's':
 					svr_opts.noauthpass = 1;
@@ -253,7 +259,7 @@
 		svr_opts.addresses[0] = m_strdup(DROPBEAR_DEFADDRESS);
 		svr_opts.portcount = 1;
 	}
-        
+
 	if (svr_opts.dsskeyfile == NULL) {
 		svr_opts.dsskeyfile = DSS_PRIV_FILENAME;
 	}
@@ -284,19 +290,22 @@
 	
 	if (recv_window_arg) {
 		opts.recv_window = atol(recv_window_arg);
-		if (opts.recv_window == 0 || opts.recv_window > MAX_RECV_WINDOW)
-		{
+		if (opts.recv_window == 0 || opts.recv_window > MAX_RECV_WINDOW) {
 			dropbear_exit("Bad recv window '%s'", recv_window_arg);
 		}
 	}
 	
 	if (keepalive_arg) {
-		opts.keepalive_secs = strtoul(keepalive_arg, NULL, 10);
-		if (opts.keepalive_secs == 0 && errno == EINVAL)
-		{
+		if (m_str_to_uint(keepalive_arg, &opts.keepalive_secs) == DROPBEAR_FAILURE) {
 			dropbear_exit("Bad keepalive '%s'", keepalive_arg);
 		}
 	}
+
+	if (idle_timeout_arg) {
+		if (m_str_to_uint(idle_timeout_arg, &opts.idle_timeout_secs) == DROPBEAR_FAILURE) {
+			dropbear_exit("Bad idle_timeout '%s'", idle_timeout_arg);
+		}
+	}
 }
 
 static void addportandaddress(char* spec) {

=== modified file 'svr-session.c'
--- svr-session.c	2008-03-27 20:08:06 +0000
+++ svr-session.c	2008-11-19 20:58:59 +0000
@@ -80,7 +80,7 @@
     reseedrandom();
 
 	crypto_init();
-	common_session_init(sock, remotehost);
+	common_session_init(sock, sock, remotehost);
 
 	/* Initialise server specific parts of the session */
 	svr_ses.childpipe = childpipe;
@@ -144,6 +144,9 @@
 
 	_dropbear_log(LOG_INFO, fmtbuf, param);
 
+	/* free potential public key options */
+	svr_pubkey_options_cleanup();
+
 	/* must be after we've done with username etc */
 	common_session_cleanup();
 
@@ -183,7 +186,7 @@
 						localtime(&timesec)) == 0)
 		{
 			/* upon failure, just print the epoch-seconds time. */
-			snprintf(datestr, sizeof(datestr), "%d", timesec);
+			snprintf(datestr, sizeof(datestr), "%d", (int)timesec);
 		}
 		fprintf(stderr, "[%d] %s %s\n", getpid(), datestr, printbuf);
 	}
@@ -192,8 +195,10 @@
 /* called when the remote side closes the connection */
 static void svr_remoteclosed() {
 
-	close(ses.sock);
-	ses.sock = -1;
+	m_close(ses.sock_in);
+	m_close(ses.sock_out);
+	ses.sock_in = -1;
+	ses.sock_out = -1;
 	dropbear_close("Exited normally");
 
 }

=== modified file 'svr-tcpfwd.c'
--- svr-tcpfwd.c	2008-03-27 20:08:06 +0000
+++ svr-tcpfwd.c	2008-11-19 20:58:59 +0000
@@ -32,6 +32,7 @@
 #include "packet.h"
 #include "listener.h"
 #include "runopts.h"
+#include "auth.h"
 
 #ifdef ENABLE_SVR_REMOTETCPFWD
 
@@ -72,7 +73,7 @@
 
 	TRACE(("enter recv_msg_global_request_remotetcp"))
 
-	if (svr_opts.noremotetcp) {
+	if (svr_opts.noremotetcp || !svr_pubkey_allows_tcpfwd()) {
 		TRACE(("leave recv_msg_global_request_remotetcp: remote tcp forwarding disabled"))
 		goto out;
 	}
@@ -236,7 +237,7 @@
 	int len;
 	int err = SSH_OPEN_ADMINISTRATIVELY_PROHIBITED;
 
-	if (svr_opts.nolocaltcp) {
+	if (svr_opts.nolocaltcp || !svr_pubkey_allows_tcpfwd()) {
 		TRACE(("leave newtcpdirect: local tcp forwarding disabled"))
 		goto out;
 	}

=== modified file 'svr-x11fwd.c'
--- svr-x11fwd.c	2006-04-16 16:16:40 +0000
+++ svr-x11fwd.c	2008-11-19 20:58:59 +0000
@@ -33,6 +33,7 @@
 #include "channel.h"
 #include "packet.h"
 #include "buffer.h"
+#include "auth.h"
 
 #define X11BASEPORT 6000
 #define X11BINDBASE 6010
@@ -47,6 +48,10 @@
 
 	int fd;
 
+	if (!svr_pubkey_allows_x11fwd()) {
+		return DROPBEAR_FAILURE;
+	}
+
 	/* we already have an x11 connection */
 	if (chansess->x11listener != NULL) {
 		return DROPBEAR_FAILURE;

=== added file 'sysoptions.h'
--- sysoptions.h	1970-01-01 00:00:00 +0000
+++ sysoptions.h	2008-11-19 20:58:59 +0000
@@ -0,0 +1,206 @@
+/*******************************************************************
+ * You shouldn't edit this file unless you know you need to. 
+ * This file is only included from options.h
+ *******************************************************************/
+
+#ifndef DROPBEAR_VERSION
+#define DROPBEAR_VERSION "0.52"
+#endif
+
+#define LOCAL_IDENT "SSH-2.0-dropbear_" DROPBEAR_VERSION
+#define PROGNAME "dropbear"
+
+/* Spec recommends after one hour or 1 gigabyte of data. One hour
+ * is a bit too verbose, so we try 8 hours */
+#ifndef KEX_REKEY_TIMEOUT
+#define KEX_REKEY_TIMEOUT (3600 * 8)
+#endif
+#ifndef KEX_REKEY_DATA
+#define KEX_REKEY_DATA (1<<30) /* 2^30 == 1GB, this value must be < INT_MAX */
+#endif
+/* Close connections to clients which haven't authorised after AUTH_TIMEOUT */
+#ifndef AUTH_TIMEOUT
+#define AUTH_TIMEOUT 300 /* we choose 5 minutes */
+#endif
+
+/* Minimum key sizes for DSS and RSA */
+#ifndef MIN_DSS_KEYLEN
+#define MIN_DSS_KEYLEN 512
+#endif
+#ifndef MIN_RSA_KEYLEN
+#define MIN_RSA_KEYLEN 512
+#endif
+
+#define MAX_BANNER_SIZE 2000 /* this is 25*80 chars, any more is foolish */
+#define MAX_BANNER_LINES 20 /* How many lines the client will display */
+
+/* the number of NAME=VALUE pairs to malloc for environ, if we don't have
+ * the clearenv() function */
+#define ENV_SIZE 100
+
+#define MAX_CMD_LEN 1024 /* max length of a command */
+#define MAX_TERM_LEN 200 /* max length of TERM name */
+
+#define MAX_HOST_LEN 254 /* max hostname len for tcp fwding */
+#define MAX_IP_LEN 15 /* strlen("255.255.255.255") == 15 */
+
+#define DROPBEAR_MAX_PORTS 10 /* max number of ports which can be specified,
+								 ipv4 and ipv6 don't count twice */
+
+/* Each port might have at least a v4 and a v6 address */
+#define MAX_LISTEN_ADDR (DROPBEAR_MAX_PORTS*3)
+
+#define _PATH_TTY "/dev/tty"
+
+#define _PATH_CP "/bin/cp"
+
+/* success/failure defines */
+#define DROPBEAR_SUCCESS 0
+#define DROPBEAR_FAILURE -1
+
+/* various algorithm identifiers */
+#define DROPBEAR_KEX_DH_GROUP1 0
+
+#define DROPBEAR_SIGNKEY_ANY 0
+#define DROPBEAR_SIGNKEY_RSA 1
+#define DROPBEAR_SIGNKEY_DSS 2
+#define DROPBEAR_SIGNKEY_NONE 3
+
+#define DROPBEAR_COMP_NONE 0
+#define DROPBEAR_COMP_ZLIB 1
+#define DROPBEAR_COMP_ZLIB_DELAY 2
+
+/* Required for pubkey auth */
+#if defined(ENABLE_SVR_PUBKEY_AUTH) || defined(DROPBEAR_CLIENT)
+#define DROPBEAR_SIGNKEY_VERIFY
+#endif
+
+/* SHA1 is 20 bytes == 160 bits */
+#define SHA1_HASH_SIZE 20
+/* SHA512 is 64 bytes == 512 bits */
+#define SHA512_HASH_SIZE 64
+/* MD5 is 16 bytes = 128 bits */
+#define MD5_HASH_SIZE 16
+
+/* largest of MD5 and SHA1 */
+#define MAX_MAC_LEN SHA1_HASH_SIZE
+
+
+#define MAX_KEY_LEN 32 /* 256 bits for aes256 etc */
+#define MAX_IV_LEN 20 /* must be same as max blocksize, 
+						 and >= SHA1_HASH_SIZE */
+#define MAX_MAC_KEY 20
+
+#define MAX_NAME_LEN 64 /* maximum length of a protocol name, isn't
+						   explicitly specified for all protocols (just
+						   for algos) but seems valid */
+
+#define MAX_PROPOSED_ALGO 20
+
+/* size/count limits */
+#define MIN_PACKET_LEN 16
+
+#define RECV_MAX_PACKET_LEN (MAX(35000, ((RECV_MAX_PAYLOAD_LEN)+100)))
+
+/* for channel code */
+#define TRANS_MAX_WINDOW 500000000 /* 500MB is sufficient, stopping overflow */
+#define TRANS_MAX_WIN_INCR 500000000 /* overflow prevention */
+
+#define RECV_WINDOWEXTEND (opts.recv_window / 3) /* We send a "window extend" every
+								RECV_WINDOWEXTEND bytes */
+#define MAX_RECV_WINDOW (1024*1024) /* 1 MB should be enough */
+
+#define MAX_CHANNELS 100 /* simple mem restriction, includes each tcp/x11
+							connection, so can't be _too_ small */
+
+#define MAX_STRING_LEN 1400 /* ~= MAX_PROPOSED_ALGO * MAX_NAME_LEN, also
+							   is the max length for a password etc */
+
+/* For a 4096 bit DSS key, empirically determined */
+#define MAX_PUBKEY_SIZE 1700
+/* For a 4096 bit DSS key, empirically determined */
+#define MAX_PRIVKEY_SIZE 1700
+
+/* The maximum size of the bignum portion of the kexhash buffer */
+/* Sect. 8 of the transport draft, K_S + e + f + K */
+#define KEXHASHBUF_MAX_INTS (1700 + 130 + 130 + 130)
+
+#define DROPBEAR_MAX_SOCKS 2 /* IPv4, IPv6 are all we'll get for now. Revisit
+								in a few years time.... */
+
+#define DROPBEAR_MAX_CLI_PASS 1024
+
+#define DROPBEAR_MAX_CLI_INTERACT_PROMPTS 80 /* The number of prompts we'll 
+												accept for keyb-interactive
+												auth */
+
+#if defined(DROPBEAR_AES256) || defined(DROPBEAR_AES128)
+#define DROPBEAR_AES
+#endif
+
+#if defined(DROPBEAR_TWOFISH256) || defined(DROPBEAR_TWOFISH128)
+#define DROPBEAR_TWOFISH
+#endif
+
+#ifndef ENABLE_X11FWD
+#define DISABLE_X11FWD
+#endif
+
+#ifndef ENABLE_AGENTFWD
+#define DISABLE_AGENTFWD
+#endif
+
+#if defined(ENABLE_CLI_REMOTETCPFWD) || defined(ENABLE_CLI_LOCALTCPFWD)
+#define ENABLE_CLI_ANYTCPFWD 
+#endif
+
+#if defined(ENABLE_CLI_LOCALTCPFWD) || defined(ENABLE_SVR_REMOTETCPFWD)
+#define DROPBEAR_TCP_ACCEPT
+#endif
+
+#if defined(ENABLE_CLI_REMOTETCPFWD) || defined(ENABLE_CLI_LOCALTCPFWD) || \
+	defined(ENABLE_SVR_REMOTETCPFWD) || defined(ENABLE_SVR_LOCALTCPFWD) || \
+	defined(ENABLE_AGENTFWD) || defined(ENABLE_X11FWD)
+#define USING_LISTENERS
+#endif
+
+#if defined(ENABLE_CLI_NETCAT) && defined(ENABLE_CLI_PROXYCMD)
+#define ENABLE_CLI_MULTIHOP
+#endif
+
+#if defined(DROPBEAR_CLIENT) || defined(ENABLE_SVR_PUBKEY_AUTH)
+#define DROPBEAR_KEY_LINES /* ie we're using authorized_keys or known_hosts */
+#endif
+
+#if defined(ENABLE_SVR_PASSWORD_AUTH) && defined(ENABLE_SVR_PAM_AUTH)
+#error "You can't turn on PASSWORD and PAM auth both at once. Fix it in options.h"
+#endif
+
+#if defined(DROPBEAR_RANDOM_DEV) && defined(DROPBEAR_PRNGD_SOCKET)
+#error "You can't turn on DROPBEAR_PRNGD_SOCKET and DROPBEAR_RANDOM_DEV at once"
+#endif
+
+#if !defined(DROPBEAR_RANDOM_DEV) && !defined(DROPBEAR_PRNGD_SOCKET)
+#error "You must choose one of DROPBEAR_PRNGD_SOCKET or DROPBEAR_RANDOM_DEV in options.h"
+#endif
+
+/* We use dropbear_client and dropbear_server as shortcuts to avoid redundant
+ * code, if we're just compiling as client or server */
+#if defined(DROPBEAR_SERVER) && defined(DROPBEAR_CLIENT)
+
+#define IS_DROPBEAR_SERVER (ses.isserver == 1)
+#define IS_DROPBEAR_CLIENT (ses.isserver == 0)
+
+#elif defined(DROPBEAR_SERVER)
+
+#define IS_DROPBEAR_SERVER 1
+#define IS_DROPBEAR_CLIENT 0
+
+#elif defined(DROPBEAR_CLIENT)
+
+#define IS_DROPBEAR_SERVER 0
+#define IS_DROPBEAR_CLIENT 1
+
+#else
+#error You must compiled with either DROPBEAR_CLIENT or DROPBEAR_SERVER selected
+#endif

=== modified file 'tcpfwd.h'
--- tcpfwd.h	2006-04-16 16:16:40 +0000
+++ tcpfwd.h	2008-11-19 20:58:59 +0000
@@ -49,18 +49,23 @@
 	const unsigned char* connectaddr;
 	unsigned int connectport;
 	unsigned int listenport;
+	unsigned int have_reply; /* is set to 1 after a reply has been received
+								when setting up the forwarding */
 	struct TCPFwdList * next;
 
 };
 
 /* Server */
 void recv_msg_global_request_remotetcp();
+
 extern const struct ChanType svr_chan_tcpdirect;
 
 /* Client */
 void setup_localtcp();
 void setup_remotetcp();
 extern const struct ChanType cli_chan_tcpremote;
+void cli_recv_msg_request_success();
+void cli_recv_msg_request_failure();
 
 /* Common */
 int listen_tcpfwd(struct TCPListener* tcpinfo);

